using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Diagnostics;
using System.ServiceProcess;
using System.Text;
using System.Timers;
using System.IO;
using System.Configuration;
using System.Collections;
using System.Data.SqlClient;
using System.Threading;
using System.Globalization;
using System.Runtime.InteropServices;
using System.Data.OleDb;
using CMITech.UMXClient;
using CMITech.UMXClient.Events;
using CMITech.UMXClient.Entities;
using System.Reflection;
/**************************************************************************************************************************************************
* Project Name    : TimeCheck                  Started       : 14-June-2007
* Module          : Windows Service            Last Modified : 01-Apr-2008
* Programmer      : Kumuthini.L
* Current Storage : D:\Projects\Inprogress\SCREEN1206\code\WindowsService\WS_Jan02\CollectRawData\TimecheckCollectRawData\TimecheckCollectRawData
* BackUp          :
***************************************************************************************************************************************************/
namespace TimecheckCollectRawData
{
    public partial class TimecheckCollectDataService : ServiceBase
    {
        #region Variable Declaration
        DataFunction objDatafunction = new DataFunction();
        DataTable dtTerminalDataType, gdtShift, gdtShiftSettings;
        private static CallBack myCallBack;
        public System.Timers.Timer timer;
        string strOldPunchTypeRemarksId = string.Empty;
        string strPunchTypeRemarksId = string.Empty;
        int RecordFromClockdetails = 0;
        Int64 gintTimerInterval = 0;
        string gstrClockDate = string.Empty;
        string gstrDataOutFile, gstrCompanyId;
        string gstrWeeklyOffDate = string.Empty;
        string gstrNextDayIsWeeklyOff = string.Empty;
        string gstrPreviousShiftStartTime = string.Empty;
        string gstrPreviousShiftEndTime = string.Empty;
        DateTime gdtmPreviousShiftStartTime = new DateTime();
        DateTime gdtmPreviousShiftEndTime = new DateTime();
        string gstrCurrentShiftStartTime = string.Empty;
        string gstrCurrentShiftEndTime = string.Empty;
        DateTime gdtmCurrentShiftStartTime = new DateTime();
        DateTime gdtmCurrentShiftEndTime = new DateTime();
        string gstrNextShiftStartTime = string.Empty;
        string gstrNextShiftEndTime = string.Empty;
        DateTime gdtmNextShiftStartTime = new DateTime();
        DateTime gdtmNextShiftEndTime = new DateTime();
        string gstrPunchInterval = string.Empty;
        int gintShiftId = 0, gintCompanyId = 0, gintNextDayShiftId = 0, gintWeeklyOffShiftCount = 0;
        TimeSpan tsMaxHoursNextDayIsWeeklyOff = new TimeSpan();
        string strClk_Status = string.Empty;
        TimeSpan tsWeeklyOffStartHours_24HrsShift = new TimeSpan();
        bool IsPreviousShift_24Hours = false;
        bool IsCurrentShift_24Hours = false;
        bool IsNextShift_24Hours = false;
        static CultureInfo CI;
        string PackageVersion = string.Empty;
        string[] strPackageID; //auto shift config point for vaigai client
        string strIsAutoShiftEmployee = string.Empty; //auto shift config point for vaigai client
        //CMI Tech Iris device - variables.
        private string m_selectedDevice = null;
        private Dictionary<string, Client> m_clients = null;
        #endregion
        #region TimecheckCollectDataService
        public TimecheckCollectDataService()
        {
            InitializeComponent();
            if (System.Configuration.ConfigurationManager.AppSettings["TimerInterval"].ToString() != string.Empty)
            {
                gintTimerInterval = Convert.ToInt64(System.Configuration.ConfigurationManager.AppSettings["TimerInterval"].ToString());
            }
            else
            {
                gintTimerInterval = 180000;
            }
            timer = new System.Timers.Timer(gintTimerInterval);
            timer.Elapsed += new ElapsedEventHandler(timer_Elapsed);
            if (!System.Diagnostics.EventLog.SourceExists("TC3.2.0CollectRawDataLogSource"))
                System.Diagnostics.EventLog.CreateEventSource("TC3.2.0CollectRawDataLogSource", "TC3.2.0CollectRawDataLog");
            eventLog1.Source = "TC3.2.0CollectRawDataLogSource";
            eventLog1.Log = "TC3.2.0CollectRawDataLog";
        }
        #endregion
        #region OnStart
        protected override void OnStart(string[] args)
        {
            timer.Start();
        }
        #endregion
        #region OnStop
        protected override void OnStop()
        {
            timer.Stop();
        }
        #endregion
        #region timer_Elapsed
        private void timer_Elapsed(object source, ElapsedEventArgs e)
        {
            timer.Stop();
            CI = new CultureInfo("en-us");
            CI.DateTimeFormat.ShortDatePattern = "MM/dd/yyyy";
            CI.DateTimeFormat.LongDatePattern = "MM/dd/yyyy";
            CI.DateTimeFormat.ShortTimePattern = "HH:mm:ss";
            CI.DateTimeFormat.LongTimePattern = "HH:mm:ss";
            System.Threading.Thread.CurrentThread.CurrentCulture = CI;
            try
            {
                DataTable dtLic = new DataTable();
                dtLic = objDatafunction.ExecuteQuery("Proc_TA_SelectTA_Tbl_LIC_Details_Service", "TA_Tbl_LIC_Details");
                if (dtLic.Rows.Count > 0)
                {
                    string ExpDate = string.Empty;
                    ExpDate = Convert.ToString(dtLic.Rows[0]["ExpiryDate"]);
                    ExpDate = Cryptographys.Cryptography.Decrypt_BioStar(ExpDate, "");
                    PackageVersion = Cryptographys.Cryptography.Decrypt(Convert.ToString(dtLic.Rows[0]["PackageVersion"]));
                    strPackageID = PackageVersion.Split('.');
                    if (Convert.ToDateTime(ExpDate, CI).AddHours(23).AddMinutes(59) > Convert.ToDateTime(Convert.ToString(DateTime.Now, CI)))
                        Process();
                    else
                        WriteErrorToEventLog("License was expired", "License was expired. Purchase New license." + DateTime.Now.ToString());
                }
                else
                    Process();
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "timer_Elapsed() ; Error : " + ex.ToString());
            }
            finally
            {
                timer.Start();
            }
        }
        #endregion
        #region Process
        public void Process()
        {
            try
            {
                //Get Shifts of all the companies
                ShiftsAllCompanies();
                //Get Shift Settings of All Companies
                ShiftSettingsAllCompanies();
                // Collects the Data from the External Files
                //CollectDataFromPostgre();
                CollectData();
                // Matches IN and OUT
                ClockDetails();
                // Collects the Raw Data from the Timecheck Manual Time Entry
                ManualTimeEntry();
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "Process() ; Error : " + ex.ToString());
            }
        }
        #endregion
        #region ShiftsAllCompanies
        /// <summary>
        /// Getting all companies shift details
        /// </summary>
        public void ShiftsAllCompanies()
        {
            try
            {
                gdtShift = objDatafunction.ExecuteQuery("Proc_TA_GetShiftDetailsOfAllCompanies", "ShiftsAllCompanies");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "ShiftsAllCompanies(); Error : " + ex.Message.ToString());
            }
        }
        #endregion
        #region ShiftSettingsAllCompanies
        /// <summary>
        /// Getting all companies shift setting details
        /// </summary>
        public void ShiftSettingsAllCompanies()
        {
            try
            {
                gdtShiftSettings = objDatafunction.ExecuteQuery("Proc_TA_GettingShiftSettingDetailsOfAllCompanies", "ShiftSettingsAllCompanies");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "ShiftSettingsAllCompanies(); Error : " + ex.Message.ToString());
            }
        }
        #endregion
        #region CollectDataFromPostgre
        public void CollectDataFromPostgre()
        {
            try
            {
                DataTable dtRdbmsRawData = new DataTable();
                DataTable dtPostgreDetails = new DataTable();
                string strConnectionString = string.Empty;
                DateTime dtmDateTime = new DateTime();
                string strDate = string.Empty, strTime = string.Empty;
                string strTableName = string.Empty, strColReaderNo = string.Empty;
                string strColCardNo = string.Empty, strColDateTime = string.Empty, strColDate = string.Empty;
                string strColTime = string.Empty, strnIndex = string.Empty, strColType = string.Empty;
                CI.DateTimeFormat.ShortTimePattern = "hh:mm tt";
                CI.DateTimeFormat.LongTimePattern = "hh:mm tt";
                //dtPostgreDetails = GettingDeviceDataBaseDetails(intTerminalID, inFileType); //use when add in product
                //if (dtPostgreDetails.Rows.Count > 0)
                //{
                //    if (dtPostgreDetails.Rows[0]["ConnectionString"] != DBNull.Value)
                //    {
                //        char[] split = { ';' };
                //        string sptChr = Convert.ToString(dtPostgreDetails.Rows[0]["ConnectionString"]);
                //        if (sptChr != "")
                //        {
                //            string[] strFilters = sptChr.Split(split);
                //            if (strFilters.Length > 1)
                //            {
                //                strConnectionString = Convert.ToString(dtPostgreDetails.Rows[0]["ConnectionString"]);
                //            }
                //            else
                //            {
                //                strConnectionString = Cryptographys.Cryptography.Decrypt_BioStar(Convert.ToString(dtPostgreDetails.Rows[0]["ConnectionString"]), "");
                //                Console.Write(strConnectionString);
                //            }
                //        }
                //    }
                //}
                strConnectionString = Convert.ToString(ConfigurationSettings.AppSettings["PostgreSQL_ConnectionString"]);
                if (strConnectionString != null && strConnectionString != "")
                {
                    strColCardNo = "nuserid";
                    strColReaderNo = "ndeviceid";
                    strColDateTime = "dtdatetime";
                    strnIndex = "nindex";
                    strColType = "ntnaevent";
                    string strCmd = "SELECT nindex, nevent, ndeviceid, nuserid, dtdatetime, ntnaevent, susername from tb_reportslist WHERE susername is null ";
                    dtRdbmsRawData = objDatafunction.GetDataFromPostgresql(strConnectionString, strCmd);
                    #region Processing1000Records
                    try
                    {
                        foreach (DataRow drRdbmsRawData in dtRdbmsRawData.Rows)
                        {
                            if ((drRdbmsRawData[strColReaderNo] != DBNull.Value) && (drRdbmsRawData[strColCardNo] != DBNull.Value) && (drRdbmsRawData[strColType] != DBNull.Value) && (Convert.ToString(drRdbmsRawData[strColReaderNo]) != string.Empty) && (Convert.ToString(drRdbmsRawData[strColCardNo]) != string.Empty) && (Convert.ToString(drRdbmsRawData[strColType]) != string.Empty))
                            {
                                if (drRdbmsRawData["dtdatetime"] != DBNull.Value && Convert.ToString(drRdbmsRawData[strColDateTime]) != string.Empty && Convert.ToString(drRdbmsRawData[strColDateTime]) != "0")
                                {
                                    dtmDateTime = DateTime.Parse(Convert.ToString(drRdbmsRawData[strColDateTime]), CI);
                                    strDate = dtmDateTime.ToShortDateString();
                                    strTime = dtmDateTime.ToShortTimeString();
                                }
                            }
                            #region InsertRawData
                            string strType = string.Empty, strPunchType = string.Empty;
                            try
                            {
                                if (drRdbmsRawData[strColCardNo] != DBNull.Value && drRdbmsRawData[strColReaderNo] != DBNull.Value && drRdbmsRawData[strColType] != DBNull.Value && strDate != string.Empty && strDate != "0" && strTime != string.Empty && strTime != "0")
                                {
                                    strType = Convert.ToString(drRdbmsRawData[strColType]);
                                    // Function key logic punch types
                                    switch (strType)
                                    {
                                        case "0":
                                        case "1":
                                        case "2":
                                        case "3":
                                        case "4":
                                        case "5":
                                        case "6":
                                        case "7":
                                        case "8":
                                        case "9":
                                        case "10":
                                        case "11":
                                        case "12":
                                        case "13":
                                        case "14":
                                        case "15":
                                            strPunchType = strType;
                                            break;
                                        default:
                                            strPunchType = Convert.ToString(drRdbmsRawData[strColReaderNo]);
                                            break;
                                    }
                                    InsertRawDataDetails(Convert.ToString(drRdbmsRawData[strColCardNo]),
                                        Convert.ToString(drRdbmsRawData[strColReaderNo]),
                                        Convert.ToString(DateTime.Parse(strDate, CI)),
                                        Convert.ToString(strTime),
                                        Convert.ToString(strPunchType));
                                }
                                #region UpdateFlagInDeviceDB
                                if (strConnectionString != string.Empty)
                                {
                                    try
                                    {
                                        string strupdateCmd = "Update tb_reportslist set susername = '1' where nindex = " + Convert.ToInt32(drRdbmsRawData[strnIndex]) + " ";
                                        objDatafunction.UpdateFlagInDevicePostgreDatabase(strConnectionString, strupdateCmd);
                                    }
                                    catch (Exception ex)
                                    {
                                        WriteErrorToEventLog("Collect Rawdata", "UpdateFlagInDevicePostgreDatabase(); Error : " + ex.Message.ToString());
                                    }
                                }
                                #endregion
                            }
                            #endregion
                            catch (Exception ex)
                            {
                                WriteErrorToEventLog("Collect Rawdata", "getdataFromPostgre(); Error : " + ex.Message.ToString());
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        WriteErrorToEventLog("Collect Rawdata", "getdataFromPostgre(); Error : " + ex.Message.ToString());
                    }
                    #endregion
                }
                else
                {
                    WriteErrorToEventLog("Collect Rawdata", "getdataFromPostgre(); Error : strConnectionString" + strConnectionString.ToString());
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("Collect Rawdata", "getdataFromPostgre(); Error : " + ex.Message.ToString());
            }
        }
        #endregion
        #region GetLogsFromMariaDB
        public void CollectLogsFrmMariadb()
        {
            try
            {
                int currentMonth;
                int currentYear;
                currentMonth = Convert.ToInt16(DateTime.Now.Month);
                currentYear = Convert.ToInt16(DateTime.Now.Year);
                string tableName = string.Empty;
                DataTable dtRDBMSDetails = new DataTable();
                DataTable dtRdbmsRawData = new DataTable();
                for (int i = 5; i >= 0; i--)
                {
                    if (currentMonth == 0)
                    {
                        currentYear = Convert.ToInt16(currentYear) - 1;
                        currentMonth = 12;
                    }
                    if (Convert.ToString(currentMonth).Length == 1)
                        tableName = "T_LG" + currentYear + "0" + currentMonth;
                    else
                        tableName = "T_LG" + currentYear + currentMonth;
                    string strConnectionString = "";
                    strConnectionString = Convert.ToString(ConfigurationSettings.AppSettings["mariaDb"]);
                    string strSQL = "";
                    string tableExistsScript = "";
                    string tableexistvalue = "";
                    tableExistsScript = "select table_name from information_schema.tables where table_name = '" + tableName + "'";
                    objDatafunction.InitializeMySQLConnection(strConnectionString);
                    tableexistvalue = objDatafunction.getTableExists(tableExistsScript);
                    if (tableexistvalue != null && tableexistvalue != "")
                    {
                        string columnexistsvalue = "";
                        string columnexists = "SELECT Column_name FROM information_schema.COLUMNS WHERE TABLE_NAME = '" + tableName + "' AND COLUMN_NAME = 'flag'";
                        columnexistsvalue = objDatafunction.getTableExists(columnexists);
                        if (columnexistsvalue == null || columnexistsvalue == "")
                        {
                            string alertQuery = "Alter table " + tableName + " add flag int";
                            objDatafunction.ExecuteMysqlcommand(alertQuery);
                        }
                        strSQL = "SELECT DEVDT,USRID,TNAKEY,DEVUID,EVT,EVTLGUID FROM " + tableName + " where (flag is null or flag=0) and TNAKEY in ('0','1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16','255')";
                        if (strSQL != string.Empty && strConnectionString != string.Empty)
                        {
                            try
                            {
                                dtRdbmsRawData = objDatafunction.mysqlrdbmsExecuteQuery(strSQL, "biostarTables");
                                foreach (DataRow drRdbmsRawData in dtRdbmsRawData.Rows)
                                {
                                    InsertMariaLogsInToReportsList(Convert.ToString(drRdbmsRawData[0]), Convert.ToString(drRdbmsRawData[1]), Convert.ToString(drRdbmsRawData[2]), Convert.ToString(drRdbmsRawData[3]), Convert.ToString(drRdbmsRawData[4]));
                                    if (strConnectionString != string.Empty)
                                    {
                                        objDatafunction.InitializeMySQLConnection(strConnectionString);
                                        string alertQuery = "update " + tableName + " set flag=1 where EVTLGUID=" + Convert.ToString(drRdbmsRawData[5]);
                                        objDatafunction.ExecuteMysqlcommand(alertQuery);
                                    }
                                }
                            }
                            catch
                            {
                            }
                        }
                    }
                    currentMonth -= 1;
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectMariaDB", ex.ToString());
            }
        }
        #endregion
        #region CollectData
        /// <summary>
        ///  Purpose :
        ///     The CollectData Method is used to collect the Raw Data from different File Types(i.e., TextFiles, MDB, RDBMS, etc)
        ///     and insert the Raw Data into the TimeCheck Raw Data Table.
        /// </summary>
        public void CollectData()
        {
            try
            {
                dtTerminalDataType = new DataTable();
                dtTerminalDataType = objDatafunction.ExecuteQuery("Proc_Ta_GettingAllTerminalDataTypeDetails", "TA_Tbl_TerminalDatatype");
                foreach (DataRow drTerminalDataType in dtTerminalDataType.Rows)
                {
                    if (drTerminalDataType["FileType"] != DBNull.Value)
                    {
                        string fileType = string.Empty;
                        if (Convert.ToString(drTerminalDataType["FileType"]) != "")
                            fileType = Convert.ToString(drTerminalDataType["FileType"]);
                        // If FileType is RDBMS
                        switch (fileType)
                        {
                            case "RDBMS":
                            case "MariaDB":
                                //if (fileType == "MariaDB")
                                //{
                                //Biostar 2 support maria db.
                                //1.Below method will fetch the logs from device database and posted into timecheck reports list table
                                //2.Configure the Timecheck database into terminal master. 
                                //3.Then update the filetype as mariaDb in terminal datatype table.
                                //4.Update the maria database userid and password in web config file of collect raw data service 
                                //after the installation and then start the service.
                                //CollectLogsFrmMariadb();
                                //}
                                //if (Convert.ToString(drTerminalDataType["KeyValue"]) == "Iris EF-45 device")
                                //{
                                //    getIrisDeviceLogs();
                                //}
                                CollectRBMSRawData(Convert.ToInt32(drTerminalDataType["TerminalDatatype_ID"]), fileType, Convert.ToString(drTerminalDataType["KeyValue"]));
                                break;
                            case "Fixed Length":
                            case "Delimiter":
                                CollectTextFileRawData(Convert.ToInt32(drTerminalDataType["TerminalDatatype_ID"]), fileType, Convert.ToString(drTerminalDataType["KeyValue"]));
                                break;
                            case "MDB":
                                CollectMDBRawData(Convert.ToInt32(drTerminalDataType["TerminalDatatype_ID"]), fileType, Convert.ToString(drTerminalDataType["KeyValue"]));
                                break;
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "CollectData(); Error : " + ex.ToString());
            }
        }
        #endregion
        #region CollectRBMSRawData
        /// <summary>
        /// Purpose :
        ///     The CollectRBMSRawData Method is used to get the Raw Data from any RDBMS and inserts the Raw Data into the
        ///     TimeCheck Raw Data Table 
        /// </summary>
        /// <param name="intTerminalID"></param>
        /// <param name="inFileType"></param>
        /// <param name="strBrandName"></param>
        public void CollectRBMSRawData(int intTerminalID, string inFileType, string strBrandName)
        {
            #region RDBMSVariables
            DataTable dtRDBMSDetails = new DataTable();
            DataTable dtRdbmsRawData = new DataTable();
            DataTable dtEmployee = new DataTable();
            DataTable dtRawData = new DataTable();
            string strSQL = string.Empty;
            string strSQLHanvon = string.Empty;
            string strSQLMinMaxTime = string.Empty;
            string strSQLFileDetails = string.Empty;
            string strConnectionString = string.Empty, strTableName = string.Empty, strColReaderNo = string.Empty;
            string strColCardNo = string.Empty, strColDateTime = string.Empty, strColDate = string.Empty;
            string strColTime = string.Empty, strColType = string.Empty, strColFlag = string.Empty;
            string strColTransIdentifier = string.Empty, strTransIdentifierValue = string.Empty;
            DateTime dtmDateTime = new DateTime();
            string strDate = string.Empty, strTime = string.Empty;
            #endregion
            try
            {
                dtRDBMSDetails = GettingDeviceDataBaseDetails(intTerminalID, inFileType);
                if (dtRDBMSDetails.Rows.Count > 0)
                {
                    if (dtRDBMSDetails.Rows[0]["ConnectionString"] != DBNull.Value)
                    {
                        char[] split = { ';' };
                        string sptChr = Convert.ToString(dtRDBMSDetails.Rows[0]["ConnectionString"]);
                        if (sptChr != "")
                        {
                            if (strBrandName == "Iris EF-45 device")
                            {
                                strConnectionString = Cryptographys.Cryptography.Decrypt(Convert.ToString(dtRDBMSDetails.Rows[0]["ConnectionString"]), "TimecheckPhaseI");
                            }
                            else
                            {
                                string[] strFilters = sptChr.Split(split);
                                if (strFilters.Length > 1)
                                    strConnectionString = Convert.ToString(dtRDBMSDetails.Rows[0]["ConnectionString"]);
                                else
                                    strConnectionString = Cryptographys.Cryptography.Decrypt_BioStar(Convert.ToString(dtRDBMSDetails.Rows[0]["ConnectionString"]), "");
                            }
                        }
                    }
                    if (dtRDBMSDetails.Rows[0]["TableName"] != DBNull.Value)
                    {
                        strTableName = Convert.ToString(dtRDBMSDetails.Rows[0]["TableName"]);
                    }
                    if (dtRDBMSDetails.Rows[0]["RDBMS_ReaderNo"] != DBNull.Value)
                    {
                        strColReaderNo = Convert.ToString(dtRDBMSDetails.Rows[0]["RDBMS_ReaderNo"]);
                    }
                    if (dtRDBMSDetails.Rows[0]["RDBMS_CardNo"] != DBNull.Value)
                    {
                        strColCardNo = Convert.ToString(dtRDBMSDetails.Rows[0]["RDBMS_CardNo"]);
                    }
                    if (dtRDBMSDetails.Rows[0]["RDBMS_DateTimeBit"] != DBNull.Value)
                    {
                        if (Convert.ToString(dtRDBMSDetails.Rows[0]["RDBMS_DateTimeBit"]) == "True")
                        {
                            if (dtRDBMSDetails.Rows[0]["RDBMS_DateTime"] != DBNull.Value)
                            {
                                strColDateTime = Convert.ToString(dtRDBMSDetails.Rows[0]["RDBMS_DateTime"]);
                            }
                        }
                        else if (Convert.ToString(dtRDBMSDetails.Rows[0]["RDBMS_DateTimeBit"]) == "False")
                        {
                            if (dtRDBMSDetails.Rows[0]["RDBMS_Date"] != DBNull.Value && dtRDBMSDetails.Rows[0]["RDBMS_Time"] != DBNull.Value)
                            {
                                strColDate = Convert.ToString(dtRDBMSDetails.Rows[0]["RDBMS_Date"]);
                                strColTime = Convert.ToString(dtRDBMSDetails.Rows[0]["RDBMS_Time"]);
                            }
                        }
                    }
                    if (dtRDBMSDetails.Rows[0]["RDBMS_Type"] != DBNull.Value)
                    {
                        strColType = Convert.ToString(dtRDBMSDetails.Rows[0]["RDBMS_Type"]);
                    }
                    if (dtRDBMSDetails.Rows[0]["RDBMS_MDB_Flag"] != DBNull.Value)
                    {
                        strColFlag = Convert.ToString(dtRDBMSDetails.Rows[0]["RDBMS_MDB_Flag"]);
                    }
                    if (dtRDBMSDetails.Rows[0]["RDBMS_TransactionIdentifier"] != DBNull.Value)
                    {
                        strColTransIdentifier = Convert.ToString(dtRDBMSDetails.Rows[0]["RDBMS_TransactionIdentifier"]);
                    }
                    if (dtRDBMSDetails.Rows[0]["TransactionIdentifierValue"] != DBNull.Value)
                    {
                        strTransIdentifierValue = Convert.ToString(dtRDBMSDetails.Rows[0]["TransactionIdentifierValue"]);
                    }
                    #region OldMethods
                    //if ((strColDateTime != string.Empty) || (strColDate != string.Empty && strColTime != string.Empty))
                    //{
                    //    if (dtRDBMSDetails.Rows[0]["RDBMS_DateTimeBit"] != DBNull.Value)
                    //    {
                    //        #region For Hanvon FaceId
                    //        if (strBrandName == "Hanvon")
                    //        {
                    //            string devInfo, cmdStr, retStr;
                    //            DataTable dtMinMaxTime = new DataTable();
                    //            DataTable dtResult_Details = new DataTable();
                    //            DataRow drResult_Details;
                    //            dtResult_Details.Columns.Add("DeviceId");
                    //            dtResult_Details.Columns.Add("dtDateTime");
                    //            dtResult_Details.Columns.Add("EmployeeId");
                    //            dtResult_Details.Columns.Add("WorkCode");
                    //            retStr = "";
                    //            IntPtr ret = IntPtr.Zero;
                    //            uint retlen = 0;
                    //            strSQLMinMaxTime = "select KQZ_DevInfo.IPAddress,KQZ_DevInfo.DevID,KQZ_DevInfo.DevPwd,KQZ_DevInfo.ComPort,min(tb_reportslist.dtDateTime) as Min_DateTime,max(tb_reportslist.dtDateTime) as Max_DateTime,tb_reportslist.nDeviceID from tb_reportslist inner join KQZ_DevInfo on KQZ_DevInfo.DevID=tb_reportslist.nDeviceId where tb_reportslist.nTNAEvent is null group by KQZ_DevInfo.IPAddress,tb_reportslist.nDeviceID,KQZ_DevInfo.DevID,KQZ_DevInfo.DevPwd,KQZ_DevInfo.ComPort";
                    //            if (strSQLMinMaxTime != string.Empty && strConnectionString != string.Empty)
                    //            {
                    //                objDatafunction.InitializeRDBMSConnection(strConnectionString);
                    //                dtMinMaxTime = objDatafunction.rdbmsExecuteQuery(strSQLMinMaxTime, strTableName);
                    //            }
                    //            if (dtMinMaxTime.Rows.Count > 0)
                    //            {
                    //                foreach (DataRow drRow in dtMinMaxTime.Rows)
                    //                {
                    //                    devInfo = GetDeviceInfo(Convert.ToString(drRow["IPAddress"]), Convert.ToString(drRow["DevID"]), Convert.ToString(drRow["DevPwd"]), Convert.ToString(drRow["ComPort"]));
                    //                    //cmdStr = "GetRecord(start_time=\"2010-10-20 11:55:29\"end_time=\"2010-10-26 14:55:29\")";
                    //                    cmdStr = "GetRecord(start_time=\"" + Convert.ToDateTime(Convert.ToString(drRow["Min_DateTime"])).ToString("yyyy-MM-dd HH:mm:ss") + "\" end_time=\"" + Convert.ToDateTime(drRow["Max_DateTime"].ToString()).ToString("yyyy-MM-dd HH:mm:ss") + "\")";
                    //                    myCallBack = new CallBack(BeCalled);
                    //                    int result = HwDev_Execute(devInfo, devInfo.Length, cmdStr, cmdStr.Length, ref retStr, ref retlen, null);
                    //                    if (result == 0)
                    //                    {
                    //                        //retStr = ("Return( result='success' dev_id='1' time='2010-10-18 11:55:29' id='11' name='raju1' workcode='1' status='1' card_src='from_door' card_src='from_check' dev_id='0' time='2010-10-18 11:55:29' id='12' name='raju2' workcode='2' status='1' card_src='from_door' card_src='from_check' dev_id='0' time='2010-10-20 12:16:39' id='106' name='raju3' workcode='3' status='1' card_src='from_door' card_src='from_check' dev_id='0' time='2010-10-20 12:13:02' id='621' name='raju4' workcode='5' status='1' card_src='from_door' card_src='from_check')");
                    //                        //FileAccess.writeAllDeviceRecord(retStr);
                    //                        // MessageBox.Show("DownlaodAllDeviceInfo Success");
                    //                        retStr = retStr.Replace("\"", "'");
                    //                        // string strResult = ("Return( result='success' dev_id='0' time='2010-10-18 11:55:29' id='11' name='raju1' workcode='2' status='1' card_src='from_door' card_src='from_check' dev_id='0' time='2010-10-18 11:55:29' id='12' name='raju2' workcode='3' status='1' card_src='from_door' card_src='from_check' dev_id='0' time='2010-10-18 11:55:29' id='13' name='raju3' workcode='4' status='1' card_src='from_door' card_src='from_check' dev_id='0' time='2010-10-18 11:55:29' id='14' name='raju4' workcode='5' status='1' card_src='from_door' card_src='from_check')");
                    //                        string strResult = retStr;
                    //                        strResult = strResult.Replace("(", "");
                    //                        strResult = strResult.Replace(")", "");
                    //                        //Separated using space
                    //                        char[] separator = new char[] { };
                    //                        string[] strDetails;
                    //                        strDetails = strResult.Split(separator);
                    //                        int i;
                    //                        for (i = 0; i < strDetails.Length; i++)
                    //                        {
                    //                            if (strDetails[i].StartsWith("time") == true)
                    //                            {
                    //                                drResult_Details = dtResult_Details.NewRow();
                    //                                drResult_Details["DeviceId"] = drRow["nDeviceID"].ToString();
                    //                                drResult_Details["dtDateTime"] = strDetails[i].Substring(strDetails[i].IndexOf("'")).Replace("'", "") + " " + strDetails[i + 1].Replace("'", "");
                    //                                drResult_Details["EmployeeId"] = strDetails[i + 2].Substring(strDetails[i + 2].IndexOf("'")).Replace("'", "");
                    //                                drResult_Details["WorkCode"] = strDetails[i + 4].Substring(strDetails[i + 4].IndexOf("'")).Replace("'", "");
                    //                                dtResult_Details.Rows.Add(drResult_Details);
                    //                            }
                    //                        }
                    //                    }
                    //                    else
                    //                    {
                    //                        //MessageBox.Show("DownlaodAllDeviceInfo Failure");
                    //                        //eventLog1.WriteEntry(retStr);
                    //                        WriteErrorToEventLog("CollectRawData", retStr);
                    //                    }
                    //                }
                    //                try
                    //                {
                    //                    //delete existing records in ta_reportlist_temp table
                    //                    string strSQLDelete = "delete from tb_reportlist_temp";
                    //                    if (strSQLDelete != string.Empty && strConnectionString != string.Empty)
                    //                    {
                    //                        objDatafunction.InitializeRDBMSConnection(strConnectionString);
                    //                        objDatafunction.rdbmsExecuteNonQuery(strSQLDelete);
                    //                    }
                    //                    //inserts the records in ta_reportlist_temp table
                    //                    SqlBulkCopy sqlCopy = new SqlBulkCopy(strConnectionString.Replace("Provider=SQLOLEDB.1;", ""));
                    //                    sqlCopy.DestinationTableName = "tb_reportlist_temp";
                    //                    sqlCopy.ColumnMappings.Clear();
                    //                    foreach (DataColumn dcColumn in dtResult_Details.Columns)
                    //                    {
                    //                        sqlCopy.ColumnMappings.Add(new SqlBulkCopyColumnMapping(dcColumn.ColumnName, dcColumn.ColumnName));
                    //                    }
                    //                    Stopwatch sw = new Stopwatch();
                    //                    sw.Start();
                    //                    sqlCopy.WriteToServer(dtResult_Details);
                    //                    sw.Stop();
                    //                    //updates the tb_reportlist
                    //                    strSQLHanvon = "update tb_reportslist set nTNAEvent=tb_reportlist_temp.WorkCode,sUserName=null from tb_reportlist_temp inner join tb_reportslist on tb_reportslist.dtDateTime=tb_reportlist_temp.dtDateTime and tb_reportslist.nUserID=tb_reportlist_temp.EmployeeId and tb_reportslist.nDeviceID=tb_reportlist_temp.DeviceId";
                    //                    if (strSQLHanvon != string.Empty && strConnectionString != string.Empty)
                    //                    {
                    //                        objDatafunction.InitializeRDBMSConnection(strConnectionString);
                    //                        objDatafunction.rdbmsExecuteNonQuery(strSQLHanvon);
                    //                    }
                    //                }
                    //                catch (Exception ex)
                    //                {
                    //                    WriteErrorToEventLog("CollectRawData", "CollectRBMSRawData(tb_reportlist_temp); TerminalID : " + intTerminalID + "; FileType : " + inFileType + "; BrandName : " + strBrandName + "; Error : " + ex.ToString());
                    //                    throw ex;
                    //                }
                    //            }
                    //        }
                    //        #endregion
                    //        #region Select1000RecordsFromDeviceDb
                    //        strSQL = "SELECT nIndex," + strColReaderNo + "," + strColCardNo + ",";
                    //        if (Convert.ToString(dtRDBMSDetails.Rows[0]["RDBMS_DateTimeBit"]) == "True")
                    //        {
                    //            strSQL += "" + strColDateTime + ",";
                    //        }
                    //        else if (Convert.ToString(dtRDBMSDetails.Rows[0]["RDBMS_DateTimeBit"]) == "False")
                    //        {
                    //            strSQL += "" + strColDate + "," + strColTime + ",";
                    //        }
                    //        strSQL += "" + strColType + "," + strColFlag + " FROM " + strTableName + " WHERE " + strColFlag + " IS NULL";
                    //        if (dtRDBMSDetails.Rows[0]["TransactionIdentifierBit"] != DBNull.Value)
                    //        {
                    //            if (Convert.ToString(dtRDBMSDetails.Rows[0]["TransactionIdentifierBit"]) == "True")
                    //            {
                    //                strSQL += " AND " + strColTransIdentifier + " in( " + strTransIdentifierValue + ")";
                    //            }
                    //        }
                    //        if (strSQL != string.Empty && strConnectionString != string.Empty)
                    //        {                                
                    //            objDatafunction.InitializeRDBMSConnection(strConnectionString);
                    //            try
                    //            {
                    //                //1.Reports List Table need to be created in device Database.
                    //                //2.Configure device database in terminal master
                    //                //3.Create the below procedure into device database.
                    //                //Which is used to fetch the logs from the dynamic table of essl device.
                    //                //SqlParameter sp_Date = new SqlParameter("@ProcessFromDate", gstrDefaultMonthClosureDate);
                    //                //SqlParameter[] pmeters = { sp_Date };
                    //                //objDatafunction.ExecuteQueryUsingParameter(pmeters, "Pro_CreateAutoTrigger");
                    //                objDatafunction.ExecuteNonQuery_Procedures("Pro_CreateAutoTrigger");
                    //            }
                    //            catch (Exception ex)
                    //            {
                    //                WriteErrorToEventLog("CollectRawData", "CollectRBMSRawData(); BrandName : " + strBrandName + "; Error : " + ex.ToString());
                    //            }
                    //            CI.DateTimeFormat.ShortTimePattern = "hh:mm:ss tt";
                    //            CI.DateTimeFormat.LongTimePattern = "hh:mm:ss tt";
                    //            //dtRdbmsRawData = objDatafunction.rdbmsExecuteQuery(strSQL, strTableName);
                    //            OleDbParameter pgUpdateQuery = new OleDbParameter("@UpdateQuery", strSQL);
                    //            OleDbParameter[] pParams_UpdateQuery = { pgUpdateQuery };
                    //            dtRdbmsRawData = objDatafunction.GetDataFromRDBMS(pParams_UpdateQuery, "Proc_Ta_UpdateProcessedDataForService");
                    //            CI.DateTimeFormat.ShortTimePattern = "hh:mm tt";
                    //            CI.DateTimeFormat.LongTimePattern = "hh:mm tt";
                    //            #region Processing1000Records
                    //            foreach (DataRow drRdbmsRawData in dtRdbmsRawData.Rows)
                    //            {
                    //                string strSQLInsert = string.Empty, strSQLUpdate = string.Empty, strSQLCheckEmployee = string.Empty;
                    //                if ((drRdbmsRawData[strColReaderNo] != DBNull.Value) && (drRdbmsRawData[strColCardNo] != DBNull.Value) && (drRdbmsRawData[strColType] != DBNull.Value) && (Convert.ToString(drRdbmsRawData[strColReaderNo]) != string.Empty) && (Convert.ToString(drRdbmsRawData[strColCardNo]) != string.Empty) && (Convert.ToString(drRdbmsRawData[strColType]) != string.Empty))
                    //                {
                    //                    if (dtRDBMSDetails.Rows[0]["RDBMS_DateTimeBit"] != DBNull.Value)
                    //                    {
                    //                        if (Convert.ToString(dtRDBMSDetails.Rows[0]["RDBMS_DateTimeBit"]) == "True")
                    //                        {
                    //                            if (drRdbmsRawData[strColDateTime] != DBNull.Value && Convert.ToString(drRdbmsRawData[strColDateTime]) != string.Empty && Convert.ToString(drRdbmsRawData[strColDateTime]) != "0")
                    //                            {
                    //                                dtmDateTime = DateTime.Parse(Convert.ToString(drRdbmsRawData[strColDateTime]), CI);
                    //                                strDate = dtmDateTime.ToShortDateString();
                    //                                strTime = dtmDateTime.ToShortTimeString();
                    //                            }
                    //                        }
                    //                        else if (Convert.ToString(dtRDBMSDetails.Rows[0]["RDBMS_DateTimeBit"]) == "False")
                    //                        {
                    //                            if ((drRdbmsRawData[strColDate] != DBNull.Value) && (drRdbmsRawData[strColTime] != DBNull.Value) && (Convert.ToString(drRdbmsRawData[strColDate]) != string.Empty) && (Convert.ToString(drRdbmsRawData[strColTime]) != string.Empty) && (Convert.ToString(drRdbmsRawData[strColDate]) != "0") && (Convert.ToString(drRdbmsRawData[strColTime]) != "0"))
                    //                            {
                    //                                if (dtRDBMSDetails.Rows[0]["IsEncrypted"] != DBNull.Value)
                    //                                {
                    //                                    if (Convert.ToString(dtRDBMSDetails.Rows[0]["IsEncrypted"]) == "True")
                    //                                    {
                    //                                        strDate = DecryptDateTime(int.Parse(Convert.ToString(drRdbmsRawData[strColDate])), "D");
                    //                                        strTime = DecryptDateTime(int.Parse(Convert.ToString(drRdbmsRawData[strColTime])), "T");
                    //                                    }
                    //                                    else
                    //                                    {
                    //                                        strDate = DateTime.Parse(Convert.ToString(drRdbmsRawData[strColDate]), CI).ToShortDateString();
                    //                                        strTime = DateTime.Parse(Convert.ToString(drRdbmsRawData[strColTime]), CI).ToLongTimeString();
                    //                                    }
                    //                                }
                    //                            }
                    //                        }
                    //                    }
                    //                    string strType = string.Empty, strPunchType = string.Empty;
                    //                    #region InsertRawData
                    //                    if (drRdbmsRawData[strColCardNo] != DBNull.Value && drRdbmsRawData[strColReaderNo] != DBNull.Value && drRdbmsRawData[strColType] != DBNull.Value && strDate != string.Empty && strDate != "0" && strTime != string.Empty && strTime != "0")
                    //                    {
                    //                        strType = Convert.ToString(drRdbmsRawData[strColType]);
                    //                        // BioStation
                    //                        switch (strType)
                    //                        {
                    //                            case "0":
                    //                            case "1":
                    //                            case "2":
                    //                            case "3":
                    //                            case "4":
                    //                            case "5":
                    //                            case "6":
                    //                            case "7":
                    //                            case "8":
                    //                            case "9":
                    //                            case "10":
                    //                            case "11":
                    //                            case "12":
                    //                            case "13":
                    //                            case "14":
                    //                            case "15":
                    //                                strPunchType = strType;
                    //                                break;
                    //                            default:
                    //                                strPunchType = Convert.ToString(drRdbmsRawData[strColReaderNo]);
                    //                                break;
                    //                        }
                    //                        InsertRawDataDetails(Convert.ToString(drRdbmsRawData[strColCardNo]),
                    //                                    Convert.ToString(drRdbmsRawData[strColReaderNo]),
                    //                                    Convert.ToString(DateTime.Parse(strDate, CI)),
                    //                                    Convert.ToString(strTime),
                    //                                    Convert.ToString(strPunchType));
                    //                    }
                    //                    #endregion
                    //                    #region UpdateFlagInDeviceDB
                    //                    if (strConnectionString != string.Empty)
                    //                    {
                    //                        objDatafunction.InitializeRDBMSConnection(strConnectionString);
                    //                        UpdateFlagInDeviceDatabase(strTableName, strColFlag, Convert.ToString(drRdbmsRawData["nIndex"]));
                    //                    }
                    //                    #endregion
                    //                }
                    //            }
                    //            #endregion
                    //        }
                    //        #endregion
                    //    }
                    //}
                    #endregion
                    if (dtRDBMSDetails.Rows[0]["strSQL"] != DBNull.Value)
                    {
                        strSQL = Convert.ToString(dtRDBMSDetails.Rows[0]["strSQL"]);
                    }
                    if ((strColDateTime != string.Empty) || (strColDate != string.Empty && strColTime != string.Empty))
                    {
                        if (dtRDBMSDetails.Rows[0]["RDBMS_DateTimeBit"] != DBNull.Value)
                        {
                            #region Select1000RecordsFromDeviceDb
                            if (strConnectionString != string.Empty)
                            {
                                //strConnectionString = "Server=127.0.0.1;Port=3312;Database=biostar_tna;Uid=root;Pwd=admin123;";                                
                                DataTable dtTblExists = new DataTable();
                                DataTable dtlogTableDetails = new DataTable();
                                CI.DateTimeFormat.ShortTimePattern = "hh:mm:ss tt";
                                CI.DateTimeFormat.LongTimePattern = "hh:mm:ss tt";
                                string finalMonth = "";
                                string strFinaltableName = "";
                                string strTableExistsQuery = "";
                                int CurrentYear = Convert.ToInt32(DateTime.Now.Year);
                                int CurrentMonth = Convert.ToInt32(DateTime.Now.Month);
                                double lastLogID = 0;
                                strTableExistsQuery = "select table_name from information_schema.tables where table_name =";
                                string dataCollectionQuery = "";
                                //strBrandName = "Suprema-Biostar 2";
                                //strBrandName = "ESSL";
                                int maxlogID = 0;
                                switch (strBrandName)
                                {
                                    case "Hanvon":
                                        #region Hanvon
                                        string devInfo, cmdStr, retStr;
                                        DataTable dtMinMaxTime = new DataTable();
                                        DataTable dtResult_Details = new DataTable();
                                        DataRow drResult_Details;
                                        dtResult_Details.Columns.Add("DeviceId");
                                        dtResult_Details.Columns.Add("dtDateTime");
                                        dtResult_Details.Columns.Add("EmployeeId");
                                        dtResult_Details.Columns.Add("WorkCode");
                                        retStr = "";
                                        IntPtr ret = IntPtr.Zero;
                                        uint retlen = 0;
                                        strSQLMinMaxTime = "select KQZ_DevInfo.IPAddress,KQZ_DevInfo.DevID,KQZ_DevInfo.DevPwd,KQZ_DevInfo.ComPort,min(tb_reportslist.dtDateTime) as Min_DateTime,max(tb_reportslist.dtDateTime) as Max_DateTime,tb_reportslist.nDeviceID from tb_reportslist inner join KQZ_DevInfo on KQZ_DevInfo.DevID=tb_reportslist.nDeviceId where tb_reportslist.nTNAEvent is null group by KQZ_DevInfo.IPAddress,tb_reportslist.nDeviceID,KQZ_DevInfo.DevID,KQZ_DevInfo.DevPwd,KQZ_DevInfo.ComPort";
                                        if (strSQLMinMaxTime != string.Empty && strConnectionString != string.Empty)
                                        {
                                            objDatafunction.InitializeRDBMSConnection(strConnectionString);
                                            dtMinMaxTime = objDatafunction.rdbmsExecuteQuery(strSQLMinMaxTime, strTableName);
                                        }
                                        if (dtMinMaxTime.Rows.Count > 0)
                                        {
                                            foreach (DataRow drRow in dtMinMaxTime.Rows)
                                            {
                                                devInfo = GetDeviceInfo(Convert.ToString(drRow["IPAddress"]), Convert.ToString(drRow["DevID"]), Convert.ToString(drRow["DevPwd"]), Convert.ToString(drRow["ComPort"]));
                                                //cmdStr = "GetRecord(start_time=\"2010-10-20 11:55:29\"end_time=\"2010-10-26 14:55:29\")";
                                                cmdStr = "GetRecord(start_time=\"" + Convert.ToDateTime(Convert.ToString(drRow["Min_DateTime"])).ToString("yyyy-MM-dd HH:mm:ss") + "\" end_time=\"" + Convert.ToDateTime(drRow["Max_DateTime"].ToString()).ToString("yyyy-MM-dd HH:mm:ss") + "\")";
                                                myCallBack = new CallBack(BeCalled);
                                                int result = HwDev_Execute(devInfo, devInfo.Length, cmdStr, cmdStr.Length, ref retStr, ref retlen, null);
                                                if (result == 0)
                                                {
                                                    //retStr = ("Return( result='success' dev_id='1' time='2010-10-18 11:55:29' id='11' name='raju1' workcode='1' status='1' card_src='from_door' card_src='from_check' dev_id='0' time='2010-10-18 11:55:29' id='12' name='raju2' workcode='2' status='1' card_src='from_door' card_src='from_check' dev_id='0' time='2010-10-20 12:16:39' id='106' name='raju3' workcode='3' status='1' card_src='from_door' card_src='from_check' dev_id='0' time='2010-10-20 12:13:02' id='621' name='raju4' workcode='5' status='1' card_src='from_door' card_src='from_check')");
                                                    //FileAccess.writeAllDeviceRecord(retStr);
                                                    // MessageBox.Show("DownlaodAllDeviceInfo Success");
                                                    retStr = retStr.Replace("\"", "'");
                                                    // string strResult = ("Return( result='success' dev_id='0' time='2010-10-18 11:55:29' id='11' name='raju1' workcode='2' status='1' card_src='from_door' card_src='from_check' dev_id='0' time='2010-10-18 11:55:29' id='12' name='raju2' workcode='3' status='1' card_src='from_door' card_src='from_check' dev_id='0' time='2010-10-18 11:55:29' id='13' name='raju3' workcode='4' status='1' card_src='from_door' card_src='from_check' dev_id='0' time='2010-10-18 11:55:29' id='14' name='raju4' workcode='5' status='1' card_src='from_door' card_src='from_check')");
                                                    string strResult = retStr;
                                                    strResult = strResult.Replace("(", "");
                                                    strResult = strResult.Replace(")", "");
                                                    //Separated using space
                                                    char[] separator = new char[] { };
                                                    string[] strDetails;
                                                    strDetails = strResult.Split(separator);
                                                    int i;
                                                    for (i = 0; i < strDetails.Length; i++)
                                                    {
                                                        if (strDetails[i].StartsWith("time") == true)
                                                        {
                                                            drResult_Details = dtResult_Details.NewRow();
                                                            drResult_Details["DeviceId"] = drRow["nDeviceID"].ToString();
                                                            drResult_Details["dtDateTime"] = strDetails[i].Substring(strDetails[i].IndexOf("'")).Replace("'", "") + " " + strDetails[i + 1].Replace("'", "");
                                                            drResult_Details["EmployeeId"] = strDetails[i + 2].Substring(strDetails[i + 2].IndexOf("'")).Replace("'", "");
                                                            drResult_Details["WorkCode"] = strDetails[i + 4].Substring(strDetails[i + 4].IndexOf("'")).Replace("'", "");
                                                            dtResult_Details.Rows.Add(drResult_Details);
                                                        }
                                                    }
                                                }
                                                else
                                                {
                                                    //MessageBox.Show("DownlaodAllDeviceInfo Failure");
                                                    //eventLog1.WriteEntry(retStr);
                                                    WriteErrorToEventLog("collectRawData", retStr);
                                                }
                                            }
                                            try
                                            {
                                                //delete existing records in ta_reportlist_temp table
                                                string strSQLDelete = "delete from tb_reportlist_temp";
                                                if (strSQLDelete != string.Empty && strConnectionString != string.Empty)
                                                {
                                                    objDatafunction.InitializeRDBMSConnection(strConnectionString);
                                                    objDatafunction.rdbmsExecuteNonQuery(strSQLDelete);
                                                }
                                                //inserts the records in ta_reportlist_temp table
                                                SqlBulkCopy sqlCopy = new SqlBulkCopy(strConnectionString.Replace("Provider=SQLOLEDB.1;", ""));
                                                sqlCopy.DestinationTableName = "tb_reportlist_temp";
                                                sqlCopy.ColumnMappings.Clear();
                                                foreach (DataColumn dcColumn in dtResult_Details.Columns)
                                                {
                                                    sqlCopy.ColumnMappings.Add(new SqlBulkCopyColumnMapping(dcColumn.ColumnName, dcColumn.ColumnName));
                                                }
                                                Stopwatch sw = new Stopwatch();
                                                sw.Start();
                                                sqlCopy.WriteToServer(dtResult_Details);
                                                sw.Stop();
                                                //updates the tb_reportlist
                                                strSQLHanvon = "update tb_reportslist set nTNAEvent=tb_reportlist_temp.WorkCode,sUserName=null from tb_reportlist_temp inner join tb_reportslist on tb_reportslist.dtDateTime=tb_reportlist_temp.dtDateTime and tb_reportslist.nUserID=tb_reportlist_temp.EmployeeId and tb_reportslist.nDeviceID=tb_reportlist_temp.DeviceId";
                                                if (strSQLHanvon != string.Empty && strConnectionString != string.Empty)
                                                {
                                                    objDatafunction.InitializeRDBMSConnection(strConnectionString);
                                                    objDatafunction.rdbmsExecuteNonQuery(strSQLHanvon);
                                                }
                                            }
                                            catch (Exception ex)
                                            {
                                                //eventLog1.WriteEntry("function : CollectRBMSRawData(tb_reportlist_temp); TerminalID : " + intTerminalID + "; FileType : " + inFileType + "; BrandName : " + strBrandName + "; Error : " + ex.ToString());
                                                WriteErrorToEventLog("collectRawData", "CollectRBMSRawData(tb_reportlist_temp); TerminalID : " + intTerminalID + "; FileType : " + inFileType + "; BrandName : " + strBrandName + "; Error : " + ex.ToString());
                                                throw ex;
                                            }
                                        }
                                        #endregion
                                        break;
                                    case "ESSL":
                                        #region ESSL
                                        for (int i = 2; i >= 0; i--)
                                        {
                                            if (CurrentMonth == 0)
                                            {
                                                CurrentYear = Convert.ToInt16(CurrentYear) - 1;
                                                CurrentMonth = 12;
                                            }
                                            finalMonth = "";
                                            strFinaltableName = "";
                                            lastLogID = 0;
                                            maxlogID = 0;
                                            strFinaltableName = strTableName + Convert.ToString(CurrentMonth) + "_" + Convert.ToString(CurrentYear);
                                            dtlogTableDetails = GetDeviceLogTableDetails(strFinaltableName);
                                            if (dtlogTableDetails.Rows.Count > 0)
                                            {
                                                lastLogID = Convert.ToDouble(dtlogTableDetails.Rows[0]["LastLogID"]);
                                            }
                                            //strTableExistsQuery += "'" + Convert.ToString(strFinaltableName) + "'";
                                            if (strTableExistsQuery != string.Empty)
                                            {
                                                objDatafunction.InitializeRDBMSConnection(strConnectionString);
                                                dtTblExists = objDatafunction.rdbmsExecuteQuery(strTableExistsQuery + "'" + Convert.ToString(strFinaltableName) + "'", Convert.ToString(strFinaltableName));
                                                if (dtTblExists.Rows.Count > 0)
                                                {
                                                    dataCollectionQuery = strSQL.Replace("#Table_Name", strFinaltableName);
                                                    dataCollectionQuery = dataCollectionQuery.Replace("#log_Number", lastLogID.ToString());
                                                    //dataCollectionQuery = "select t1.LogDate,t1.DeviceId,t1.UserId,' ',DeviceLogId FROM " + Convert.ToString(strFinaltableName) + " t1 ";
                                                    //dataCollectionQuery += " WHERE T1.UserId IS NOT NULL AND T1.UserId <> ''";
                                                    //dataCollectionQuery += " AND T1.EVT IN(" + strTransIdentifierValue + ") and EVTLGUID>" + lastLogID;
                                                    //Todo: This field need to be confirmed with ESSL database.
                                                    //dataCollectionQuery += " and DeviceLogId>" + lastLogID;
                                                    dtRdbmsRawData = objDatafunction.rdbmsExecuteQuery(dataCollectionQuery, strTableName);
                                                    CI.DateTimeFormat.ShortTimePattern = "hh:mm tt";
                                                    CI.DateTimeFormat.LongTimePattern = "hh:mm tt";
                                                    if (dtRdbmsRawData.Rows.Count > 0)
                                                    {
                                                        InsertLogToRawDataTable_WithOutPunchTypes(dtRDBMSDetails, dtRdbmsRawData, strColReaderNo, strColCardNo, strColDateTime, "", "");
                                                        //ToDo: need to enabled below line instead of above line.
                                                        //InsertLogToRawDataTable(dtRDBMSDetails, dtRdbmsRawData, strConnectionString, strColReaderNo, strColCardNo, strColDateTime, strColDate, strColTime, strColType, strColFlag);
                                                        //Todo: This field need to be confirmed with ESSL database.
                                                        if (strColFlag != "" && strColFlag != "NoFlag")
                                                            maxlogID = (int)dtRdbmsRawData.Compute("MAX(" + strColFlag + ")", "");
                                                    }
                                                    if (strColFlag != "" && strColFlag != "NoFlag")
                                                        InsertDeviceLogDetails(strFinaltableName, maxlogID);
                                                }
                                            }
                                            CurrentMonth -= 1;
                                        }
                                        #endregion
                                        break;
                                    case "Suprema-Biostar 2":
                                        #region Biostar2                                        
                                        for (int i = 2; i >= 0; i--)
                                        {
                                            if (CurrentMonth == 0)
                                            {
                                                CurrentYear = Convert.ToInt16(CurrentYear) - 1;
                                                CurrentMonth = 12;
                                            }
                                            finalMonth = "";
                                            strFinaltableName = "";
                                            lastLogID = 0;
                                            maxlogID = 0;
                                            if (Convert.ToString(CurrentMonth).Length == 1)
                                            {
                                                finalMonth = "0";
                                            }
                                            finalMonth += Convert.ToString(CurrentMonth);
                                            strFinaltableName = strTableName + Convert.ToString(CurrentYear) + finalMonth;
                                            dtlogTableDetails = GetDeviceLogTableDetails(strFinaltableName);
                                            if (dtlogTableDetails.Rows.Count > 0)
                                            {
                                                lastLogID = Convert.ToDouble(dtlogTableDetails.Rows[0]["LastLogID"]);
                                            }
                                            if (strTableExistsQuery != string.Empty)
                                            {
                                                //strConnectionString = @"Provider=SQLOLEDB.1;Data Source=angler67\SQL2014;Initial Catalog=Biostar_AC23;User Id=sa;pwd=angler123;";
                                                if (inFileType == "RDBMS")
                                                {
                                                    objDatafunction.InitializeRDBMSConnection(strConnectionString);
                                                }
                                                else if (inFileType == "MariaDB")
                                                {
                                                    objDatafunction.InitializeMySQLConnection(strConnectionString);
                                                }
                                                dtTblExists = objDatafunction.rdbmsExecuteQuery(strTableExistsQuery + "'" + strFinaltableName + "'", Convert.ToString(strFinaltableName));
                                                if (dtTblExists.Rows.Count > 0)
                                                {
                                                    if (!string.IsNullOrEmpty(strSQL))
                                                    {
                                                        dataCollectionQuery = strSQL.Replace("#Table_Name", strFinaltableName).Replace("#log_Number", lastLogID.ToString());
                                                        //dataCollectionQuery = "SELECT DEVDT=dateadd(SS,t1.DEVDT+14400,'01/01/1970'),DEVUID,USRID,EVT,TNAKEY,EVTLGUID FROM " + Convert.ToString(strFinaltableName) + " t1 ";
                                                        //dataCollectionQuery += " WHERE TNAKEY IN ('0','1','2','3','4','5','6','7','8','9','10','11','12','13','14','15','16','255') AND T1.USRID IS NOT NULL AND T1.USRID <> ''";
                                                        //dataCollectionQuery += " AND T1.EVT IN(" + strTransIdentifierValue + ") and EVTLGUID>" + lastLogID;
                                                        if (inFileType == "RDBMS")
                                                        {
                                                            dtRdbmsRawData = objDatafunction.rdbmsExecuteQuery(dataCollectionQuery, strTableName);
                                                        }
                                                        else if (inFileType == "MariaDB")
                                                        {
                                                            dtRdbmsRawData = objDatafunction.mysqlrdbmsExecuteQuery(dataCollectionQuery, strTableName);
                                                        }
                                                        CI.DateTimeFormat.ShortTimePattern = "hh:mm tt";
                                                        CI.DateTimeFormat.LongTimePattern = "hh:mm tt";
                                                        if (dtRdbmsRawData.Rows.Count > 0)
                                                        {
                                                            InsertLogToRawDataTable(dtRDBMSDetails, dtRdbmsRawData, strColReaderNo, strColCardNo, strColDateTime, "", "", strColType);
                                                            //ToDo: need to enabled below line instead of above line.
                                                            //InsertLogToRawDataTable(dtRDBMSDetails, dtRdbmsRawData, strConnectionString, strColReaderNo, strColCardNo, strColDateTime, strColDate, strColTime, strColType, strColFlag);
                                                            if (strColFlag != "" && strColFlag != "NoFlag")
                                                                maxlogID = (int)dtRdbmsRawData.Compute("MAX(" + strColFlag + ")", "");
                                                        }
                                                        if (strColFlag != "" && strColFlag != "NoFlag")
                                                            InsertDeviceLogDetails(strFinaltableName, maxlogID);
                                                    }
                                                }
                                            }
                                            CurrentMonth -= 1;
                                        }
                                        #endregion
                                        break;
                                    case "Suprema":
                                        #region Biostar
                                        strFinaltableName = strTableName;
                                        dtlogTableDetails = GetDeviceLogTableDetails(strFinaltableName);
                                        if (dtlogTableDetails.Rows.Count > 0)
                                        {
                                            lastLogID = Convert.ToDouble(dtlogTableDetails.Rows[0]["LastLogID"]);
                                        }
                                        if (strSQL != string.Empty)
                                        {
                                            objDatafunction.InitializeRDBMSConnection(strConnectionString);
                                            strSQL = strSQL.Replace("#log_Number", lastLogID.ToString());
                                            dtRdbmsRawData = objDatafunction.rdbmsExecuteQuery(strSQL, strTableName);
                                            CI.DateTimeFormat.ShortTimePattern = "hh:mm tt";
                                            CI.DateTimeFormat.LongTimePattern = "hh:mm tt";
                                            maxlogID = 0;
                                            if (dtRdbmsRawData.Rows.Count > 0)
                                            {
                                                InsertLogToRawDataTable(dtRDBMSDetails, dtRdbmsRawData, strColReaderNo, strColCardNo, strColDateTime, strColDate, strColTime, strColType);
                                                if (strColFlag != "" && strColFlag != "NoFlag")
                                                    maxlogID = (int)dtRdbmsRawData.Compute("MAX(" + strColFlag + ")", "");
                                            }
                                            if (strColFlag != "" && strColFlag != "NoFlag")
                                            {
                                                InsertDeviceLogDetails(strFinaltableName, maxlogID);
                                            }
                                        }
                                        #endregion
                                        break;
                                    case "Others":
                                        #region Others
                                        strFinaltableName = strTableName;
                                        dtlogTableDetails = GetDeviceLogTableDetails(strFinaltableName);
                                        if (dtlogTableDetails.Rows.Count > 0)
                                        {
                                            lastLogID = Convert.ToDouble(dtlogTableDetails.Rows[0]["LastLogID"]);
                                        }
                                        if (strSQL != string.Empty)
                                        {
                                            objDatafunction.InitializeRDBMSConnection(strConnectionString);
                                            strSQL = strSQL.Replace("#log_Number", lastLogID.ToString());
                                            dtRdbmsRawData = objDatafunction.rdbmsExecuteQuery(strSQL, strTableName);
                                            CI.DateTimeFormat.ShortTimePattern = "hh:mm tt";
                                            CI.DateTimeFormat.LongTimePattern = "hh:mm tt";
                                            maxlogID = 0;
                                            if (dtRdbmsRawData.Rows.Count > 0)
                                            {
                                                InsertLogToRawDataTable_WithOutPunchTypes(dtRDBMSDetails, dtRdbmsRawData, strColReaderNo, strColCardNo, strColDateTime, strColDate, strColTime);
                                                if (strColFlag != "" && strColFlag != "NoFlag")
                                                    maxlogID = (int)dtRdbmsRawData.Compute("MAX(" + strColFlag + ")", "");
                                            }
                                            if (strColFlag != "" && strColFlag != "NoFlag")
                                            {
                                                InsertDeviceLogDetails(strFinaltableName, maxlogID);
                                            }
                                        }
                                        #endregion
                                        break;
                                    case "Iris EF-45 device":
                                        #region Iris-CMITech
                                        strFinaltableName = strTableName;
                                        dtlogTableDetails = GetDeviceLogTableDetails(strFinaltableName);
                                        if (dtlogTableDetails.Rows.Count > 0)
                                        {
                                            lastLogID = Convert.ToDouble(dtlogTableDetails.Rows[0]["LastLogID"]);
                                        }
                                        if (strSQL != string.Empty)
                                        {
                                            if (inFileType == "MariaDB")
                                            {
                                                objDatafunction.InitializeMySQLConnection(strConnectionString);
                                            }
                                            else
                                                objDatafunction.InitializeRDBMSConnection(strConnectionString);
                                            strSQL = strSQL.Replace("#log_Number", lastLogID.ToString());
                                            if (inFileType == "MariaDB")
                                            {
                                                dtRdbmsRawData = objDatafunction.mysqlrdbmsExecuteQuery(strSQL, strTableName);
                                            }
                                            else
                                            {
                                                dtRdbmsRawData = objDatafunction.rdbmsExecuteQuery(strSQL, strTableName);
                                            }
                                            CI.DateTimeFormat.ShortTimePattern = "hh:mm tt";
                                            CI.DateTimeFormat.LongTimePattern = "hh:mm tt";
                                            maxlogID = 0;
                                            if (dtRdbmsRawData.Rows.Count > 0)
                                            {
                                                InsertLogToRawDataTable_WithOutPunchTypes_Iris(dtRDBMSDetails, dtRdbmsRawData, strColReaderNo, strColCardNo, strColDateTime, strColDate, strColTime);
                                                if (strColFlag != "" && strColFlag != "NoFlag")
                                                    maxlogID = (int)dtRdbmsRawData.Compute("MAX(" + strColFlag + ")", "");
                                            }
                                            if (strColFlag != "" && strColFlag != "NoFlag")
                                            {
                                                InsertDeviceLogDetails(strFinaltableName, maxlogID);
                                            }
                                        }
                                        #endregion
                                        break;
                                }
                            }
                            #endregion
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "CollectRBMSRawData(); TerminalID : " + intTerminalID + "; FileType : " + inFileType + "; BrandName : " + strBrandName + "; Error : " + ex.ToString());
            }
        }
        #endregion
        #region InsertLogToRawDataTable_WithOutPunchTypes_Iris
        private void InsertLogToRawDataTable_WithOutPunchTypes_Iris(DataTable dtRDBMSDetails, DataTable dtRdbmsRawData, string strColReaderNo, string strColCardNo, string strColDateTime, string strColDate, string strColTime)
        {
            #region Processing1000Records
            DateTime dtmDateTime = new DateTime();
            string strDate = string.Empty, strTime = string.Empty;
            foreach (DataRow drRdbmsRawData in dtRdbmsRawData.Rows)
            {
                string strSQLInsert = string.Empty, strSQLUpdate = string.Empty, strSQLCheckEmployee = string.Empty;
                if ((drRdbmsRawData[strColReaderNo] != DBNull.Value) && (drRdbmsRawData[strColCardNo] != DBNull.Value) && (Convert.ToString(drRdbmsRawData[strColReaderNo]) != string.Empty) && (Convert.ToString(drRdbmsRawData[strColCardNo]) != string.Empty))
                {
                    if (dtRDBMSDetails.Rows[0]["RDBMS_DateTimeBit"] != DBNull.Value)
                    {
                        if (Convert.ToString(dtRDBMSDetails.Rows[0]["RDBMS_DateTimeBit"]) == "True")
                        {
                            if (drRdbmsRawData[strColDateTime] != DBNull.Value && Convert.ToString(drRdbmsRawData[strColDateTime]) != string.Empty && Convert.ToString(drRdbmsRawData[strColDateTime]) != "0")
                            {
                                string logDatetime = Convert.ToString(drRdbmsRawData[strColDateTime]).Substring(0, 4)
                                    + "-" + Convert.ToString(drRdbmsRawData[strColDateTime]).Substring(4, 2)
                                    + "-" + Convert.ToString(drRdbmsRawData[strColDateTime]).Substring(6, 2)
                                    + " " + Convert.ToString(drRdbmsRawData[strColDateTime]).Substring(8, 2)
                                    + ":" + Convert.ToString(drRdbmsRawData[strColDateTime]).Substring(10, 2)
                                    + ":" + Convert.ToString(drRdbmsRawData[strColDateTime]).Substring(12, 2);
                                dtmDateTime = DateTime.Parse(logDatetime, CI);
                                strDate = dtmDateTime.ToShortDateString();
                                strTime = dtmDateTime.ToShortTimeString();
                            }
                        }
                    }
                    string strType = string.Empty, strPunchType = string.Empty;
                    try
                    {
                        #region InsertRawData
                        if (drRdbmsRawData[strColCardNo] != DBNull.Value && drRdbmsRawData[strColReaderNo] != DBNull.Value && strDate != string.Empty && strDate != "0" && strTime != string.Empty && strTime != "0")
                        {
                            strPunchType = Convert.ToString(drRdbmsRawData[strColReaderNo]);
                            InsertRawDataDetails(Convert.ToString(drRdbmsRawData[strColCardNo]),
                                Convert.ToString(drRdbmsRawData[strColReaderNo]),
                                Convert.ToString(strDate),
                                Convert.ToString(strTime),
                                Convert.ToString(strPunchType));
                        }
                        #endregion
                    }
                    catch (Exception ex)
                    {
                        WriteErrorToEventLog("CollectRawData", "CollectRBMSRawData(); SwipeCardNo : " + drRdbmsRawData[strColCardNo].ToString() + "; ReaderNo : " + drRdbmsRawData[strColReaderNo].ToString() + "; Date : " + strDate + "; Time : " + strTime + "; Punch Type : " + strPunchType + "; Error : " + ex.ToString());
                        throw ex;
                    }
                }
            }
            #endregion
        }
        #endregion
        #region ClockDetails
        /// <summary>
        /// Purpose :
        ///     The ClockDetails Method is a used to take Raw Data from the TimeCheck Raw Data Table and insert matching 
        ///     IN and OUT Records for a particular Employee and Date
        /// </summary>
        public void ClockDetails()
        {
            DataTable dtRawData;
            bool blnDuplicateExists = false;
            string Shiftdate = string.Empty;
            string strPunchTypeExists = string.Empty;
            int intTerminalExists = 1;
            string strRawDataUpdate = string.Empty;
            DataTable dtTerminalPunchTypeStatus = new DataTable();
            int Reasonid = 0;
            try
            {
                // Get the Raw Data from the TimeCheck Raw Data Table where Clk_Flag = 0
                dtRawData = objDatafunction.ExecuteQuery("Proc_TA_GettingNonProcessedRawDataRecords", "TA_Tbl_Clk_RawData");
                foreach (DataRow drRawData in dtRawData.Rows)
                {
                    try
                    {
                        if (drRawData["Clk_CardId"] != DBNull.Value && drRawData["Clk_DeviceId"] != DBNull.Value && drRawData["Clk_Date"] != DBNull.Value && drRawData["Clk_Time"] != DBNull.Value && drRawData["Clk_Type"] != DBNull.Value)
                        {
                            if (Convert.ToString(drRawData["Clk_CardId"]) != string.Empty && Convert.ToString(drRawData["Clk_DeviceId"]) != string.Empty && Convert.ToString(drRawData["Clk_Date"]) != string.Empty && Convert.ToString(drRawData["Clk_Time"]) != string.Empty && Convert.ToString(drRawData["Clk_Type"]) != string.Empty)
                            {
                                // Since this Process is Coming from Terminal, the Status is set to A to indicate it is Automatic Process                            
                                strClk_Status = "A";
                                dtTerminalPunchTypeStatus = ToCheckTerminalAndPunchTypesExists(Convert.ToString(drRawData["Clk_DeviceId"]), Convert.ToString(drRawData["Clk_Type"]));
                                #region TerminalStatusChecking
                                if (dtTerminalPunchTypeStatus.Rows.Count > 0)
                                {
                                    intTerminalExists = Convert.ToInt16(dtTerminalPunchTypeStatus.Rows[0]["Status"]);
                                    strPunchTypeExists = Convert.ToString(dtTerminalPunchTypeStatus.Rows[0]["PunchType"]);
                                    if (intTerminalExists == 0)
                                    {
                                        #region GetShiftId
                                        gintShiftId = GetShiftId(Convert.ToString(drRawData["Clk_CardId"]), Convert.ToString(drRawData["Clk_Date"]), Convert.ToString(drRawData["Clk_Time"]));
                                        Shiftdate = Convert.ToString(drRawData["Clk_Date"]);
                                        while (gintShiftId == -1)
                                        {
                                            TimeSpan ts = new TimeSpan(-1, 0, 0, 0);
                                            Shiftdate = DateTime.Parse(Shiftdate, CI).Add(ts).ToShortDateString();
                                            gintShiftId = GetShiftId(Convert.ToString(drRawData["Clk_CardId"]), Shiftdate, Convert.ToString(drRawData["Clk_Time"]));
                                        }
                                        if (gintShiftId != 0)
                                        {
                                            //Get Clock Date
                                            gstrClockDate = GetClockDate(Convert.ToString(drRawData["Clk_CardId"]), Convert.ToString(drRawData["Clk_Date"]), DateTime.Parse(Convert.ToString(drRawData["Clk_Time"]), CI).ToLongTimeString());
                                            GetLevelId(Convert.ToString(drRawData["Clk_CardId"]), DateTime.Parse(Convert.ToString(drRawData["Clk_Date"]), CI).ToShortDateString());
                                            // Get the shift type based on Shift Id 
                                            bool shiftType = GetShiftType(gintShiftId);
                                            // Insert the Record into the Clock Details Table
                                            if (!shiftType) // Function Key Mapping if Shift Type is false
                                            {
                                                // Function Key Mapping if Shift Type is false
                                                #region FunctionKey
                                                bool blnValueExists = false;
                                                if (strPunchTypeExists != "")
                                                {
                                                    // Insert the Record into the Clock Details Table 
                                                    strPunchTypeRemarksId = GettingPunchTypeRemarks(Convert.ToString(drRawData["Clk_Type"]), strPunchTypeExists);
                                                    RecordFromClockdetails = 1;
                                                    blnValueExists = ReplaceAndInsert(Convert.ToString(drRawData["Clk_CardId"]), Convert.ToString(drRawData["Clk_DeviceId"]), DateTime.Parse(Convert.ToString(drRawData["Clk_Date"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["Clk_Time"]), CI).ToLongTimeString(), Convert.ToString(drRawData["Clk_Type"]), string.Empty, string.Empty, strClk_Status, Convert.ToInt64(drRawData["Clk_Id"]));
                                                    //Added By Manikandan.R //Mapping Break Punches..... //On 25-08-2014 11:32 am
                                                    if (Convert.ToString(strPunchTypeExists) == "Break In" || Convert.ToString(strPunchTypeExists) == "Break Out")
                                                    {
                                                        MappingPunches(Convert.ToString(drRawData["Clk_CardId"]), Convert.ToString(drRawData["Clk_DeviceId"]), DateTime.Parse(Convert.ToString(drRawData["Clk_Date"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["Clk_Time"]), CI).ToLongTimeString(), Convert.ToString(strPunchTypeExists), gstrClockDate);
                                                    }
                                                    if (blnValueExists == false)
                                                    {
                                                        UpdateClockDate(Convert.ToString(drRawData["Clk_CardId"]), Convert.ToString(drRawData["Clk_DeviceId"]), DateTime.Parse(Convert.ToString(drRawData["Clk_Date"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["Clk_Time"]), CI).ToLongTimeString(), Convert.ToString(drRawData["Clk_Type"]), shiftType, strClk_Status, "", "", "");
                                                    }
                                                }
                                                #endregion
                                            }
                                            else // Free Scan Mapping if Shift Type is true
                                            {
                                                // Free Scan Mapping if Shift Type is true
                                                #region FreeScan
                                                strPunchTypeExists = "1";
                                                // Check Ignore Duplicate 
                                                blnDuplicateExists = CheckIgnoreDuplicate(shiftType, Convert.ToString(drRawData["Clk_CardId"]), DateTime.Parse(Convert.ToString(drRawData["Clk_Date"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["Clk_Time"]), CI).ToLongTimeString(), gstrClockDate, "IO");
                                                bool blnExactDuplicateExists = false;
                                                DataTable dtCheckInDateExactDuplicateExists = new DataTable();
                                                dtCheckInDateExactDuplicateExists = CheckExactDuplicateRecordExists(
                                                    Convert.ToString(drRawData["Clk_CardId"]),
                                                    DateTime.Parse(Convert.ToString(drRawData["Clk_Date"]), CI).ToShortDateString(),
                                                    DateTime.Parse(Convert.ToString(drRawData["Clk_Time"]), CI).ToLongTimeString());
                                                if (dtCheckInDateExactDuplicateExists.Rows.Count > 0)
                                                {
                                                    if (Convert.ToInt32(dtCheckInDateExactDuplicateExists.Rows[0]["Count"]) > 0)
                                                    {
                                                        blnExactDuplicateExists = true;
                                                    }
                                                }
                                                if (blnDuplicateExists == false)
                                                {
                                                    DataTable dtDeviceType = new DataTable();
                                                    dtDeviceType = CheckingDeviceMappingInEntrance(Convert.ToString(drRawData["Clk_DeviceId"]), "C");
                                                    if (dtDeviceType.Rows.Count > 0)
                                                    {
                                                        if (Convert.ToInt32(dtDeviceType.Rows[0]["count"]) > 1)
                                                        {
                                                            FreeScan(Convert.ToString(drRawData["Clk_CardId"]), Convert.ToString(drRawData["Clk_DeviceId"]), DateTime.Parse(Convert.ToString(drRawData["Clk_Date"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["Clk_Time"]), CI).ToLongTimeString(), "", "", strClk_Status);
                                                        }
                                                        if (Convert.ToInt32(dtDeviceType.Rows[0]["count"]) == 1)
                                                        {
                                                            bool blnValueExists = false;
                                                            //if both devices in and out are same, that time we are not checking punch types exists or not.B
                                                            //But at the same time if the devices are different in entrance master, we are checking
                                                            //punchtypes are available or not. To avoid that implemented below datatable.
                                                            //For freescan logic we dont need to 
                                                            DataTable dt_DeviceType = new DataTable();
                                                            dt_DeviceType = CheckingDeviceMappingInEntrance(Convert.ToString(drRawData["Clk_DeviceId"]), "T");
                                                            string clkType = string.Empty;
                                                            if (dt_DeviceType.Rows.Count > 0)
                                                            {
                                                                clkType = Convert.ToString(dt_DeviceType.Rows[0]["Type"]);
                                                                clkType = (clkType.ToUpper() == "IN") ? "I" : "O";
                                                            }
                                                            blnValueExists = ReplaceAndInsert(Convert.ToString(drRawData["Clk_CardId"]), Convert.ToString(drRawData["Clk_DeviceId"]), DateTime.Parse(Convert.ToString(drRawData["Clk_Date"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["Clk_Time"]), CI).ToLongTimeString(), clkType, string.Empty, string.Empty, strClk_Status, Convert.ToInt64(drRawData["Clk_Id"]));
                                                            if (blnValueExists == false)
                                                            {
                                                                UpdateClockDate(Convert.ToString(drRawData["Clk_CardId"]), Convert.ToString(drRawData["Clk_DeviceId"]), DateTime.Parse(Convert.ToString(drRawData["Clk_Date"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["Clk_Time"]), CI).ToLongTimeString(), Convert.ToString(drRawData["Clk_Type"]), shiftType, strClk_Status, "", "", "");
                                                            }
                                                        }
                                                    }
                                                }
                                                else
                                                {
                                                    if (blnExactDuplicateExists == false)
                                                    {
                                                        DataTable dtDeviceType = new DataTable();
                                                        dtDeviceType = CheckingDeviceMappingInEntrance(Convert.ToString(drRawData["Clk_DeviceId"]), "T");
                                                        if (dtDeviceType.Rows.Count > 0)
                                                        {
                                                            if (Convert.ToString(dtDeviceType.Rows[0]["Type"]) == "In")
                                                            {
                                                                InsertVoidPunches(Convert.ToString(drRawData["Clk_CardId"]), Convert.ToString(drRawData["Clk_DeviceId"]), DateTime.Parse(Convert.ToString(drRawData["Clk_Date"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["Clk_Time"]), CI).ToLongTimeString(), "", "", strClk_Status, "I");
                                                            }
                                                            if (Convert.ToString(dtDeviceType.Rows[0]["Type"]) == "Out")
                                                            {
                                                                InsertVoidPunches(Convert.ToString(drRawData["Clk_CardId"]), Convert.ToString(drRawData["Clk_DeviceId"]), DateTime.Parse(Convert.ToString(drRawData["Clk_Date"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["Clk_Time"]), CI).ToLongTimeString(), "", "", strClk_Status, "O");
                                                            }
                                                        }
                                                    }
                                                }
                                                UpdateClockDate(Convert.ToString(drRawData["Clk_CardId"]), Convert.ToString(drRawData["Clk_DeviceId"]), DateTime.Parse(Convert.ToString(drRawData["Clk_Date"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["Clk_Time"]), CI).ToLongTimeString(), Convert.ToString(drRawData["Clk_Type"]), shiftType, strClk_Status, "", "", "");
                                                #endregion
                                            }
                                            if (strPunchTypeExists != "")
                                            {
                                                // After matching the record in the Clock Details Table, Update the flag in the Raw Data Table to 1
                                                string st = "";
                                                DataTable dtshiftname = new DataTable();
                                                st = "Proc_TA_GetShiftUsingID @ShiftID=" + gintShiftId;
                                                dtshiftname = objDatafunction.ExecuteQuery(st, "Shift_Name");
                                                if (dtshiftname.Rows.Count > 0)
                                                    if (Convert.ToString(dtshiftname.Rows[0][0]) == "True")
                                                        UpdateRawDataFlag(Convert.ToInt64(drRawData["Clk_Id"]), 0, 1, 1, "C");
                                                    else
                                                        // If Shift is not allocated, then Change the Clk_Flag to 0 and Clk_Process to 1, Reasonid to 3
                                                        UpdateRawDataFlag(Convert.ToInt64(drRawData["Clk_Id"]), 3, 1, 0, "C");
                                            }
                                            else
                                                // If punch types is not created for particular device, then Change the Clk_Flag to 0 and Clk_Process to 1, Reasonid to 4
                                                UpdateRawDataFlag(Convert.ToInt64(drRawData["Clk_Id"]), 4, 1, 0, "C");
                                        }
                                        else
                                            // If Shift is not allocated, then Change the Clk_Flag to 0 and Clk_Process to 1, Reasonid to 3
                                            UpdateRawDataFlag(Convert.ToInt64(drRawData["Clk_Id"]), 3, 1, 0, "C");
                                        #endregion
                                    }
                                    else
                                    {
                                        Reasonid = intTerminalExists == 1 ? 2 : 4;
                                        // If Terminal\device is not created, then Change the Clk_Flag to 0 and Clk_Process to 1, Reasonid to 2
                                        UpdateRawDataFlag(Convert.ToInt64(drRawData["Clk_Id"]), Reasonid, 1, 0, "C");
                                    }
                                }
                                #endregion
                                //Added by Gopinath For Punch type remarks
                                RecordFromClockdetails = 0;
                                strPunchTypeRemarksId = string.Empty;
                                strOldPunchTypeRemarksId = string.Empty;
                            }
                            else
                            {
                                if (Convert.ToString(drRawData["Clk_CardId"]) == string.Empty)
                                {
                                    WriteErrorDetailsToDB(Convert.ToString(drRawData["Clk_Id"]), "Card Id is Empty", "C");
                                }
                            }
                        }
                    }
                    catch (Exception ex)
                    {
                        string strErrorMessage = ex.Message.ToString().Replace(",", "");
                        WriteErrorToEventLog("CollectRawData", "ClockDetails() ; SwipeCardNo : " + drRawData["Clk_CardId"].ToString() + "; DeviceID : " + drRawData["Clk_DeviceId"].ToString() + "; Date : " + drRawData["Clk_Date"].ToString() + "; Time : " + drRawData["Clk_Time"].ToString() + "; Type : " + drRawData["Clk_Type"].ToString() + "; Error : " + ex.ToString());
                        WriteErrorDetailsToDB(Convert.ToString(drRawData["Clk_Id"]), strErrorMessage, "C");
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "function : ClockDetails() ; Error : " + ex.ToString());
            }
        }
        #endregion
        #region ToCheckTerminalExists
        public DataTable ToCheckTerminalAndPunchTypesExists(string inClk_DeviceId, string inClk_Type)
        {
            DataTable dtTerminal = new DataTable();
            try
            {
                SqlParameter pmTerminal_ReaderID = new SqlParameter("@Terminal_ReaderID", inClk_DeviceId);
                SqlParameter pminClk_Type = new SqlParameter("@inClk_Type", inClk_Type);
                SqlParameter[] pmetersTerminal = { pmTerminal_ReaderID, pminClk_Type };
                dtTerminal = objDatafunction.GettingDatasetUsingParameter(pmetersTerminal, "Proc_TA_CheckingTerminalStatus");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "ToCheckTerminalAndPunchTypesExists()" + "\r\n" + ex.Message);
            }
            return (dtTerminal);
        }
        #endregion
        #region GetShiftId
        public int GetShiftId(string inClk_EmpId, string inClk_Date, string Clk_time)
        {
            int intShiftId = 0;
            int intCompanyId = 0;
            try
            {
                intCompanyId = Convert.ToInt32(GetLevelId(inClk_EmpId, inClk_Date));
                SqlParameter pmintEmployeeId = new SqlParameter("@Clk_EmpId", inClk_EmpId);
                SqlParameter pmintDate = new SqlParameter("@date", inClk_Date);
                SqlParameter pmintCompanyId = new SqlParameter("@CompanyId", intCompanyId);
                SqlParameter Clk_tim = new SqlParameter("@Clk_time", Clk_time);
                SqlParameter[] pParams = { pmintEmployeeId, pmintDate, pmintCompanyId, Clk_tim };
                intShiftId = Convert.ToInt16(objDatafunction.GettingScalarValueUsingParameter(pParams, "Proc_TA_GetShiftIDForParticularDate"));
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "GetShiftId ; SwipeCardNo : " + inClk_EmpId + "; Date : " + inClk_Date + "; Error : " + ex.ToString());
                throw ex;
            }
            return (intShiftId);
        }
        #endregion
        #region GetLevelId
        /// <summary>
        /// Get the parent level id(Company id)for processing using swipe card number and clock date
        /// </summary>
        /// <param name="inClk_EmpId"></param>
        /// <param name="inClk_Date"></param>
        /// <returns></returns>
        public string GetLevelId(string inClk_EmpId, string inClk_Date)
        {
            DataTable dtCompany = new DataTable();
            try
            {
                // Get the Company Id for a particular Employee
                SqlParameter GetLevelId_inClk_EmpId = new SqlParameter("@inClk_EmpId", inClk_EmpId);
                SqlParameter GetLevelId_inClk_Date = new SqlParameter("@inClk_Date", inClk_Date);
                SqlParameter[] GetLevelId_prmters = { GetLevelId_inClk_EmpId, GetLevelId_inClk_Date };
                dtCompany = objDatafunction.GettingDatasetUsingParameter(GetLevelId_prmters, "Proc_Ta_GetLevelIdForService");
                if (dtCompany.Rows.Count > 0)
                {
                    gstrCompanyId = dtCompany.Rows[0][0].ToString();
                }
                else
                {
                    gstrCompanyId = "0";
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "GetLevelId; SwipeCardNo : " + inClk_EmpId + "; Date : " + inClk_Date + "; Error : " + ex.Message);
            }
            return gstrCompanyId;
        }
        #endregion
        #region GetClockDate
        /// <summary>
        /// GetClockDate
        /// </summary>
        /// <param name="SwipeCardNo"></param>
        /// <param name="inStrDate"></param>
        /// <param name="inStrTime"></param>
        /// <param name="intShiftId"></param>
        /// <returns></returns>
        public string GetClockDate(string SwipeCardNo, string inClk_Date, string inClk_Time)
        {
            DataTable dtShiftSettings;
            TimeSpan tsMaxHoursBeforeShift = new TimeSpan();
            TimeSpan tsMaxHourBeforeShift_24HrsShift = new TimeSpan();
            string strSQLShiftSettings = string.Empty;
            string strPunchDateTime = string.Empty;
            gstrWeeklyOffDate = string.Empty;
            gstrNextDayIsWeeklyOff = string.Empty;
            gintNextDayShiftId = 0;
            gintWeeklyOffShiftCount = 0;
            gstrPreviousShiftStartTime = string.Empty;
            gstrPreviousShiftEndTime = string.Empty;
            gdtmPreviousShiftStartTime = new DateTime();
            gdtmPreviousShiftEndTime = new DateTime();
            gstrCurrentShiftStartTime = string.Empty;
            gstrCurrentShiftEndTime = string.Empty;
            gdtmCurrentShiftStartTime = new DateTime();
            gdtmCurrentShiftEndTime = new DateTime();
            gstrNextShiftStartTime = string.Empty;
            gstrNextShiftEndTime = string.Empty;
            gdtmNextShiftStartTime = new DateTime();
            gdtmNextShiftEndTime = new DateTime();
            DateTime dtmPunchDateTime = new DateTime();
            strPunchDateTime = DateTime.Parse(inClk_Date, CI).ToShortDateString() + " " + inClk_Time;
            dtmPunchDateTime = DateTime.Parse(strPunchDateTime, CI);
            DateTime dtmDefaultDateTime = new DateTime();
            int intCompanyId = 0;
            try
            {
                SqlParameter pgSwipeCardNo = new SqlParameter("@SwipeCardNo", SwipeCardNo);
                SqlParameter[] pParams = { pgSwipeCardNo };
                strIsAutoShiftEmployee = objDatafunction.GettingScalarValueUsingParameter(pParams, "Proc_Ta_GettingIsAutoShiftEmployee");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "function : GetClockDate strIsAutoShiftEmployee ; SwipeCardNo : " + SwipeCardNo + "; Date : " + inClk_Date + "; Time : " + inClk_Time + "; Error : " + ex.ToString());
            }
            try
            {
                intCompanyId = GetCompanyId(SwipeCardNo, inClk_Date);
                if (strIsAutoShiftEmployee == "NO")
                {
                    gdtShiftSettings.DefaultView.RowFilter = "CompanyId = " + intCompanyId + "";
                    dtShiftSettings = gdtShiftSettings.DefaultView.ToTable();
                    if (dtShiftSettings.Rows.Count == 0)
                    {
                        gdtShiftSettings.DefaultView.RowFilter = "CompanyId = -1";
                        dtShiftSettings = gdtShiftSettings.DefaultView.ToTable();
                    }
                    if (dtShiftSettings.Rows.Count > 0)
                    {
                        tsMaxHoursBeforeShift = DateTime.Parse(Convert.ToString(dtShiftSettings.Rows[0]["MaxHoursBeforeShift"]), CI).TimeOfDay;
                        tsMaxHoursNextDayIsWeeklyOff = DateTime.Parse(Convert.ToString(dtShiftSettings.Rows[0]["WeeklyOffStartHours"]), CI).TimeOfDay;
                        if (Convert.ToString(dtShiftSettings.Rows[0]["MaxHoursBeforeShift_24HrsShift"]) != string.Empty)
                            tsMaxHourBeforeShift_24HrsShift = DateTime.Parse(Convert.ToString(dtShiftSettings.Rows[0]["MaxHoursBeforeShift_24HrsShift"]), CI).TimeOfDay;
                        if (Convert.ToString(dtShiftSettings.Rows[0]["WeeklyOffStartHours_24HrsShift"]) != string.Empty)
                            tsWeeklyOffStartHours_24HrsShift = new TimeSpan(int.Parse(Convert.ToString(dtShiftSettings.Rows[0]["WeeklyOffStartHours_24HrsShift"]).Split(':')[0]), int.Parse(Convert.ToString(dtShiftSettings.Rows[0]["WeeklyOffStartHours_24HrsShift"]).Split(':')[1]), 0);
                    }
                    ValuesReset();
                    // Get the Previous Day Shift Start DateTime and End DateTime
                    GetPreviousDateShiftStartTimeEndTime(SwipeCardNo, DateTime.Parse(inClk_Date, CI).AddDays(-1).ToShortDateString(), inClk_Time);
                    if (gdtmPreviousShiftStartTime != dtmDefaultDateTime)
                    {
                        //Check Current Day is Weekly Off
                        if (gstrWeeklyOffDate == string.Empty)
                        {
                            if (IsPreviousShift_24Hours == true)
                            {
                                gdtmPreviousShiftStartTime = gdtmPreviousShiftStartTime.Subtract(tsMaxHourBeforeShift_24HrsShift);
                            }
                            else
                            {
                                gdtmPreviousShiftStartTime = gdtmPreviousShiftStartTime.Subtract(tsMaxHoursBeforeShift);
                            }
                        }
                    }
                    ValuesReset();
                    //Get the Current Day Shift Start DateTime and End DateTime
                    GetCurrentDateShiftStartTimeEndTime(SwipeCardNo, DateTime.Parse(inClk_Date, CI).ToShortDateString(), inClk_Time);
                    if (gdtmCurrentShiftStartTime != dtmDefaultDateTime)
                    {
                        //Check Current Day is Weekly Off
                        if (gstrWeeklyOffDate == string.Empty)
                        {
                            if (IsCurrentShift_24Hours == true)
                            {
                                gdtmCurrentShiftStartTime = gdtmCurrentShiftStartTime.Subtract(tsMaxHourBeforeShift_24HrsShift);
                            }
                            else
                            {
                                gdtmCurrentShiftStartTime = gdtmCurrentShiftStartTime.Subtract(tsMaxHoursBeforeShift);
                            }
                        }
                    }
                    ValuesReset();
                    // Get the Previous Day Shift Start DateTime and End DateTime
                    GetNextDateShiftStartTimeEndTime(SwipeCardNo, DateTime.Parse(inClk_Date, CI).AddDays(1).ToShortDateString(), inClk_Time);
                    if (gdtmNextShiftStartTime != dtmDefaultDateTime)
                    {
                        //Check Current Day is Weekly Off
                        if (gstrWeeklyOffDate == string.Empty)
                        {
                            if (IsNextShift_24Hours == true)
                            {
                                gdtmNextShiftStartTime = gdtmNextShiftStartTime.Subtract(tsMaxHourBeforeShift_24HrsShift);
                            }
                            else
                            {
                                gdtmNextShiftStartTime = gdtmNextShiftStartTime.Subtract(tsMaxHoursBeforeShift);
                            }
                        }
                    }
                    else
                    {
                        if (gdtmCurrentShiftStartTime != dtmDefaultDateTime)
                        {
                            gdtmNextShiftStartTime = gdtmCurrentShiftStartTime.AddDays(1);
                            gdtmNextShiftEndTime = gdtmCurrentShiftEndTime.AddDays(1);
                        }
                    }
                    //Check Start Times
                    if (gdtmCurrentShiftStartTime >= gdtmPreviousShiftStartTime && gdtmCurrentShiftStartTime <= gdtmPreviousShiftEndTime)
                    {
                        gdtmPreviousShiftEndTime = gdtmCurrentShiftStartTime.AddSeconds(-1);
                    }
                    if (gdtmNextShiftStartTime >= gdtmCurrentShiftStartTime && gdtmNextShiftStartTime <= gdtmCurrentShiftEndTime)
                    {
                        gdtmNextShiftStartTime = gdtmCurrentShiftEndTime.AddSeconds(1);
                    }
                    //Check between Current day shift time
                    if (dtmPunchDateTime >= gdtmCurrentShiftStartTime && dtmPunchDateTime <= gdtmCurrentShiftEndTime)
                    {
                        gstrClockDate = DateTime.Parse(inClk_Date, CI).ToShortDateString();
                    }
                    else if (dtmPunchDateTime >= gdtmPreviousShiftStartTime && dtmPunchDateTime <= gdtmPreviousShiftEndTime)
                    {
                        //Check between Previous day shift time
                        gstrClockDate = DateTime.Parse(inClk_Date, CI).AddDays(-1).ToShortDateString();
                    }
                    else if (dtmPunchDateTime >= gdtmNextShiftStartTime && dtmPunchDateTime <= gdtmNextShiftEndTime)
                    {
                        //Check between Next day shift time
                        gstrClockDate = DateTime.Parse(inClk_Date, CI).AddDays(1).ToShortDateString();
                    }
                    else if (dtmPunchDateTime < gdtmCurrentShiftStartTime)
                    {
                        gstrClockDate = DateTime.Parse(inClk_Date, CI).AddDays(-1).ToShortDateString();
                    }
                    else if (dtmPunchDateTime >= gdtmNextShiftStartTime)
                    {
                        gstrClockDate = DateTime.Parse(inClk_Date, CI).AddDays(1).ToShortDateString();
                    }
                    else
                    {
                        gstrClockDate = DateTime.Parse(inClk_Date, CI).ToShortDateString();
                    }
                }
                else
                {
                    gstrClockDate = GetClockDateForAutoShiftEmployee(SwipeCardNo, inClk_Date, inClk_Time, intCompanyId);
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "GetClockDate ; SwipeCardNo : " + SwipeCardNo + "; Date : " + inClk_Date + "; Time : " + inClk_Time + "; Error : " + ex.ToString());
            }
            return DateTime.Parse(gstrClockDate, CI).ToShortDateString();
        }
        #endregion
        #region GetCompanyId
        public int GetCompanyId(string inClk_EmpId, string inClk_Date)
        {
            int intCompanyId = 0;
            try
            {
                GetLevelId(inClk_EmpId, inClk_Date);
                intCompanyId = GetCompanyId(Int32.Parse(gstrCompanyId));
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "GetCompanyId ; SwipeCardNo : " + inClk_EmpId + "; Date : " + inClk_Date + "; Error : " + ex.ToString());
            }
            return intCompanyId;
        }
        #endregion
        #region GetCompanyId
        public int GetCompanyId(int LevelId)
        {
            DataTable dtLevel = new DataTable();
            int intLevelId = 0;
            try
            {
                SqlParameter pmLevelId = new SqlParameter("@LevelId", LevelId);
                SqlParameter[] pmetersCompany = { pmLevelId };
                dtLevel = objDatafunction.GettingDatasetUsingParameter(pmetersCompany, "Proc_TA_GetCompanyDetails");
                if (dtLevel.Rows.Count > 0)
                {
                    intLevelId = int.Parse(Convert.ToString(dtLevel.Rows[0]["ParentId"]));
                    if (intLevelId == 0)
                    {
                        gintCompanyId = int.Parse(Convert.ToString(dtLevel.Rows[0]["Id"]));
                    }
                    else
                    {
                        GetCompanyId(intLevelId);
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "GetCompanyId ; LevelId : " + LevelId + "; Error : " + ex.ToString());
            }
            return (gintCompanyId);
        }
        #endregion
        #region ValuesReset
        /// <summary>
        /// Reset the Global values to default(gstrNextDayIsWeeklyOff,gintWeeklyOffShiftCount,gintNextDayShiftId,gstrWeeklyOffDate)
        /// </summary>
        public void ValuesReset()
        {
            gstrNextDayIsWeeklyOff = string.Empty;
            gintWeeklyOffShiftCount = 0;
            gintNextDayShiftId = 0;
            gstrWeeklyOffDate = string.Empty;
        }
        #endregion
        #region GetPreviousDateShiftStartTimeEndTime
        public void GetPreviousDateShiftStartTimeEndTime(string inClk_EmpId, string inClk_Date, string Clk_time)
        {
            DataTable dtShift = new DataTable();
            string strSQLShiftStartTime = string.Empty;
            int intShiftId = 0;
            gstrPreviousShiftStartTime = string.Empty;
            gstrPreviousShiftEndTime = string.Empty;
            gdtmPreviousShiftStartTime = new DateTime();
            gdtmPreviousShiftEndTime = new DateTime();
            try
            {
                intShiftId = GetShiftId(inClk_EmpId, inClk_Date, Clk_time);
                //Check Next Day is Weekly Off
                if (gstrNextDayIsWeeklyOff == string.Empty)
                {
                    gintNextDayShiftId = GetShiftId(inClk_EmpId, DateTime.Parse(inClk_Date, CI).AddDays(1).ToShortDateString(), Clk_time);
                    if (gintNextDayShiftId == -1)
                    {
                        gstrNextDayIsWeeklyOff = DateTime.Parse(inClk_Date, CI).AddDays(1).ToShortDateString();
                    }
                }
                //End of Weekly Off Checking
                gdtShift.DefaultView.RowFilter = "Shift_Id = " + intShiftId + "";
                dtShift = gdtShift.DefaultView.ToTable();
                if (dtShift.Rows.Count > 0)
                {
                    if (dtShift.Rows[0]["Shift_StartTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]) != string.Empty)
                    {
                        if (gstrWeeklyOffDate == string.Empty)
                        {
                            gstrPreviousShiftStartTime = inClk_Date + " " + Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]);
                            gdtmPreviousShiftStartTime = DateTime.Parse(gstrPreviousShiftStartTime, CI);
                            if (Convert.ToString(dtShift.Rows[0]["24HrsShift"]) != string.Empty)
                                IsPreviousShift_24Hours = Convert.ToBoolean(dtShift.Rows[0]["24HrsShift"]);
                            //Check Next Day is Weekly Off
                            if (gstrNextDayIsWeeklyOff == string.Empty)
                            {
                                gstrPreviousShiftEndTime = inClk_Date + " " + Convert.ToString(dtShift.Rows[0]["Shift_EndTime"]);
                                if ((gstrPreviousShiftStartTime.Substring(9, 2) == "PM") && (gstrPreviousShiftEndTime.Substring(9, 2) == "AM"))
                                {
                                    gdtmPreviousShiftEndTime = DateTime.Parse(gstrPreviousShiftEndTime, CI).AddDays(1);
                                }
                                else
                                {
                                    gdtmPreviousShiftEndTime = DateTime.Parse(gstrPreviousShiftEndTime, CI);
                                }
                            }
                            else
                            {
                                //16 Hours would be parameterized in Shift Settings
                                if (gintWeeklyOffShiftCount == 0)
                                {
                                    if (dtShift.Rows[0]["24HrsShift"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["24HrsShift"]) != string.Empty)
                                    {
                                        if (Convert.ToString(dtShift.Rows[0]["24HrsShift"]) == "True")
                                        {
                                            gstrPreviousShiftEndTime = Convert.ToString(gdtmPreviousShiftStartTime.Add(tsWeeklyOffStartHours_24HrsShift));
                                        }
                                        else
                                        {
                                            gstrPreviousShiftEndTime = Convert.ToString(gdtmPreviousShiftStartTime.Add(tsMaxHoursNextDayIsWeeklyOff));
                                        }
                                    }
                                    else
                                    {
                                        gstrPreviousShiftEndTime = Convert.ToString(gdtmPreviousShiftStartTime.Add(tsMaxHoursNextDayIsWeeklyOff));
                                    }
                                    gdtmPreviousShiftEndTime = DateTime.Parse(gstrPreviousShiftEndTime, CI);
                                }
                                if (gintWeeklyOffShiftCount >= 1)
                                {
                                    gstrPreviousShiftStartTime = inClk_Date + " " + Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]);
                                    if (dtShift.Rows[0]["24HrsShift"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["24HrsShift"]) != string.Empty)
                                    {
                                        if (Convert.ToString(dtShift.Rows[0]["24HrsShift"]) == "True")
                                        {
                                            gdtmPreviousShiftStartTime = DateTime.Parse(gstrPreviousShiftStartTime, CI).AddDays(gintWeeklyOffShiftCount - 1).Add(tsWeeklyOffStartHours_24HrsShift).AddSeconds(1);
                                        }
                                        else
                                        {
                                            gdtmPreviousShiftStartTime = DateTime.Parse(gstrPreviousShiftStartTime, CI).AddDays(gintWeeklyOffShiftCount - 1).Add(tsMaxHoursNextDayIsWeeklyOff).AddSeconds(1);
                                        }
                                    }
                                    else
                                    {
                                        gdtmPreviousShiftStartTime = DateTime.Parse(gstrPreviousShiftStartTime, CI).AddDays(gintWeeklyOffShiftCount - 1).Add(tsMaxHoursNextDayIsWeeklyOff).AddSeconds(1);
                                    }
                                    gdtmPreviousShiftEndTime = gdtmPreviousShiftStartTime.AddDays(1).AddSeconds(-1);
                                }
                            }
                            //End of Weekly Off Checking
                        }
                        else
                        {
                            if (gintWeeklyOffShiftCount >= 1)
                            {
                                gstrPreviousShiftStartTime = inClk_Date + " " + Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]);
                                if (dtShift.Rows[0]["24HrsShift"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["24HrsShift"]) != string.Empty)
                                {
                                    if (Convert.ToString(dtShift.Rows[0]["24HrsShift"]) == "True")
                                    {
                                        gdtmPreviousShiftStartTime = DateTime.Parse(gstrPreviousShiftStartTime, CI).AddDays(gintWeeklyOffShiftCount - 1).Add(tsWeeklyOffStartHours_24HrsShift).AddSeconds(1);
                                    }
                                    else
                                    {
                                        gdtmPreviousShiftStartTime = DateTime.Parse(gstrPreviousShiftStartTime, CI).AddDays(gintWeeklyOffShiftCount - 1).Add(tsMaxHoursNextDayIsWeeklyOff).AddSeconds(1);
                                    }
                                }
                                else
                                {
                                    gdtmPreviousShiftStartTime = DateTime.Parse(gstrPreviousShiftStartTime, CI).AddDays(gintWeeklyOffShiftCount - 1).Add(tsMaxHoursNextDayIsWeeklyOff).AddSeconds(1);
                                }
                                gdtmPreviousShiftEndTime = gdtmPreviousShiftStartTime.AddDays(1).AddSeconds(-1);
                            }
                        }
                    }
                }
                if (intShiftId == -1)
                {
                    if (gstrWeeklyOffDate == string.Empty)
                    {
                        gstrWeeklyOffDate = inClk_Date;
                    }
                    gintWeeklyOffShiftCount = gintWeeklyOffShiftCount + 1;
                    GetPreviousDateShiftStartTimeEndTime(inClk_EmpId, DateTime.Parse(inClk_Date, CI).AddDays(-1).ToShortDateString(), Clk_time);
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "GetPreviousDateShiftStartTimeEndTime ; SwipeCardNo : " + inClk_EmpId + "; Date : " + inClk_Date + "; Error : " + ex.ToString());
            }
        }
        #endregion
        #region GetCurrentDateShiftStartTimeEndTime
        public void GetCurrentDateShiftStartTimeEndTime(string inClk_EmpId, string inClk_Date, string Clk_time)
        {
            DataTable dtShift = new DataTable();
            string strSQLShiftStartTime = string.Empty;
            int intShiftId = 0;
            gstrCurrentShiftStartTime = string.Empty;
            gstrCurrentShiftEndTime = string.Empty;
            gdtmCurrentShiftStartTime = new DateTime();
            gdtmCurrentShiftEndTime = new DateTime();
            try
            {
                intShiftId = GetShiftId(inClk_EmpId, inClk_Date, Clk_time);
                //Check Next Day is Weekly Off
                if (gstrNextDayIsWeeklyOff == string.Empty)
                {
                    gintNextDayShiftId = GetShiftId(inClk_EmpId, DateTime.Parse(inClk_Date, CI).AddDays(1).ToShortDateString(), Clk_time);
                    if (gintNextDayShiftId == -1)
                    {
                        gstrNextDayIsWeeklyOff = DateTime.Parse(inClk_Date, CI).AddDays(1).ToShortDateString();
                    }
                }
                //End of Weekly Off Checking
                gdtShift.DefaultView.RowFilter = "Shift_Id = " + intShiftId + "";
                dtShift = gdtShift.DefaultView.ToTable();
                if (dtShift.Rows.Count > 0)
                {
                    if (dtShift.Rows[0]["Shift_StartTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]) != string.Empty)
                    {
                        if (gstrWeeklyOffDate == string.Empty)
                        {
                            gstrCurrentShiftStartTime = inClk_Date + " " + Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]);
                            gdtmCurrentShiftStartTime = DateTime.Parse(gstrCurrentShiftStartTime, CI);
                            if (Convert.ToString(dtShift.Rows[0]["24HrsShift"]) != string.Empty)
                                IsCurrentShift_24Hours = Convert.ToBoolean(dtShift.Rows[0]["24HrsShift"]);
                            //Check Next Day is Weekly Off
                            if (gstrNextDayIsWeeklyOff == string.Empty)
                            {
                                gstrCurrentShiftEndTime = inClk_Date + " " + Convert.ToString(dtShift.Rows[0]["Shift_EndTime"]);
                                if ((gstrCurrentShiftStartTime.Substring(9, 2) == "PM") && (gstrCurrentShiftEndTime.Substring(9, 2) == "AM"))
                                {
                                    gdtmCurrentShiftEndTime = DateTime.Parse(gstrCurrentShiftEndTime, CI).AddDays(1);
                                }
                                else
                                {
                                    gdtmCurrentShiftEndTime = DateTime.Parse(gstrCurrentShiftEndTime, CI);
                                }
                            }
                            else
                            {
                                //16 Hours would be parameterized in Shift Settings
                                //gstrCurrentShiftEndTime = gdtmCurrentShiftStartTime.AddHours(16).ToString();
                                //gdtmCurrentShiftEndTime = DateTime.Parse(gstrCurrentShiftEndTime);
                                //16 Hours would be parameterized in Shift Settings
                                if (gintWeeklyOffShiftCount == 0)
                                {
                                    if (dtShift.Rows[0]["24HrsShift"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["24HrsShift"]) != string.Empty)
                                    {
                                        if (Convert.ToString(dtShift.Rows[0]["24HrsShift"]) == "True")
                                        {
                                            gstrCurrentShiftEndTime = Convert.ToString(gdtmCurrentShiftStartTime.Add(tsWeeklyOffStartHours_24HrsShift));
                                        }
                                        else
                                        {
                                            gstrCurrentShiftEndTime = Convert.ToString(gdtmCurrentShiftStartTime.Add(tsMaxHoursNextDayIsWeeklyOff));
                                        }
                                    }
                                    else
                                    {
                                        gstrCurrentShiftEndTime = Convert.ToString(gdtmCurrentShiftStartTime.Add(tsMaxHoursNextDayIsWeeklyOff));
                                    }
                                    gdtmCurrentShiftEndTime = DateTime.Parse(gstrCurrentShiftEndTime, CI);
                                }
                                if (gintWeeklyOffShiftCount >= 1)
                                {
                                    gstrCurrentShiftStartTime = inClk_Date + " " + Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]);
                                    if (dtShift.Rows[0]["24HrsShift"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["24HrsShift"]) != string.Empty)
                                    {
                                        if (Convert.ToString(dtShift.Rows[0]["24HrsShift"]) == "True")
                                        {
                                            gdtmCurrentShiftStartTime = DateTime.Parse(gstrCurrentShiftStartTime, CI).AddDays(gintWeeklyOffShiftCount - 1).Add(tsWeeklyOffStartHours_24HrsShift).AddSeconds(1);
                                        }
                                        else
                                        {
                                            gdtmCurrentShiftStartTime = DateTime.Parse(gstrCurrentShiftStartTime, CI).AddDays(gintWeeklyOffShiftCount - 1).Add(tsMaxHoursNextDayIsWeeklyOff).AddSeconds(1);
                                        }
                                    }
                                    else
                                    {
                                        gdtmCurrentShiftStartTime = DateTime.Parse(gstrCurrentShiftStartTime, CI).AddDays(gintWeeklyOffShiftCount - 1).Add(tsMaxHoursNextDayIsWeeklyOff).AddSeconds(1);
                                    }
                                    gdtmCurrentShiftEndTime = gdtmCurrentShiftStartTime.AddDays(1).AddSeconds(-1);
                                }
                            }
                            //End of Weekly Off Checking
                        }
                        else
                        {
                            ////Check Before Shift hours here
                            //gstrCurrentShiftEndTime = gdtmCurrentShiftStartTime.AddDays(1).ToString();
                            //if (gintWeeklyOffShiftCount >= 1)
                            //{
                            //    gstrCurrentShiftStartTime = inClk_Date + " " + Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]);
                            //    if (dtShift.Rows[0]["24HrsShift"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["24HrsShift"]) != string.Empty)
                            //    {
                            //        if (Convert.ToString(dtShift.Rows[0]["24HrsShift"]) == "True")
                            //        {
                            //            gdtmCurrentShiftStartTime = DateTime.Parse(gstrCurrentShiftStartTime, CI).AddDays(gintWeeklyOffShiftCount - 1).Add(tsWeeklyOffStartHours_24HrsShift).AddSeconds(1);
                            //        }
                            //        else
                            //        {
                            //            gdtmCurrentShiftStartTime = DateTime.Parse(gstrCurrentShiftStartTime, CI).AddDays(gintWeeklyOffShiftCount - 1).Add(tsMaxHoursNextDayIsWeeklyOff).AddSeconds(1);
                            //        }
                            //    }
                            //    else
                            //    {
                            //        gdtmCurrentShiftStartTime = DateTime.Parse(gstrCurrentShiftStartTime, CI).AddDays(gintWeeklyOffShiftCount - 1).Add(tsMaxHoursNextDayIsWeeklyOff).AddSeconds(1);
                            //    }
                            //    gdtmCurrentShiftEndTime = gdtmCurrentShiftStartTime.AddDays(1).AddSeconds(-1);
                            //    //End
                            //}
                            gstrCurrentShiftStartTime = inClk_Date + " " + Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]);
                            gdtmCurrentShiftStartTime = DateTime.Parse(gstrCurrentShiftStartTime, CI);
                            for (int i = 1; i <= gintWeeklyOffShiftCount; i++)
                            {
                                if (dtShift.Rows[0]["24HrsShift"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["24HrsShift"]) != string.Empty)
                                {
                                    if (Convert.ToString(dtShift.Rows[0]["24HrsShift"]) == "True")
                                    {
                                        gdtmCurrentShiftStartTime = gdtmCurrentShiftStartTime.Add(tsWeeklyOffStartHours_24HrsShift).AddSeconds(1);
                                    }
                                    else
                                    {
                                        gdtmCurrentShiftStartTime = gdtmCurrentShiftStartTime.Add(tsMaxHoursNextDayIsWeeklyOff).AddSeconds(1);
                                    }
                                }
                                else
                                {
                                    gdtmCurrentShiftStartTime = gdtmCurrentShiftStartTime.Add(tsMaxHoursNextDayIsWeeklyOff).AddSeconds(1);
                                }
                                gdtmCurrentShiftEndTime = gdtmCurrentShiftStartTime.AddDays(1).AddSeconds(-1);
                                //End
                            }
                        }
                    }
                }
                if (intShiftId == -1)
                {
                    if (gstrWeeklyOffDate == string.Empty)
                    {
                        gstrWeeklyOffDate = inClk_Date;
                    }
                    gintWeeklyOffShiftCount = gintWeeklyOffShiftCount + 1;
                    GetCurrentDateShiftStartTimeEndTime(inClk_EmpId, DateTime.Parse(inClk_Date, CI).AddDays(-1).ToShortDateString(), Clk_time);
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "GetCurrentDateShiftStartTimeEndTime ; SwipeCardNo : " + inClk_EmpId + "; Date : " + inClk_Date + "; Error : " + ex.ToString());
                throw ex;
            }
        }
        #endregion
        #region GetNextDateShiftStartTimeEndTime
        public void GetNextDateShiftStartTimeEndTime(string inClk_EmpId, string inClk_Date, string Clk_time)
        {
            DataTable dtShift = new DataTable();
            string strSQLShiftStartTime = string.Empty;
            int intShiftId = 0;
            gstrNextShiftStartTime = string.Empty;
            gstrNextShiftEndTime = string.Empty;
            gdtmNextShiftStartTime = new DateTime();
            gdtmNextShiftEndTime = new DateTime();
            try
            {
                intShiftId = GetShiftId(inClk_EmpId, inClk_Date, Clk_time);
                //Check Next Day is Weekly Off
                if (gstrNextDayIsWeeklyOff == string.Empty)
                {
                    gintNextDayShiftId = GetShiftId(inClk_EmpId, DateTime.Parse(inClk_Date, CI).AddDays(1).ToShortDateString(), Clk_time);
                    if (gintNextDayShiftId == -1)
                    {
                        gstrNextDayIsWeeklyOff = DateTime.Parse(inClk_Date, CI).AddDays(1).ToShortDateString();
                    }
                }
                //End of Weekly Off Checking
                gdtShift.DefaultView.RowFilter = "Shift_Id = " + intShiftId + "";
                dtShift = gdtShift.DefaultView.ToTable();
                if (dtShift.Rows.Count > 0)
                {
                    if (dtShift.Rows[0]["Shift_StartTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]) != string.Empty)
                    {
                        if (gstrWeeklyOffDate == string.Empty)
                        {
                            gstrNextShiftStartTime = inClk_Date + " " + Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]);
                            gdtmNextShiftStartTime = DateTime.Parse(gstrNextShiftStartTime, CI);
                            if (Convert.ToString(dtShift.Rows[0]["24HrsShift"]) != string.Empty)
                                IsNextShift_24Hours = Convert.ToBoolean(dtShift.Rows[0]["24HrsShift"]);
                            //Check Next Day is Weekly Off
                            if (gstrNextDayIsWeeklyOff == string.Empty)
                            {
                                gstrNextShiftEndTime = inClk_Date + " " + Convert.ToString(dtShift.Rows[0]["Shift_EndTime"]);
                                if ((gstrNextShiftStartTime.Substring(9, 2) == "PM") && (gstrNextShiftEndTime.Substring(9, 2) == "AM"))
                                {
                                    gdtmNextShiftEndTime = DateTime.Parse(gstrNextShiftEndTime, CI).AddDays(1);
                                }
                                else
                                {
                                    gdtmNextShiftEndTime = DateTime.Parse(gstrNextShiftEndTime, CI);
                                }
                            }
                            else
                            {
                                //16 Hours would be parameterized in Shift Settings
                                if (gintWeeklyOffShiftCount == 0)
                                {
                                    if (dtShift.Rows[0]["24HrsShift"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["24HrsShift"]) != string.Empty)
                                    {
                                        if (Convert.ToString(dtShift.Rows[0]["24HrsShift"]) == "True")
                                        {
                                            gstrNextShiftEndTime = Convert.ToString(gdtmNextShiftStartTime.Add(tsWeeklyOffStartHours_24HrsShift));
                                        }
                                        else
                                        {
                                            gstrNextShiftEndTime = Convert.ToString(gdtmNextShiftStartTime.Add(tsMaxHoursNextDayIsWeeklyOff));
                                        }
                                    }
                                    else
                                    {
                                        gstrNextShiftEndTime = Convert.ToString(gdtmNextShiftStartTime.Add(tsMaxHoursNextDayIsWeeklyOff));
                                    }
                                    gdtmNextShiftEndTime = DateTime.Parse(gstrNextShiftEndTime, CI);
                                }
                                if (gintWeeklyOffShiftCount >= 1)
                                {
                                    gstrNextShiftStartTime = inClk_Date + " " + Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]);
                                    if (dtShift.Rows[0]["24HrsShift"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["24HrsShift"]) != string.Empty)
                                    {
                                        if (Convert.ToString(dtShift.Rows[0]["24HrsShift"]) == "True")
                                        {
                                            gdtmNextShiftStartTime = DateTime.Parse(gstrNextShiftStartTime, CI).AddDays(gintWeeklyOffShiftCount - 1).Add(tsWeeklyOffStartHours_24HrsShift).AddSeconds(1);
                                        }
                                        else
                                        {
                                            gdtmNextShiftStartTime = DateTime.Parse(gstrNextShiftStartTime, CI).AddDays(gintWeeklyOffShiftCount - 1).Add(tsMaxHoursNextDayIsWeeklyOff).AddSeconds(1);
                                        }
                                    }
                                    else
                                    {
                                        gdtmNextShiftStartTime = DateTime.Parse(gstrNextShiftStartTime, CI).AddDays(gintWeeklyOffShiftCount - 1).Add(tsMaxHoursNextDayIsWeeklyOff).AddSeconds(1);
                                    }
                                    gdtmNextShiftEndTime = gdtmNextShiftStartTime.AddDays(1).AddSeconds(-1);
                                }
                            }
                            //End of Weekly Off Checking
                        }
                        else
                        {
                            if (gintWeeklyOffShiftCount >= 1)
                            {
                                gstrNextShiftStartTime = inClk_Date + " " + Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]);
                                if (dtShift.Rows[0]["24HrsShift"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["24HrsShift"]) != string.Empty)
                                {
                                    if (Convert.ToString(dtShift.Rows[0]["24HrsShift"]) == "True")
                                    {
                                        gdtmNextShiftStartTime = DateTime.Parse(gstrNextShiftStartTime, CI).AddDays(gintWeeklyOffShiftCount - 1).Add(tsWeeklyOffStartHours_24HrsShift).AddSeconds(1);
                                    }
                                    else
                                    {
                                        gdtmNextShiftStartTime = DateTime.Parse(gstrNextShiftStartTime, CI).AddDays(gintWeeklyOffShiftCount - 1).Add(tsMaxHoursNextDayIsWeeklyOff).AddSeconds(1);
                                    }
                                }
                                else
                                {
                                    gdtmNextShiftStartTime = DateTime.Parse(gstrNextShiftStartTime, CI).AddDays(gintWeeklyOffShiftCount - 1).Add(tsMaxHoursNextDayIsWeeklyOff).AddSeconds(1);
                                }
                                gdtmNextShiftEndTime = gdtmNextShiftStartTime.AddDays(1).AddSeconds(-1);
                            }
                        }
                    }
                }
                if (intShiftId == -1)
                {
                    if (gstrWeeklyOffDate == string.Empty)
                    {
                        gstrWeeklyOffDate = inClk_Date;
                    }
                    gintWeeklyOffShiftCount = gintWeeklyOffShiftCount + 1;
                    GetNextDateShiftStartTimeEndTime(inClk_EmpId, DateTime.Parse(inClk_Date, CI).AddDays(-1).ToShortDateString(), Clk_time);
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "GetNextDateShiftStartTimeEndTime ; SwipeCardNo : " + inClk_EmpId + "; Date : " + inClk_Date + "; Error : " + ex.ToString());
            }
        }
        #endregion
        #region GetShiftType
        // Function to get the shift type (Free Scan / Function Key) based on the Shift Id
        public bool GetShiftType(int ShiftId)
        {
            bool shiftType = false;
            DataTable dtShiftType = new DataTable();
            gdtShift.DefaultView.RowFilter = "Shift_Id = " + ShiftId;
            dtShiftType = gdtShift.DefaultView.ToTable();
            if (dtShiftType.Rows.Count > 0)
            {
                if (dtShiftType.Rows[0]["ShiftType"] != DBNull.Value && Convert.ToString(dtShiftType.Rows[0]["ShiftType"]) != string.Empty)
                {
                    shiftType = Convert.ToBoolean(Convert.ToString(dtShiftType.Rows[0]["ShiftType"]));
                }
            }
            return shiftType;
        }
        #endregion
        #region GetPunchType
        public string GetPunchType(string inClk_DeviceId, string inClk_Type)
        {
            DataTable dtPunchType = new DataTable();
            string strPunchType = string.Empty;
            try
            {
                SqlParameter pminClk_DeviceId = new SqlParameter("@inClk_DeviceId", inClk_DeviceId);
                SqlParameter pminClk_Type = new SqlParameter("@inClk_Type", inClk_Type);
                SqlParameter[] pmetersPunchTypes = { pminClk_DeviceId, pminClk_Type };
                strPunchType = objDatafunction.GettingScalarValueUsingParameter(pmetersPunchTypes, "Proc_Ta_CheckingSpecificDeviceAndPunchTypeStatus");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "GetPunchType ; DeviceID : " + inClk_DeviceId + "; Type : " + inClk_Type + "; Error : " + ex.ToString());
            }
            return (strPunchType);
        }
        #endregion
        #region GettingPunchTypeRemarks
        public string GettingPunchTypeRemarks(string Clk_Type, string PunchType)
        {
            string returnValue = string.Empty;
            try
            {
                SqlParameter pgClk_Type = new SqlParameter("@Clk_Type", Clk_Type);
                SqlParameter pgPunchType = new SqlParameter("@PunchType", PunchType);
                SqlParameter[] pParams = { pgClk_Type, pgPunchType };
                returnValue = objDatafunction.GettingScalarValueUsingParameter(pParams, "Proc_Ta_GettingPunchTypeRemarks");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "GettingPunchTypeRemarks ; Type : " + Clk_Type + "; PunchType : " + PunchType + "; Error : " + ex.ToString());
            }
            return returnValue;
        }
        #endregion
        #region ReplaceAndInsert
        // **********************************************************************************************************************
        // Purpose :
        //     The ReplaceAndInsert Method is a Recursive Method which is used to Replace IN or OUT Details in the TimeCheck 
        //     Clock Details Table with new Values if new INTIME or OUTTIME lies inbetween the InTime and OutTime in the Clock 
        //     Details Table for a particular Employee. If INTIME or OUTTIME does not lies inbetween, then Insert or Update the 
        //     Details in the Clock Details Table.
        //
        // Inputs  :
        //     inClk_EmpId    - EmployeeID (or) CardID
        //     inClk_DeviceId - DeviceID (or) ReaderID 
        //     inClk_Date     - Date of Punch
        //     inClk_Time     - Time of Punch
        //     inClk_Type     - Clock Type (I-In or O-Out)
        //     inClk_Remarks  - Reason (If Manual Entry)
        //     inClk_User     - EmployeeID (If Manual Entry, then who made the Entry)
        //     inClk_Status   - Entry Status (A - Automatic (or) M - Manual)
        // **********************************************************************************************************************
        public bool ReplaceAndInsert(string inClk_EmpId, string inClk_DeviceId, string inClk_Date, string inClk_Time, string inClk_Type, string inClk_Remarks, string inClk_User, string inClk_Status, Int64 Clk_Id)
        {
            bool blnValueExists = false;
            try
            {
                DataTable dtInDeviceId = new DataTable();
                DataTable dtOutDeviceId = new DataTable();
                DataTable dtInExists = new DataTable();
                string strPunchType = string.Empty, strINorOUTEntry = string.Empty;
                switch (inClk_Type)
                {
                    case "I":
                    case "O":
                        strINorOUTEntry = inClk_Type;
                        strPunchType = inClk_Type;
                        break;
                    default:
                        strPunchType = GetPunchType(inClk_DeviceId, inClk_Type);
                        strINorOUTEntry = GetEquivalentPunchType(strPunchType, "T");
                        break;
                }
                switch (strINorOUTEntry)
                {
                    case "I":
                    case "O":
                        SqlParameter pmPunchType = new SqlParameter("@PunchType", strINorOUTEntry);
                        SqlParameter pminClk_EmpId = new SqlParameter("@inClk_EmpId", inClk_EmpId);
                        SqlParameter pminClk_Date = new SqlParameter("@inClk_Date", inClk_Date);
                        SqlParameter pminClk_Time = new SqlParameter("@inClk_Time", inClk_Time);
                        SqlParameter[] pmetersClockDetails = { pmPunchType, pminClk_EmpId, pminClk_Date, pminClk_Time };
                        dtInExists = objDatafunction.GettingDatasetUsingParameter(pmetersClockDetails, "Proc_TA_CheckingDataExistsOrNotUsingPunchType");
                        if (dtInExists.Rows.Count > 0 && Convert.ToInt32(dtInExists.Rows[0]["RecordCount"]) > 0)
                        {
                            blnValueExists = true;
                        }
                        else
                        {
                            switch (strINorOUTEntry)
                            {
                                case "I":
                                    ReplaceInDetails(Convert.ToString(inClk_EmpId), Convert.ToString(inClk_DeviceId), DateTime.Parse(Convert.ToString(inClk_Date), CI).ToShortDateString(), Convert.ToString(inClk_Time), strPunchType, inClk_Remarks, inClk_User, inClk_Status);
                                    break;
                                case "O":
                                    ReplaceOutDetails(Convert.ToString(inClk_EmpId), Convert.ToString(inClk_DeviceId), DateTime.Parse(Convert.ToString(inClk_Date), CI).ToShortDateString(), Convert.ToString(inClk_Time), strPunchType, inClk_Remarks, inClk_User, inClk_Status);
                                    break;
                            }
                        }
                        break;
                    default:
                        // If punch types is not created for particular device, then Change the Clk_Flag to 0 and Clk_Process to 1, Reasonid to 4
                        UpdateRawDataFlag(Clk_Id, 4, 1, 0, "C");
                        break;
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "ReplaceAndInsert ; SwipeCardNo : " + inClk_EmpId + "; DeviceID : " + inClk_DeviceId + "; Date : " + inClk_Date + "; Time : " + inClk_Time + "; Type : " + inClk_Type + "; Error : " + ex.ToString());
                throw ex;
            }
            return blnValueExists;
        }
        #endregion
        #region GetEquivalentPunchType
        // **********************************************************************************************************************
        // Purpose :
        //     The GetEquivalentPunchType Function is used to get the Equivalent InPunchType for the OutPunchType (or) to get the
        //     Equivalent OutPunchType for the InPunchType
        // Inputs  :
        //     inPunchType - Punch Type 
        // Returns :
        //     If Equivalent PunchType is Present, then
        //        Returns the PunchType
        //     If Equivalent PunchType is not Present, then
        //         Returns Null Value
        // **********************************************************************************************************************
        public string GetEquivalentPunchType(string inPunchType, string inType)
        {
            string strPunchType = string.Empty;
            string strType = string.Empty;
            switch (inPunchType)
            {
                case "In":
                    strPunchType = "Out";
                    strType = "I";
                    break;
                case "Out":
                    strPunchType = "In";
                    strType = "O";
                    break;
                case "Normal In":
                    strPunchType = "Normal Out";
                    strType = "I";
                    break;
                case "Normal Out":
                    strPunchType = "Normal In";
                    strType = "O";
                    break;
                case "Personal In":
                    strPunchType = "Personal Out";
                    strType = "I";
                    break;
                case "Personal Out":
                    strPunchType = "Personal In";
                    strType = "O";
                    break;
                case "Business Out":
                    strPunchType = "Business In";
                    strType = "O";
                    break;
                case "Business In":
                    strPunchType = "Business Out";
                    strType = "I";
                    break;
                case "In Duty":
                    strPunchType = "Out Duty";
                    strType = "O";
                    break;
                case "Out Duty":
                    strPunchType = "In Duty";
                    strType = "I";
                    break;
                case "Shift In":
                    strPunchType = "Shift Out";
                    strType = "I";
                    break;
                case "Shift Out":
                    strPunchType = "Shift In";
                    strType = "O";
                    break;
                case "Break In":
                    strPunchType = "Break Out";
                    strType = "I";
                    break;
                case "Break Out":
                    strPunchType = "Break In";
                    strType = "O";
                    break;
                case "Lunch In":
                    strPunchType = "Lunch Out";
                    strType = "I";
                    break;
                case "Lunch Out":
                    strPunchType = "Lunch In";
                    strType = "O";
                    break;
                case "Official In":
                    strPunchType = "Official Out";
                    strType = "O";
                    break;
                case "Official Out":
                    strPunchType = "Official In";
                    strType = "I";
                    break;
            }
            if (inType == "P")
            {
                return strPunchType;
            }
            else if (inType == "T")
            {
                return strType;
            }
            else
            {
                return string.Empty;
            }
        }
        #endregion
        #region ReplaceInDetails
        public void ReplaceInDetails(string inClk_EmpId, string inClk_DeviceId, string inClk_Date, string inClk_Time, string inClk_Type, string inClk_Remarks, string inClk_User, string inClk_Status)
        {
            DataTable dtCheckInTime;
            string strSQLUpdate, strSQLCheckInTime = string.Empty, strSQLInTime = string.Empty;
            string strOutDeviceId = string.Empty, strInDateTime = string.Empty;
            // Get the Equivalent OutDeviceID for the InDeviceID.
            try
            {
                strOutDeviceId = GetEquivalentDeviceId(inClk_DeviceId, "I");
                if (strOutDeviceId != string.Empty)
                {
                    strInDateTime = inClk_Date + ' ' + inClk_Time;
                    // Check whether the InTime lies inbetween any InTime and OutTime in the Clock Details Table for particular Employee
                    dtCheckInTime = GettingNonMappedData(inClk_EmpId, strOutDeviceId, strInDateTime, "I");
                    /* 
                     * If InTime lies inbetween, then Replace this In Details in the ClockDetails Table and Store the Old In Details
                     * in the Temporary Variable and insert the Old Details.
                     * If InTime does not lies inbetween any Transaction, then the IN Details are send to the InsertInDetails Function.
                    */
                    if (dtCheckInTime.Rows.Count > 0)
                    {
                        string strEmpId = string.Empty, strClk_InDeviceId = string.Empty, strClk_InDate = string.Empty, strClk_InTime = string.Empty;
                        string strclkInpunchType = string.Empty;
                        // Stores the Old IN Details from the Clock Details Table in Temporary Variables.
                        if (dtCheckInTime.Rows[0]["Clk_EmpId"] != DBNull.Value && Convert.ToString(dtCheckInTime.Rows[0]["Clk_EmpId"]) != string.Empty)
                        {
                            strEmpId = Convert.ToString(dtCheckInTime.Rows[0]["Clk_EmpId"]);
                        }
                        if (dtCheckInTime.Rows[0]["Clk_InDeviceId"] != DBNull.Value && Convert.ToString(dtCheckInTime.Rows[0]["Clk_InDeviceId"]) != string.Empty)
                        {
                            strClk_InDeviceId = Convert.ToString(dtCheckInTime.Rows[0]["Clk_InDeviceId"]);
                        }
                        if (dtCheckInTime.Rows[0]["Clk_InDate"] != DBNull.Value && Convert.ToString(dtCheckInTime.Rows[0]["Clk_InDate"]) != string.Empty)
                        {
                            strClk_InDate = DateTime.Parse(Convert.ToString(dtCheckInTime.Rows[0]["Clk_InDate"]), CI).ToShortDateString();
                        }
                        if (dtCheckInTime.Rows[0]["Clk_InTime"] != DBNull.Value && Convert.ToString(dtCheckInTime.Rows[0]["Clk_InTime"]) != string.Empty)
                        {
                            strClk_InTime = DateTime.Parse(Convert.ToString(dtCheckInTime.Rows[0]["Clk_InTime"]), CI).ToLongTimeString();
                        }
                        if (dtCheckInTime.Rows[0]["Clk_InPunchType"] != DBNull.Value && Convert.ToString(dtCheckInTime.Rows[0]["Clk_InPunchType"]) != string.Empty)
                        {
                            strclkInpunchType = Convert.ToString(dtCheckInTime.Rows[0]["Clk_InPunchType"]);
                        }
                        if (strEmpId != string.Empty && strClk_InDeviceId != string.Empty && strClk_InDate != string.Empty && strClk_InTime != string.Empty)
                        {
                            // Replaces the IN Details in the Clock Details Table.
                            UpdateInAndOutDetailsIntoClockDetails(inClk_DeviceId, inClk_Date, inClk_Time, inClk_Type, inClk_Remarks, inClk_User, gstrClockDate, inClk_Status, Convert.ToString(dtCheckInTime.Rows[0]["Clk_Id"]), "I", 0, "");
                            // Insert Old IN Details in the Clock Details Table
                            InsertInAndOutDetails(strEmpId, strClk_InDeviceId, DateTime.Parse(strClk_InDate, CI).ToShortDateString(), strClk_InTime, Convert.ToString(strclkInpunchType), inClk_Remarks, inClk_User, inClk_Status, "I", "");
                        }
                    }
                    else
                    {
                        // If the IN Details does not lies inbetween, then call the below Function to Insert or Update the Details
                        InsertUpdateInDetails(inClk_EmpId, inClk_DeviceId, DateTime.Parse(Convert.ToString(inClk_Date), CI).ToShortDateString(), Convert.ToString(inClk_Time), Convert.ToString(inClk_Type), inClk_Remarks, inClk_User, inClk_Status, strOutDeviceId);
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "ReplaceInDetails ; SwipeCardNo : " + inClk_EmpId + "; DeviceID : " + inClk_DeviceId + "; Date : " + inClk_Date + "; Time : " + inClk_Time + "; Type : " + inClk_Type + "; Error : " + ex.ToString());
            }
        }
        #endregion
        #region GettingNonMappedData
        public DataTable GettingNonMappedData(string inClk_EmpId, string strInDeviceId, string strOutDateTime, string Type)
        {
            DataTable dsNonMappedData = new DataTable();
            try
            {
                SqlParameter pminClk_EmpId = new SqlParameter("@inClk_EmpId", inClk_EmpId);
                SqlParameter pmstrOutDeviceId = new SqlParameter("@strOutDeviceId", strInDeviceId);
                SqlParameter pmstrInDateTime = new SqlParameter("@strInDateTime", strOutDateTime);
                SqlParameter pmType = new SqlParameter("@Type", Type);
                SqlParameter[] pmetersClockDetails = { pminClk_EmpId, pmstrOutDeviceId, pmstrInDateTime, pmType };
                dsNonMappedData = objDatafunction.GettingDatasetUsingParameter(pmetersClockDetails, "Proc_TA_GettingDataFromClockDetails");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "GettingNonMappedData ; SwipeCardNo : " + inClk_EmpId + "; DeviceID : " + strInDeviceId + "; InDateTime : " + strOutDateTime + ";Error : " + ex.ToString());
            }
            return dsNonMappedData;
        }
        #endregion
        #region UpdateInDetails
        /// <summary>
        /// Update In and Out Punches details into clock details table
        /// </summary>
        /// <param name="inClk_DeviceId"></param>
        /// <param name="inClk_Date"></param>
        /// <param name="inClk_Time"></param>
        /// <param name="inPunchType"></param>
        /// <param name="inClk_Remarks"></param>
        /// <param name="inClk_User"></param>
        /// <param name="gstrClockDate"></param>
        /// <param name="inClk_Status"></param>
        /// <param name="clockID"></param>
        /// <param name="type"></param>
        /// <param name="RecordFromClockdetails"></param>
        /// <param name="strPunchTypeRemarksId"></param>
        public void UpdateInAndOutDetailsIntoClockDetails(string inClk_DeviceId, string inClk_Date, string inClk_Time, string inPunchType, string inClk_Remarks, string inClk_User, string gstrClockDate, string inClk_Status, string clockID, string type, int RecordFromClockdetails, string strPunchTypeRemarksId)
        {
            try
            {
                SqlParameter pminClk_DeviceId = new SqlParameter("@inClk_DeviceId", inClk_DeviceId);
                SqlParameter pminClk_Date = new SqlParameter("@inClk_Date", inClk_Date);
                SqlParameter pminClk_Time = new SqlParameter("@inClk_Time", inClk_Time);
                SqlParameter pminClk_Type = new SqlParameter("@inClk_Type", inPunchType);
                SqlParameter pminClk_Remarks = new SqlParameter("@inClk_Remarks", inClk_Remarks);
                SqlParameter pminClk_User = new SqlParameter("@inClk_User", inClk_User);
                SqlParameter pmgstrClockDate = new SqlParameter("@gstrClockDate", gstrClockDate);
                SqlParameter pminClk_Status = new SqlParameter("@inClk_Status", inClk_Status);
                SqlParameter pmClk_Id = new SqlParameter("@Clk_Id", clockID);
                SqlParameter pmType = new SqlParameter("@Type", type);
                SqlParameter pmRecordFromClockdetails = new SqlParameter("@RecordFromClockdetails", RecordFromClockdetails);
                SqlParameter pmstrPunchTypeRemarksId = new SqlParameter("@strPunchTypeRemarksId", strPunchTypeRemarksId);
                SqlParameter[] pmetersClockDetails = { pminClk_DeviceId, pminClk_Date, pminClk_Time, pminClk_Type, pminClk_Remarks, pminClk_User, pmgstrClockDate, pminClk_Status, pmClk_Id, pmType, pmRecordFromClockdetails, pmstrPunchTypeRemarksId };
                objDatafunction.ExecuteQueryUsingParameter(pmetersClockDetails, "Proc_TA_UpdateInAndOutPunchDetails");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "UpdateInAndOutDetailsIntoClockDetails; Type : " + type + ";Status : " + inClk_Status + ";ClockDate : " + gstrClockDate + ";User : " + inClk_User + ";Remarks : " + inClk_Remarks + ";Clk_Id : " + clockID + " ; DeviceID : " + inClk_DeviceId + "; Date : " + inClk_Date + "; Time : " + inClk_Time + "; PunchType : " + inPunchType + "; Error : " + ex.ToString());
            }
        }
        #endregion
        #region InsertInAndOutDetails
        // **********************************************************************************************************************
        // Purpose :
        //     The InsertInDetails Method is a used to Insert the IN Details into the TimeCheck Clock Details Table 
        //
        // Inputs  :
        //     inClk_EmpId    - EmployeeID (or) CardID
        //     inClk_DeviceId - DeviceID (or) ReaderID 
        //     inClk_Date     - Date of Punch
        //     inClk_Time     - Time of Punch
        //     inClk_Type     - Clock Type (I-In or O-Out)
        //     inClk_Remarks  - Reason (If Manual Entry)
        //     inClk_User     - EmployeeID (If Manual Entry, then who made the Entry)
        //     inClk_Status   - Entry Status (A - Automatic (or) M - Manual)
        // **********************************************************************************************************************
        public void InsertInAndOutDetails(string inClk_EmpId, string inClk_DeviceId, string inClk_Date, string inClk_Time, string inPunchType, string inClk_Remarks, string inClk_User, string inClk_Status, string Type, string PunchType_Remarks)
        {
            // Insert IN and Out Record into the Clock Details Table
            try
            {
                SqlParameter pmgstrCompanyId = new SqlParameter("@gstrCompanyId", gstrCompanyId);
                SqlParameter pminClk_EmpId = new SqlParameter("@inClk_EmpId", inClk_EmpId);
                SqlParameter pminClk_DeviceId = new SqlParameter("@inClk_DeviceId", inClk_DeviceId);
                SqlParameter pminClk_Date = new SqlParameter("@inClk_Date", inClk_Date);
                SqlParameter pminClk_Time = new SqlParameter("@inClk_Time", inClk_Time);
                SqlParameter pminPunchType = new SqlParameter("@inPunchType", inPunchType);
                SqlParameter pmgstrClockDate = new SqlParameter("@gstrClockDate", gstrClockDate);
                SqlParameter pminClk_Remarks = new SqlParameter("@inClk_Remarks", inClk_Remarks);
                SqlParameter pminClk_User = new SqlParameter("@inClk_User", inClk_User);
                SqlParameter pminClk_Status = new SqlParameter("@inClk_Status", inClk_Status);
                SqlParameter pmType = new SqlParameter("@Type", Type);
                SqlParameter pmPunchType_Remarks = new SqlParameter("@PunchType_Remarks", PunchType_Remarks);
                SqlParameter[] pmetersClockDetails = { pmgstrCompanyId, pminClk_EmpId, pminClk_DeviceId, pminClk_Date, pminClk_Time, pminPunchType, pmgstrClockDate, pminClk_Remarks, pminClk_User, pminClk_Status, pmType, pmPunchType_Remarks };
                objDatafunction.ExecuteQueryUsingParameter(pmetersClockDetails, "Proc_TA_InsertInAndOutPunchDetails");
                gstrCompanyId = string.Empty;
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "InsertInAndOutDetails(SwipeCardNo: " + inClk_EmpId + ";DeviceID: " + inClk_DeviceId + ";Date: " + inClk_Date + ";Time: " + inClk_Time + ";PunchType: " + inPunchType + "); Error : " + ex.ToString());
            }
        }
        #endregion
        #region InsertUpdateInDetails
        // **********************************************************************************************************************
        // Purpose :
        //     The InsertUpdateInDetails Method is a used to Insert the IN Details into the TimeCheck Clock Details Table (or)
        //     Update the Clock Details Table with IN Details such a way that InTime is closest to the OutTime and with matching 
        //     OutDeviceId for a particular Employee
        //
        // Inputs  :
        //     inClk_EmpId    - EmployeeID (or) CardID
        //     inClk_DeviceId - DeviceID (or) ReaderID 
        //     inClk_Date     - Date of Punch
        //     inClk_Time     - Time of Punch
        //     inClk_Type     - Clock Type (I-In or O-Out)
        //     inClk_Remarks  - Reason (If Manual Entry)
        //     inClk_User     - EmployeeID (If Manual Entry, then who made the Entry)
        //     inClk_Status   - Entry Status (A - Automatic (or) M - Manual)
        // **********************************************************************************************************************
        public void InsertUpdateInDetails(string inClk_EmpId, string inClk_DeviceId, string inClk_Date, string inClk_Time, string inType, string inClk_Remarks, string inClk_User, string inClk_Status, string inOutDeviceId)
        {
            DataTable dtClockIn;
            DataTable dtCheck;
            DataTable dtOutDeviceId = new DataTable();
            string strSQLIn = string.Empty, strSQLClockDetailsUpdate = string.Empty, strSQLClockDetailsInsert = string.Empty;
            string strOutDeviceId = string.Empty, strInDateTime = string.Empty, strInPunchType = string.Empty;
            string strInsertFlag = "N";
            try
            {
                strInPunchType = inType;
                strOutDeviceId = inOutDeviceId;
                if (strOutDeviceId != string.Empty)
                {
                    strInDateTime = inClk_Date + ' ' + inClk_Time;
                    /*
                     * Check for Records in the Clock Details Table where Clk_InTime is Null and Clk_OutTime is not Null and Clk_OutTime > InTime
                     * and Clk_OutDate >= InDate and Difference between InTime and OutTime should be less than or equal to 24 (and) Greater than equal to 0.
                     * If Records does not Exist, the Insert the IN Record
                     * Else Update the Clock Details Table with In Record with Minimum Clk_OutTime
                    */
                    dtClockIn = CheckingDataAlreadyExists(inClk_EmpId, strOutDeviceId, strInDateTime, gstrClockDate, "I");
                    if (dtClockIn.Rows.Count == 0)
                    {
                        strInsertFlag = "Y";
                    }
                    else
                    {
                        if (dtClockIn.Rows[0]["Clk_OutDate"] != DBNull.Value && dtClockIn.Rows[0]["Clk_OutTime"] != DBNull.Value)
                        {
                            if (Convert.ToString(dtClockIn.Rows[0]["Clk_OutDate"]) != string.Empty && Convert.ToString(dtClockIn.Rows[0]["Clk_OutTime"]) != string.Empty)
                            {
                                string strOutDateTime = DateTime.Parse(Convert.ToString(dtClockIn.Rows[0]["Clk_OutDate"]), CI).ToShortDateString() + " " + DateTime.Parse(Convert.ToString(dtClockIn.Rows[0]["Clk_OutTime"]), CI).ToLongTimeString();
                                dtCheck = CheckingAnyNonMappedDataExists(strInDateTime, strOutDateTime, inClk_EmpId, "I");
                                if (Convert.ToInt32(dtCheck.Rows[0]["RecordCount"]) > 0)
                                {
                                    strInsertFlag = "Y";
                                }
                                else
                                {
                                    // Update the Clock Details Table with IN Record.
                                    UpdateInAndOutDetailsIntoClockDetails(inClk_DeviceId, inClk_Date, inClk_Time, strInPunchType, inClk_Remarks, inClk_User, gstrClockDate, inClk_Status, Convert.ToString(dtClockIn.Rows[0]["Clk_Id"]), "I", 0, "");
                                }
                            }
                        }
                    }
                    if (strInsertFlag == "Y")
                    {
                        InsertInAndOutDetails(Convert.ToString(inClk_EmpId), Convert.ToString(inClk_DeviceId), DateTime.Parse(Convert.ToString(inClk_Date), CI).ToShortDateString(), Convert.ToString(inClk_Time), strInPunchType, inClk_Remarks, inClk_User, inClk_Status, "I", "");
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "InsertUpdateInDetails ; SwipeCardNo : " + inClk_EmpId + " ; DeviceID : " + inClk_DeviceId + "; Date : " + inClk_Date + "; Time : " + inClk_Time + "; Type : " + inType + "; OutDeviceId : " + inOutDeviceId + "; Error : " + ex.ToString());
            }
        }
        #endregion
        #region CheckingDataAlreadyExists
        public DataTable CheckingDataAlreadyExists(string inClk_EmpId, string strInDeviceId, string strOutDateTime, string gstrClockDate, string Type)
        {
            DataTable dtData = new DataTable();
            try
            {
                SqlParameter pminClk_EmpId = new SqlParameter("@inClk_EmpId", inClk_EmpId);
                SqlParameter pmstrOutDeviceId = new SqlParameter("@strOutDeviceId", strInDeviceId);
                SqlParameter pmstrInDateTime = new SqlParameter("@strInDateTime", strOutDateTime);
                SqlParameter pmgstrClockDate = new SqlParameter("@gstrClockDate", gstrClockDate);
                SqlParameter pmType = new SqlParameter("@Type", Type);
                SqlParameter[] pmetersClockDetails = { pminClk_EmpId, pmstrOutDeviceId, pmstrInDateTime, pmgstrClockDate, pmType };
                dtData = objDatafunction.GettingDatasetUsingParameter(pmetersClockDetails, "Proc_TA_CheckingDataExistsAlready");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "CheckingDataAlreadyExists(Type:" + inClk_EmpId + ";SwipeCardNo:" + inClk_EmpId + ";DeviceID: " + strInDeviceId + ";Date: " + gstrClockDate + ";Time: " + strOutDateTime + ");Error : " + ex.ToString());
            }
            return dtData;
        }
        #endregion
        #region CheckingAnyNonMappedDataExists
        public DataTable CheckingAnyNonMappedDataExists(string strInDateTime, string strOutDateTime, string inClk_EmpId, string Type)
        {
            DataTable dtCheck = new DataTable();
            try
            {
                SqlParameter pm_strInDateTime = new SqlParameter("@strInDateTime", strInDateTime);
                SqlParameter pm_strOutDateTime = new SqlParameter("@strOutDateTime", strOutDateTime);
                SqlParameter pm_inClk_EmpId = new SqlParameter("@inClk_EmpId", inClk_EmpId);
                SqlParameter pmType = new SqlParameter("@Type", Type);
                SqlParameter[] pmeters_ClockDetails = { pm_strInDateTime, pm_strOutDateTime, pm_inClk_EmpId, pmType };
                dtCheck = objDatafunction.GettingDatasetUsingParameter(pmeters_ClockDetails, "Proc_TA_CheckingAnyNonMappedInDataExists");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "CheckingAnyNonMappedDataExists(Type: " + Type + ";SwipeCardNo: " + inClk_EmpId + ";InDateTime: " + strInDateTime + ";OutDateTime: " + strOutDateTime + ");Error : " + ex.ToString());
                throw ex;
            }
            return dtCheck;
        }
        #endregion
        #region ReplaceOutDetails
        public void ReplaceOutDetails(string inClk_EmpId, string inClk_DeviceId, string inClk_Date, string inClk_Time, string inClk_Type, string inClk_Remarks, string inClk_User, string inClk_Status)
        {
            DataTable dtCheckOutTime;
            string strSQLCheckOutTime = string.Empty, strSQLOutTime = string.Empty;
            string strInDeviceId = string.Empty, strOutDateTime = string.Empty;
            try
            {
                // Get the Equivalent InDeviceID for the OutDeviceID.
                strInDeviceId = GetEquivalentDeviceId(inClk_DeviceId, "O");
                if (strInDeviceId != string.Empty)
                {
                    //Changing the datetime (manual indate & outdate with common SQL format yyyy-MM-dd by Manjula.P on 24-Mar-2015)
                    strOutDateTime = DateTime.Parse(inClk_Date, CI).ToShortDateString() + ' ' + inClk_Time;
                    // Check whether the OutTime lies inbetween any InTime and OutTime in the Clock Details Table for a particular Employee
                    dtCheckOutTime = GettingNonMappedData(inClk_EmpId, strInDeviceId, strOutDateTime, "O");
                    /* 
                     * If OutTime lies inbetween, then Replace this Out Details in the ClockDetails Table and Store the Old Out Details
                     * in the Temporary Variable and send this Old Details to the ReplaceAndInsert Function.
                     * If OutTime does not lies inbetween any Transaction, then the OUT Details are send to the InsertOutDetails Function.
                    */
                    if (dtCheckOutTime.Rows.Count > 0)
                    {
                        string strEmpId = string.Empty, strClk_OutDeviceId = string.Empty, strClk_OutDate = string.Empty, strClk_OutTime = string.Empty;
                        string strOldClk_Remarks = string.Empty;
                        // Stores the Old OUT Details from the Clock Details Table in Temporary Variables.
                        if (dtCheckOutTime.Rows[0]["Clk_EmpId"] != DBNull.Value && Convert.ToString(dtCheckOutTime.Rows[0]["Clk_EmpId"]) != string.Empty)
                        {
                            strEmpId = Convert.ToString(dtCheckOutTime.Rows[0]["Clk_EmpId"]);
                        }
                        if (dtCheckOutTime.Rows[0]["Clk_OutDeviceId"] != DBNull.Value && Convert.ToString(dtCheckOutTime.Rows[0]["Clk_OutDeviceId"]) != string.Empty)
                        {
                            strClk_OutDeviceId = Convert.ToString(dtCheckOutTime.Rows[0]["Clk_OutDeviceId"]);
                        }
                        if (dtCheckOutTime.Rows[0]["Clk_OutDate"] != DBNull.Value && Convert.ToString(dtCheckOutTime.Rows[0]["Clk_OutDate"]) != string.Empty)
                        {
                            strClk_OutDate = DateTime.Parse(Convert.ToString(dtCheckOutTime.Rows[0]["Clk_OutDate"]), CI).ToShortDateString();
                        }
                        if (dtCheckOutTime.Rows[0]["Clk_OutTime"] != DBNull.Value && Convert.ToString(dtCheckOutTime.Rows[0]["Clk_OutTime"]) != string.Empty)
                        {
                            strClk_OutTime = DateTime.Parse(Convert.ToString(dtCheckOutTime.Rows[0]["Clk_OutTime"]), CI).ToLongTimeString();
                        }
                        if (dtCheckOutTime.Rows[0]["PunchType_Remarks"] != DBNull.Value && Convert.ToString(dtCheckOutTime.Rows[0]["PunchType_Remarks"]) != string.Empty)
                        {
                            strOldPunchTypeRemarksId = Convert.ToString(dtCheckOutTime.Rows[0]["PunchType_Remarks"]);
                        }
                        if (dtCheckOutTime.Rows[0]["Clk_Remarks"] != DBNull.Value && Convert.ToString(dtCheckOutTime.Rows[0]["Clk_Remarks"]) != string.Empty)
                        {
                            strOldClk_Remarks = Convert.ToString(dtCheckOutTime.Rows[0]["Clk_Remarks"]);
                        }
                        if (strEmpId != string.Empty && strClk_OutDeviceId != string.Empty && strClk_OutDate != string.Empty && strClk_OutTime != string.Empty)
                        {
                            // Replaces the OUT Details in the Clock Details Table.
                            UpdateInAndOutDetailsIntoClockDetails(inClk_DeviceId, inClk_Date, inClk_Time, inClk_Type, inClk_Remarks, inClk_User, "", inClk_Status, Convert.ToString(dtCheckOutTime.Rows[0]["Clk_Id"]), "O", RecordFromClockdetails, strPunchTypeRemarksId);
                            //Added by Manikandan.R //on 16-10-2014 02:59 PM
                            strPunchTypeRemarksId = string.Empty;
                            // Insert Old OUT Details stored in the Temporary Variables
                            InsertOutDetails(strEmpId, strClk_OutDeviceId, DateTime.Parse(strClk_OutDate, CI).ToShortDateString(), strClk_OutTime, Convert.ToString(inClk_Type), inClk_Remarks, inClk_User, inClk_Status);
                        }
                    }
                    else
                    {
                        // If the OUT Details does not lies inbetween, then call the below Function to Insert or Update the Details
                        InsertUpdateOutDetails(Convert.ToString(inClk_EmpId), Convert.ToString(inClk_DeviceId), DateTime.Parse(Convert.ToString(inClk_Date), CI).ToShortDateString(), Convert.ToString(inClk_Time), Convert.ToString(inClk_Type), inClk_Remarks, inClk_User, inClk_Status, strInDeviceId);
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "ReplaceOutDetails ; SwipeCardNo : " + inClk_EmpId + "; DeviceID : " + inClk_DeviceId + "; Date : " + inClk_Date + "; Time : " + inClk_Time + "; Type : " + inClk_Type + "; Error : " + ex.ToString());
                throw ex;
            }
        }
        #endregion
        #region InsertOutDetails
        public void InsertOutDetails(string inClk_EmpId, string inClk_DeviceId, string inClk_Date, string inClk_Time, string inType, string inClk_Remarks, string inClk_User, string inClk_Status)
        {
            string PunchType_Remarks = "";
            try
            {
                //Insert OUT Record into the Clock Details Table
                if (strOldPunchTypeRemarksId != string.Empty)
                {
                    PunchType_Remarks = strOldPunchTypeRemarksId;
                }
                else if (RecordFromClockdetails != 0)
                {
                    PunchType_Remarks = strPunchTypeRemarksId;
                }
                else
                {
                    PunchType_Remarks = "";
                }
                InsertInAndOutDetails(inClk_EmpId, inClk_DeviceId, inClk_Date, inClk_Time, inType, inClk_Remarks, inClk_User, inClk_Status, "O", PunchType_Remarks);
                gstrCompanyId = string.Empty;
                strPunchTypeRemarksId = string.Empty;
                strOldPunchTypeRemarksId = string.Empty;
                RecordFromClockdetails = 0;
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "InsertOutDetails(PunchType_Remarks: " + PunchType_Remarks + ";Clk_Status: " + inClk_Status + ";Clk_User: " + inClk_User + ";Clk_Remarks: " + inClk_Remarks + ";SwipeCardNo: " + inClk_EmpId + ";DeviceID: " + inClk_DeviceId + ";Date: " + inClk_Date + ";Time: " + inClk_Time + ";Type: " + inType + ";)Error : " + ex.ToString());
            }
        }
        #endregion
        #region InsertUpdateOutDetails
        // **********************************************************************************************************************
        // Purpose :
        //     The InsertUpdateOutDetails Method is a used to Insert the OUT Details into the TimeCheck Clock Details Table (or)
        //     Update the Clock Details Table with OUT Details such a way that OutTime is closest to the InTime and with matching 
        //     InDeviceId for a particular Employee
        //
        // Inputs  :
        //     inClk_EmpId    - EmployeeID (or) CardID
        //     inClk_DeviceId - DeviceID (or) ReaderID 
        //     inClk_Date     - Date of Punch
        //     inClk_Time     - Time of Punch
        //     inClk_Type     - Clock Type (I-In or O-Out)
        //     inClk_Remarks  - Reason (If Manual Entry)
        //     inClk_User     - EmployeeID (If Manual Entry, then who made the Entry)
        //     inClk_Status   - Entry Status (A - Automatic (or) M - Manual)
        // **********************************************************************************************************************
        public void InsertUpdateOutDetails(string inClk_EmpId, string inClk_DeviceId, string inClk_Date, string inClk_Time, string inType, string inClk_Remarks, string inClk_User, string inClk_Status, string inInDeviceId)
        {
            DataTable dtClockOut;
            DataTable dtCheck;
            DataTable dtInDeviceId = new DataTable();
            string strSQLOut = string.Empty, strSQLClockDetailsUpdate = string.Empty;
            string strSQLClockDetailsInsert = string.Empty, strInDeviceId = string.Empty;
            string strOutDateTime = string.Empty, strOutPunchType = string.Empty;
            string strInsertFlag = "N";
            try
            {
                strOutPunchType = inType;
                strInDeviceId = inInDeviceId;
                if (strInDeviceId != string.Empty)
                {
                    strOutDateTime = DateTime.Parse(inClk_Date, CI).ToShortDateString() + ' ' + inClk_Time;
                    /*
                    * Check for Records in the Clock Details Table where Clk_OutTime is Null and Clk_InTime is not Null and Clk_InTime < OutTime
                    * and Clk_InDate <= OutDate and Difference between InTime and OutTime should be less than or equal to 24 (and) Greater than equal to 0.
                    * If Records does not Exist, the Insert the OUT Record
                    * Else Update the Clock Details Table with OUT Record with Maximum Clk_InTime
                    */
                    dtClockOut = CheckingDataAlreadyExists(inClk_EmpId, strInDeviceId, strOutDateTime, DateTime.Parse(gstrClockDate, CI).ToShortDateString(), "O");
                    if (dtClockOut.Rows.Count == 0)
                    {
                        strInsertFlag = "Y";
                    }
                    else
                    {
                        if (dtClockOut.Rows[0]["Clk_InDate"] != DBNull.Value && dtClockOut.Rows[0]["Clk_InTime"] != DBNull.Value)
                        {
                            if (Convert.ToString(dtClockOut.Rows[0]["Clk_InDate"]) != string.Empty && Convert.ToString(dtClockOut.Rows[0]["Clk_InTime"]) != string.Empty)
                            {
                                string strInDateTime = DateTime.Parse(Convert.ToString(dtClockOut.Rows[0]["Clk_InDate"]), CI).ToShortDateString() + " " + DateTime.Parse(Convert.ToString(dtClockOut.Rows[0]["Clk_InTime"]), CI).ToLongTimeString();
                                dtCheck = CheckingAnyNonMappedDataExists(strInDateTime, strOutDateTime, inClk_EmpId, "O");
                                if (Convert.ToInt32(dtCheck.Rows[0]["RecordCount"]) > 0)
                                {
                                    strInsertFlag = "Y";
                                }
                                else
                                {
                                    // Update the Clock Details Table with OUT Record.
                                    UpdateInAndOutDetailsIntoClockDetails(inClk_DeviceId, DateTime.Parse(inClk_Date, CI).ToShortDateString(), inClk_Time, strOutPunchType, inClk_Remarks, inClk_User, "", inClk_Status, Convert.ToString(dtClockOut.Rows[0]["Clk_Id"]), "O", RecordFromClockdetails, strPunchTypeRemarksId);
                                }
                            }
                        }
                    }
                    if (strInsertFlag == "Y")
                    {
                        InsertOutDetails(Convert.ToString(inClk_EmpId), Convert.ToString(inClk_DeviceId), DateTime.Parse(Convert.ToString(inClk_Date), CI).ToShortDateString(), Convert.ToString(inClk_Time), strOutPunchType, inClk_Remarks, inClk_User, inClk_Status);
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "InsertUpdateOutDetails(SwipeCardNo: " + inClk_EmpId + ";DeviceID: " + inClk_DeviceId + ";Date: " + inClk_Date + ";Time: " + inClk_Time + ";Type: " + inType + ";InDeviceId: " + inInDeviceId + ");Error : " + ex.ToString());
            }
        }
        #endregion
        #region MappingPunches
        public void MappingPunches(string inClk_EmpId, string inClk_DeviceId, string inClk_Date, string inClk_Time, string inClk_Type, string clk_date)
        {
            try
            {
                SqlParameter pgEmpid = new SqlParameter("@clk_empid", inClk_EmpId);
                SqlParameter pgDeviceID = new SqlParameter("@clk_InOrOutDeviceId", inClk_DeviceId);
                SqlParameter pgInOrOutDate = new SqlParameter("@clk_InOrOutDate", inClk_Date);
                SqlParameter pgInOrOutTime = new SqlParameter("@clk_InOrOutTime", inClk_Time);
                SqlParameter pgInOrOutPunchType = new SqlParameter("@clk_InOrOutPunchType", inClk_Type);
                SqlParameter pgShiftDate = new SqlParameter("@clk_date", clk_date);
                SqlParameter[] pParams = { pgEmpid, pgDeviceID, pgInOrOutDate, pgInOrOutTime, pgInOrOutPunchType, pgShiftDate };
                objDatafunction.ExecuteQueryUsingParameter(pParams, "Proc_Ta_MappingCorrespondingPunches");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "MappingPunches(Empid:" + inClk_EmpId + ";InOrOutDeviceId:" + inClk_DeviceId + ";Clk_Date:" + inClk_Date + ";Clk_Time:" + inClk_Time + ";Clk_Type:" + inClk_Type + ";Clk_Date:" + clk_date + ");" + "\r\n" + ex.Message);
            }
        }
        #endregion
        #region UpdateClockDate
        // UpdateClockDate() Function is used to split up the shift based on the Shift Settings
        public void UpdateClockDate(string inClk_EmpId, string inClk_DeviceId, string inClk_Date, string inClk_Time, string inClk_Type, bool inShiftType, string strClk_Status, string clockAddress, string latitude, string longitude)
        {
            string strSQLShift = string.Empty, strSQLShiftSettings = string.Empty, strSQLUpdateClockDate = string.Empty;
            string strPunchType = string.Empty, strType = string.Empty;
            string strClockDate = string.Empty;
            string Clk_OutDate = string.Empty, Clk_OutTime = string.Empty;
            try
            {
                strPunchType = GetPunchType(inClk_DeviceId, inClk_Type);
                strType = GetEquivalentPunchType(strPunchType, "T");
                gintShiftId = GetShiftId(inClk_EmpId, gstrClockDate, inClk_Time);
                if (gintShiftId != -1)
                {
                    // Insert the Records into the ProcessedData Table
                    if (!inShiftType) // Function Key
                    {
                        // Insert the Records into the ProcessedData Table
                        //ClockProcess(inClk_EmpId, inClk_DeviceId, gstrClockDate, inClk_Time, strPunchType, strType);
                        ClockProcess(inClk_EmpId, inClk_DeviceId, gstrClockDate, inClk_Time, strPunchType, strType, clockAddress, latitude, longitude);
                    }
                    else // Free Scan
                    {
                        ClockProcess(inClk_EmpId, inClk_DeviceId, gstrClockDate, inClk_Time, strPunchType, "I", clockAddress, latitude, longitude);
                        ClockProcess(inClk_EmpId, inClk_DeviceId, gstrClockDate, inClk_Time, strPunchType, "O", clockAddress, latitude, longitude);
                    }
                }
                else
                {
                    // If Weekly Off, then update the First In and Last Out in the Processed Data Table
                    // Insert the Records into the ProcessedData Table
                    if (!inShiftType) // Function Key
                    {
                        WeeklyOffProcess(inClk_EmpId, inClk_Date, inClk_Time, strType, clockAddress, latitude, longitude);
                    }
                    else // Free Scan
                    {
                        WeeklyOffProcess(inClk_EmpId, inClk_Date, inClk_Time, "I", clockAddress, latitude, longitude);
                        WeeklyOffProcess(inClk_EmpId, inClk_Date, inClk_Time, "O", clockAddress, latitude, longitude);
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "UpdateClockDate(SwipeCardNo: " + inClk_EmpId + ";DeviceID: " + inClk_DeviceId + ";Date: " + inClk_Date + ";Time: " + inClk_Time + ";Type: " + inClk_Type + ");Error : " + ex.ToString());
                throw ex;
            }
        }
        #endregion
        #region ClockProcess
        // **********************************************************************************************************************
        // Purpose :
        //     The ClockProcess Method is a used to Calculate and Store the Date, Minimum InTime, Maximum OutTime , Late In, 
        //     Early Out and Attendance as Present in the TimeCheck Processed Table for a Particular Employee and Date. 
        //
        // Inputs  :
        //     inClk_EmpId    - EmployeeID (or) CardID
        //     inClk_DeviceId - DeviceID (or) ReaderID 
        //     inClk_Date     - Date of Punch
        //     inClk_Time     - Time of Punch
        //     inClk_Type     - Clock Type (I-In or O-Out)
        // **********************************************************************************************************************
        public void ClockProcess(string inClk_EmpId, string inClk_DeviceId, string inClockDate, string inClk_Time, string inPunchType, string inType, string clockAddress, string latitude, string longitude)
        {
            try
            {
                DataTable dtProcessIn, dtShift, dtFirstIn, dtLastOut;
                DataTable dtPermission = new DataTable();
                DataTable dtShiftCheck = new DataTable();
                string strSQLFirstIn = string.Empty, strSQLLastOut = string.Empty, strSQLInsert = string.Empty, strShiftStartTime = string.Empty;
                string strSQLUpdate = string.Empty, strSQLShift = string.Empty, strPunchType = string.Empty, strType = string.Empty;
                DateTime dtmActualShiftStartTime = new DateTime();
                int intIsHoliday = 0;
                intIsHoliday = CheckForHoliday(DateTime.Parse(inClockDate, CI));
                strPunchType = inPunchType;
                strType = inType;
                gdtShift.DefaultView.RowFilter = "Shift_Id = " + gintShiftId + "";
                dtShift = gdtShift.DefaultView.ToTable();
                if (dtShift.Rows.Count > 0)
                {
                    if (dtShift.Rows[0]["Shift_StartTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]) != string.Empty)
                    {
                        dtmActualShiftStartTime = DateTime.Parse(inClockDate + " " + Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]), CI);
                    }
                }
                // Check for Permission
                dtPermission = CheckPermissionAppliedorNot(inClk_EmpId, DateTime.Parse(inClockDate, CI));
                // Check for Half a Day Leave
                DataTable dtLeave = new DataTable();
                dtLeave = CheckLeaveAppliedorNot(inClk_EmpId, DateTime.Parse(inClockDate, CI));
                if (dtShift.Rows.Count > 0)
                {
                    if (strType == "I") // if Type is IN
                    {
                        string strSQLCheck = string.Empty, strFirstIn = string.Empty;
                        strFirstIn = GetFirstIn(inClk_EmpId, inClockDate);
                        if (strFirstIn != string.Empty)
                        {
                            // Check whether there is Permission during the Shift Start Time
                            if (dtPermission.Rows.Count > 0)
                            {
                                dtShiftCheck = CheckingPermissionAvailedDuringShiftStartTime(gintShiftId, inClockDate + " " + Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]), Convert.ToString(dtPermission.Rows[0]["Permission_FromTime"]), Convert.ToString(dtPermission.Rows[0]["Permission_ToTime"]));
                            }
                            // If there is permission during the Shift Start Time, then Set Start Time as
                            // Permission To Time and Calculate Late. Else check if there is First half Leave
                            // Late should not be calculated during Permission Hours or First half Leave.
                            // If Half a Day Leave Present
                            if (dtLeave.Rows.Count > 0)
                            {
                                // Check for First half Leave. If so then set the Shift Start time as Lunch End Time
                                if (Convert.ToString(dtLeave.Rows[0]["Leave_SessionFrom"]) == "First half")
                                {
                                    strShiftStartTime = Convert.ToString(dtShift.Rows[0]["Shift_SecondHalf_StartTime"]);
                                }
                            }
                            if (strShiftStartTime == string.Empty)
                            {
                                // If Permission is Present
                                if (dtShiftCheck.Rows.Count > 0)
                                {
                                    if (DateTime.Parse(Convert.ToString(dtPermission.Rows[0]["Permission_ToTime"]), CI).ToShortTimeString() == DateTime.Parse(Convert.ToString(dtShift.Rows[0]["Shift_FirstHalf_EndTime"]), CI).ToShortTimeString())
                                    {
                                        strShiftStartTime = Convert.ToString(dtShift.Rows[0]["Shift_SecondHalf_StartTime"]);
                                    }
                                    else if (dtShift.Rows[0]["Shift_BreakStartTime2"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_BreakStartTime2"]) != string.Empty)
                                    {
                                        if (DateTime.Parse(Convert.ToString(dtPermission.Rows[0]["Permission_ToTime"]), CI).ToShortTimeString() == DateTime.Parse(Convert.ToString(dtShift.Rows[0]["Shift_BreakStartTime2"]), CI).ToShortTimeString())
                                        {
                                            strShiftStartTime = Convert.ToString(dtShift.Rows[0]["Shift_BreakEndTime2"]);
                                        }
                                        else
                                        {
                                            strShiftStartTime = DateTime.Parse(Convert.ToString(dtPermission.Rows[0]["Permission_ToTime"]), CI).ToShortTimeString();
                                        }
                                    }
                                    else
                                    {
                                        strShiftStartTime = DateTime.Parse(Convert.ToString(dtPermission.Rows[0]["Permission_ToTime"]), CI).ToShortTimeString();
                                    }
                                }
                                else
                                {
                                    // Nothing
                                }
                            }
                            if (strShiftStartTime == string.Empty)
                            {
                                if (dtShift.Rows[0]["Shift_StartTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]) != string.Empty)
                                {
                                    strShiftStartTime = Convert.ToString(dtShift.Rows[0]["Shift_StartTime"]);
                                }
                            }
                            // Calculate Late InTime
                            TimeSpan tsLateIn = new TimeSpan();
                            string strLateIn = "00:00";
                            double dLateInMins = 0;
                            // If the particular date is not Holiday, then Calculate Late In
                            if (intIsHoliday != 1)
                            {
                                if (strShiftStartTime != string.Empty)
                                {
                                    string strShftGraceInTime = "00:00";
                                    DateTime dtShftStartTimePlusGrace = new DateTime();
                                    DateTime dtActualShiftStartTime = DateTime.Parse(inClockDate + " " + strShiftStartTime, CI);
                                    DateTime dtActualInTime = DateTime.Parse(strFirstIn, CI);
                                    if (dtShift.Rows[0]["Shift_GraceInTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_GraceInTime"]) != string.Empty)
                                    {
                                        strShftGraceInTime = Convert.ToString(dtShift.Rows[0]["Shift_GraceInTime"]);
                                    }
                                    // Add Grace In with Shift Start Time
                                    dtShftStartTimePlusGrace = dtActualShiftStartTime.Add(DateTime.Parse(strShftGraceInTime, CI).TimeOfDay);
                                    //Calculate Late In, if Actual InTime is greater that Shift Start Time
                                    if (dtActualInTime > dtShftStartTimePlusGrace)
                                    {
                                        tsLateIn = dtActualInTime.Subtract(dtActualShiftStartTime);
                                        if (Convert.ToString(tsLateIn.TotalMinutes).Contains("."))
                                            dLateInMins = double.Parse(Convert.ToString(tsLateIn.TotalMinutes).Remove(Convert.ToString(tsLateIn.TotalMinutes).LastIndexOf(".")));
                                        else
                                            dLateInMins = double.Parse(Convert.ToString(tsLateIn.TotalMinutes));
                                        strLateIn = GetTotalHours(tsLateIn);
                                    }
                                }
                            }
                            // Check in the TimeCheck Processed Data whether there are records for appropriate EmployeeId and Date
                            dtProcessIn = CheckingDataAlreadyExistsInProcessedData(inClk_EmpId, inClockDate, "I");
                            // If Records are not present
                            if (dtProcessIn.Rows.Count == 0)
                            {
                                // Insert the EmployeeId, Date, Shift_Id, InTime, Calculated LateIn and Attendence into the Processed Data Table
                                InsertAndUpdateProcessedData(inClk_EmpId, inClockDate, gintShiftId, DateTime.Parse(strFirstIn, CI).ToShortTimeString(), "Present", strClk_Status, "I", strLateIn, dLateInMins, clockAddress);
                            }
                            // If Records are present
                            else
                            {
                                if (inClk_Time != DateTime.Parse(strFirstIn, CI).ToShortTimeString())
                                {
                                    if (Convert.ToString(dtProcessIn.Rows[0]["InNotation"]) != string.Empty)
                                    {
                                        strClk_Status = Convert.ToString(dtProcessIn.Rows[0]["InNotation"]);
                                    }
                                }
                                // Update the Processed Data Table with InTime, Calculated LateIn and Attendence for a particular EmployeeId and Date
                                InsertAndUpdateProcessedData(Convert.ToString(dtProcessIn.Rows[0]["Employee_Code_Id"]), Convert.ToString(dtProcessIn.Rows[0]["Date"]), gintShiftId, DateTime.Parse(strFirstIn, CI).ToShortTimeString(), "Present", strClk_Status, "UI", strLateIn, dLateInMins, clockAddress);
                            }
                        }
                    }
                    else if (strType == "O") // if Type is OUT
                    {
                        string strSQLCheck = string.Empty, strLastOut = string.Empty, strShiftEndTime = string.Empty;
                        strLastOut = GetLastOut(inClk_EmpId, inClockDate);
                        if (strLastOut != string.Empty)
                        {
                            // Check whether there is Permission during the Shift End Time
                            if (dtPermission.Rows.Count > 0)
                            {
                                dtShiftCheck = CheckingPermissionAvailedDuringShiftStartTime(gintShiftId, inClockDate + " " + Convert.ToString(dtShift.Rows[0]["Shift_EndTime"]), Convert.ToString(dtPermission.Rows[0]["Permission_FromTime"]), Convert.ToString(dtPermission.Rows[0]["Permission_ToTime"]));
                            }
                            // If there is permission during the Shift End Time, then Set End Time as
                            // Permission From Time and Calculate Early Out. Else check for Second half Leave.
                            // Early Out should not be calculated during Permission Hours or Second half Leave.
                            // If Half a Day Leave Present
                            if (dtLeave.Rows.Count > 0)
                            {
                                // Check for Second half Leave. If so then set the Shift End time as Lunch Start Time
                                if (Convert.ToString(dtLeave.Rows[0]["Leave_SessionFrom"]) == "Second half")
                                {
                                    strShiftEndTime = Convert.ToString(dtShift.Rows[0]["Shift_FirstHalf_EndTime"]);
                                }
                            }
                            if (strShiftEndTime == string.Empty)
                            {
                                if (dtShiftCheck.Rows.Count > 0)
                                {
                                    strShiftEndTime = DateTime.Parse(Convert.ToString(dtPermission.Rows[0]["Permission_FromTime"]), CI).ToShortTimeString();
                                }
                                else
                                {
                                    if (dtShift.Rows[0]["Shift_EndTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_EndTime"]) != string.Empty)
                                    {
                                        strShiftEndTime = Convert.ToString(dtShift.Rows[0]["Shift_EndTime"]);
                                    }
                                }
                            }
                            // Calculate Early Exit
                            TimeSpan tsEarlyOut = new TimeSpan();
                            string strEarlyOut = "00:00";
                            double dEarlyOutMins = 0;
                            // If the particular date is not Holiday, then Calculate Early Out
                            if (intIsHoliday != 1)
                            {
                                if (strShiftEndTime != string.Empty)
                                {
                                    string strShftGraceOutTime = "00:00";
                                    DateTime dtShftEndTimeMinusGrace = new DateTime();
                                    DateTime dtShift_EndTime = DateTime.Parse(inClockDate + " " + strShiftEndTime, CI);
                                    DateTime dtActualOutTime = DateTime.Parse(strLastOut, CI);
                                    string strActualShiftStartTime = dtmActualShiftStartTime.ToString("hh:mm:ss tt");
                                    string strShiftEndTim = dtShift_EndTime.ToString("hh:mm:ss tt");
                                    if ((strActualShiftStartTime.Substring(9, 2) == "PM") && (strShiftEndTim.Substring(9, 2) == "AM"))
                                    {
                                        dtShift_EndTime = dtShift_EndTime.AddDays(1);
                                    }
                                    if (dtShift.Rows[0]["Shift_GraceOutTime"] != DBNull.Value && Convert.ToString(dtShift.Rows[0]["Shift_GraceOutTime"]) != string.Empty)
                                    {
                                        strShftGraceOutTime = Convert.ToString(dtShift.Rows[0]["Shift_GraceOutTime"]);
                                    }
                                    dtShftEndTimeMinusGrace = dtShift_EndTime.Subtract(DateTime.Parse(strShftGraceOutTime, CI).TimeOfDay);
                                    //tsActualOutTime = DateTime.Parse(tsActualOutTime.ToString().Substring(0, 5)).TimeOfDay;
                                    if (dtActualOutTime < dtShftEndTimeMinusGrace)
                                    {
                                        tsEarlyOut = dtShift_EndTime.Subtract(dtActualOutTime);
                                        //strEarlyOut = tsEarlyOut.ToString().Substring(0, 5);
                                        //tsEarlyOut = DateTime.Parse(strEarlyOut).TimeOfDay;
                                        if (Convert.ToString(tsEarlyOut.TotalMinutes).Contains("."))
                                            dEarlyOutMins = double.Parse(Convert.ToString(tsEarlyOut.TotalMinutes).Remove(Convert.ToString(tsEarlyOut.TotalMinutes).LastIndexOf(".")));
                                        else
                                            dEarlyOutMins = double.Parse(Convert.ToString(tsEarlyOut.TotalMinutes));
                                        strEarlyOut = GetTotalHours(tsEarlyOut);
                                    }
                                }
                            }
                            // Check in the TimeCheck Processed Data whether there are records for appropriate EmployeeId and Date                            
                            dtProcessIn = CheckingDataAlreadyExistsInProcessedData(inClk_EmpId, inClockDate, "O");
                            // If Records are not present
                            if (dtProcessIn.Rows.Count == 0)
                            {
                                // Insert the EmployeeId, Date, Shift_Id, OutTime, Calculated EarlyOut and Attendence into the Processed Data Table
                                InsertAndUpdateProcessedData(inClk_EmpId, inClockDate, gintShiftId, DateTime.Parse(strLastOut, CI).ToShortTimeString(), "Present", strClk_Status, "IO", strEarlyOut, dEarlyOutMins, clockAddress);
                            }
                            // If Records are present
                            else
                            {
                                if (inClk_Time != DateTime.Parse(strLastOut, CI).ToShortTimeString())
                                {
                                    if (Convert.ToString(dtProcessIn.Rows[0]["OutNotation"]) != string.Empty)
                                    {
                                        strClk_Status = Convert.ToString(dtProcessIn.Rows[0]["OutNotation"]);
                                    }
                                }
                                // Update the Processed Data Table with OutTime, Calculated EarlyOut and Attendence for a particular EmployeeId and Date
                                InsertAndUpdateProcessedData(Convert.ToString(dtProcessIn.Rows[0]["Employee_Code_Id"]), Convert.ToString(dtProcessIn.Rows[0]["Date"]), gintShiftId, DateTime.Parse(strLastOut, CI).ToShortTimeString(), "Present", strClk_Status, "UO", strEarlyOut, dEarlyOutMins, clockAddress);
                            }
                        }
                    }
                }
                UpdateProcessFlagFromPrevToNextDay(inClk_EmpId, DateTime.Parse(inClockDate, CI).ToShortDateString());
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "ClockProcess ; SwipeCardNo : " + inClk_EmpId + "; DeviceID : " + inClk_DeviceId + "; Date : " + inClockDate + "; Time : " + inClk_Time + "; PunchType : " + inPunchType + " ; Type " + inType + "; Error : " + ex.ToString());
            }
        }
        #endregion
        #region GettingPermissionDetails
        public DataTable CheckPermissionAppliedorNot(string inEmployeeCodeId, DateTime dtmDate)
        {
            DataTable dtPermission = new DataTable();
            try
            {
                SqlParameter pgPermissionEmployee_Code_Id = new SqlParameter("@inEmployee_Code_Id", inEmployeeCodeId);
                SqlParameter pgPermissiondtmDate = new SqlParameter("@dtmDate", dtmDate);
                SqlParameter[] pPermissionParams = { pgPermissionEmployee_Code_Id, pgPermissiondtmDate };
                dtPermission = objDatafunction.GettingDatasetUsingParameter(pPermissionParams, "Proc_Ta_GettingPermissionDetailsForService");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "CheckPermissionAppliedorNot(SwipeCardNo: " + inEmployeeCodeId + ";Date: " + dtmDate + ");Error : " + ex.ToString());
            }
            return dtPermission;
        }
        #endregion
        #region GettingLeaveDetails
        public DataTable CheckLeaveAppliedorNot(string inEmployeeCodeId, DateTime dtmDate)
        {
            DataTable dtLeave = new DataTable();
            try
            {
                SqlParameter pgLeaveEmployee_Code_Id = new SqlParameter("@inEmployee_Code_Id", inEmployeeCodeId);
                SqlParameter pgleavedtmDate = new SqlParameter("@dtmDate", dtmDate);
                SqlParameter[] pleaveParams = { pgLeaveEmployee_Code_Id, pgleavedtmDate };
                dtLeave = objDatafunction.GettingDatasetUsingParameter(pleaveParams, "Proc_Ta_SelectLeaveDetailsForService");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "CheckLeaveAppliedorNot(SwipeCardNo: " + inEmployeeCodeId + ";Date: " + dtmDate + ");Error : " + ex.ToString());
            }
            return dtLeave;
        }
        #endregion
        #region GetFirstIn
        // Function to get First In Time for the particular Swipe Card No and Date
        public string GetFirstIn(string inSwipeCardNo, string inDate)
        {
            string strFirstInDateTime = string.Empty;
            try
            {
                DataTable dtFirstIn = new DataTable();
                SqlParameter pgFirstInEmployee_Code_Id = new SqlParameter("@inSwipeCardNo", inSwipeCardNo);
                SqlParameter pgFirstIndtmDate = new SqlParameter("@inDate", inDate);
                SqlParameter[] pFirstInParams = { pgFirstInEmployee_Code_Id, pgFirstIndtmDate };
                dtFirstIn = objDatafunction.GettingDatasetUsingParameter(pFirstInParams, "Proc_Ta_GetFirstInDetailsForService");
                if (dtFirstIn.Rows.Count > 0)
                {
                    if (dtFirstIn.Rows[0]["FirstIn"] != DBNull.Value && dtFirstIn.Rows[0]["FirstIn"].ToString() != string.Empty)
                    {
                        strFirstInDateTime = dtFirstIn.Rows[0]["FirstIn"].ToString();
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "GetFirstIn(SwipeCardNo: " + inSwipeCardNo + ";Date: " + inDate + ");Error : " + ex.ToString());
            }
            return (strFirstInDateTime);
        }
        #endregion
        #region InsertAndUpdateProcessedData
        public void InsertAndUpdateProcessedData(string Employee_Code_Id, string Date, int Shift_Id, string Intime, string Attendance, string InNotation, string Type, string LateIn, double LateInMins, string clockAddress)
        {
            try
            {
                SqlParameter pmEmployee_Code_Id = new SqlParameter("@Employee_Code_Id", Employee_Code_Id);
                SqlParameter pmDate = new SqlParameter("@Date", Date);
                SqlParameter pmShift_Id = new SqlParameter("@Shift_Id", Shift_Id);
                SqlParameter pmIntime = new SqlParameter("@Intime", Intime);
                SqlParameter pmAttendance = new SqlParameter("@Attendance", Attendance);
                SqlParameter pmInNotation = new SqlParameter("@InNotation", InNotation);
                SqlParameter pmLateIn = new SqlParameter("@LateIn", LateIn);
                SqlParameter pmLateInMins = new SqlParameter("@LateInMins", LateInMins);
                SqlParameter pmType = new SqlParameter("@Type", Type);
                SqlParameter pmClkAddress = new SqlParameter("@ClockAddress", clockAddress);
                //SqlParameter pmlatitude = new SqlParameter("@latitude", latitude);
                //SqlParameter pmlongitude = new SqlParameter("@longitude", longitude);
                SqlParameter[] pmetersProcessedData = { pmEmployee_Code_Id, pmDate, pmShift_Id, pmIntime, pmAttendance, pmInNotation, pmLateIn, pmLateInMins, pmType, pmClkAddress };
                objDatafunction.ExecuteQueryUsingParameter(pmetersProcessedData, "Proc_TA_InsertAndUpdateProcessedData");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "InsertAndUpdateProcessedData(SwipeCardNo: " + Employee_Code_Id + ";Date: " + Date + ";Shift_Id: " + Shift_Id + ";Intime: " + Intime + ";Attendance: " + Attendance + ";InNotation: " + InNotation + ";LateIn: " + LateIn + ";LateInMins: " + LateInMins + ";Type: " + Type + ");Error: " + ex.ToString());
            }
        }
        #endregion
        #region CheckingPermissionAvailedDuringShiftStartTime
        public DataTable CheckingPermissionAvailedDuringShiftStartTime(int gintShiftId, string Shift_StartTime, string Permission_FromTime, string Permission_ToTime)
        {
            DataTable dtShiftCheck = new DataTable();
            try
            {
                SqlParameter pmgintShiftId = new SqlParameter("@gintShiftId", gintShiftId);
                SqlParameter pmShift_StartTime = new SqlParameter("@Shift_StartTime", Shift_StartTime);
                SqlParameter pmPermission_FromTime = new SqlParameter("@Permission_FromTime", Permission_FromTime);
                SqlParameter pmPermission_ToTime = new SqlParameter("@Permission_ToTime", Permission_ToTime);
                SqlParameter[] pmetersPermission = { pmgintShiftId, pmShift_StartTime, pmPermission_FromTime, pmPermission_ToTime };
                dtShiftCheck = objDatafunction.GettingDatasetUsingParameter(pmetersPermission, "Proc_TA_CheckingPermissionAvailedDuringShiftStartTime");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "CheckingPermissionAvailedDuringShiftStartTime(ShiftId:" + gintShiftId + ";Shift_StartTime:" + Shift_StartTime + ";Permission_FromTime:" + Permission_FromTime + ";Permission_ToTime:" + Permission_ToTime + "); Error : " + ex.ToString());
            }
            return dtShiftCheck;
        }
        #endregion
        #region CheckingWhetherDataIsAlreadyAvailedInProcessedDataOrNot
        /// <summary>
        /// Checking Data is already Exists In ProcessedData or not for Insert/update records
        /// </summary>
        /// <param name="inClk_EmpId"></param>
        /// <param name="inClk_Date"></param>
        /// <returns></returns>
        public DataTable CheckingDataAlreadyExistsInProcessedData(string inClk_EmpId, string inClk_Date, string Datafrom)
        {
            DataTable dsProcessedData = new DataTable();
            try
            {
                SqlParameter pmClk_EmpId = new SqlParameter("@Clk_EmpId", inClk_EmpId);
                SqlParameter pmClk_Date = new SqlParameter("@ClockDate", inClk_Date);
                SqlParameter pmDatafrom = new SqlParameter("@Datafrom", Datafrom);
                SqlParameter[] pmetersProcessedData = { pmClk_EmpId, pmClk_Date, pmDatafrom };
                dsProcessedData = objDatafunction.GettingDatasetUsingParameter(pmetersProcessedData, "Proc_TA_CheckingDataAlreadyExistsInProcessedData");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "CheckingDataAlreadyExistsInProcessedData ; SwipeCardNo : " + inClk_EmpId + " ; Date : " + inClk_Date + "; Error : " + ex.ToString());
                throw ex;
            }
            return dsProcessedData;
        }
        #endregion
        #region GetLastOut
        // Function to get Last Out Time for the particular Swipe Card No and Date
        public string GetLastOut(string inSwipeCardNo, string inDate)
        {
            string strLastOutDateTime = string.Empty;
            try
            {
                DataTable dtLastOut = new DataTable();
                SqlParameter pgLastOutEmployee_Code_Id = new SqlParameter("@Employeecode", inSwipeCardNo);
                SqlParameter pgLastOutleavedtmDate = new SqlParameter("@Date", inDate);
                SqlParameter[] pLastOutParams = { pgLastOutEmployee_Code_Id, pgLastOutleavedtmDate };
                dtLastOut = objDatafunction.GettingDatasetUsingParameter(pLastOutParams, "Proc_Ta_GetLastOutForService");
                if (dtLastOut.Rows.Count > 0)
                {
                    if (dtLastOut.Rows[0]["LastOut"] != DBNull.Value && dtLastOut.Rows[0]["LastOut"].ToString() != string.Empty)
                    {
                        strLastOutDateTime = Convert.ToString(dtLastOut.Rows[0]["LastOut"]);
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "GetLastOut(SwipeCardNo:" + inSwipeCardNo + ";Date: " + inDate + ");Error : " + ex.Message);
            }
            return (strLastOutDateTime);
        }
        #endregion
        #region WeeklyOffProcess
        // Function used to fill In Time and Out Time during Weekly Off
        public void WeeklyOffProcess(string inClk_EmpId, string inClk_Date, string inClk_Time, string inClk_Type, string clockAddress, string latitude, string longitude)
        {
            DataTable dtFirstIn = new DataTable();
            DataTable dtLastOut = new DataTable();
            DataTable dtProcessIn = new DataTable();
            string strSQLFirstIn = string.Empty, strSQLLastOut = string.Empty, strSQLInsert = string.Empty;
            string strSQLUpdate = string.Empty;
            try
            {
                if (inClk_Type == "I") // if Type is IN
                {
                    string strSQLCheck = string.Empty, strFirstIn = string.Empty, strShiftStartTime = string.Empty;
                    strFirstIn = GetFirstIn(inClk_EmpId, gstrClockDate);
                    if (strFirstIn != string.Empty)
                    {
                        // Check in the TimeCheck Processed Data whether there are records for appropriate EmployeeId and Date
                        dtProcessIn = CheckingDataAlreadyExistsInProcessedData(inClk_EmpId, gstrClockDate, "I");
                        // If Records are not present
                        if (dtProcessIn.Rows.Count == 0)
                        {
                            // Insert the EmployeeId, Date, Shift_Id, InTime, Calculated LateIn and Attendence into the Processed Data Table
                            InsertAndUpdateProcessedData(inClk_EmpId, gstrClockDate, gintShiftId, DateTime.Parse(strFirstIn, CI).ToShortTimeString(), "Present", strClk_Status, "I", "00:00", 0, clockAddress);
                        }
                        // If Records are present
                        else
                        {
                            string strInTime = string.Empty;
                            if (dtProcessIn.Rows[0]["InTime"] != DBNull.Value && Convert.ToString(dtProcessIn.Rows[0]["InTime"]) != string.Empty)
                            {
                                strInTime = Convert.ToString(dtProcessIn.Rows[0]["InTime"]);
                                if (strInTime != DateTime.Parse(strFirstIn, CI).ToShortTimeString())
                                {
                                    if (Convert.ToString(dtProcessIn.Rows[0]["InNotation"]) != string.Empty)
                                    {
                                        strClk_Status = Convert.ToString(dtProcessIn.Rows[0]["InNotation"]);
                                    }
                                }
                            }
                            if (strInTime != DateTime.Parse(strFirstIn, CI).ToShortTimeString())
                            {
                                // Update the Processed Data Table with InTime and Attendence for a particular EmployeeId and Date
                                InsertAndUpdateProcessedData(Convert.ToString(dtProcessIn.Rows[0]["Employee_Code_Id"]),
                                   Convert.ToString(dtProcessIn.Rows[0]["Date"]), gintShiftId,
                                    DateTime.Parse(strFirstIn, CI).ToShortTimeString(), "Present", strClk_Status, "UI", "00:00", 0, clockAddress);
                            }
                            else if (strInTime == DateTime.Parse(strFirstIn, CI).ToShortTimeString())
                            {
                                InsertAndUpdateProcessedData(Convert.ToString(dtProcessIn.Rows[0]["Employee_Code_Id"]),
                                    Convert.ToString(dtProcessIn.Rows[0]["Date"]), 0,
                                    "", "", "", "U", "", 0, clockAddress);
                            }
                        }
                    }
                }
                else if (inClk_Type == "O") // if Type is OUT
                {
                    string strSQLCheck = string.Empty;
                    string strLastOut = string.Empty;
                    string strShiftEndTime = string.Empty;
                    strLastOut = GetLastOut(inClk_EmpId, gstrClockDate);
                    if (strLastOut != string.Empty)
                    {
                        // Check in the TimeCheck Processed Data whether there are records for appropriate EmployeeId and Date
                        dtProcessIn = CheckingDataAlreadyExistsInProcessedData(inClk_EmpId, gstrClockDate, "O");
                        // If Records are not present
                        if (dtProcessIn.Rows.Count == 0)
                        {
                            // Insert the EmployeeId, Date, Shift_Id, OutTime and Attendence into the Processed Data Table
                            InsertAndUpdateProcessedData(inClk_EmpId, gstrClockDate, gintShiftId,
                                DateTime.Parse(strLastOut, CI).ToShortTimeString(), "Present", strClk_Status, "O", "00:00", 0, clockAddress);
                        }
                        // If Records are present
                        else
                        {
                            string strOutTime = string.Empty;
                            if (dtProcessIn.Rows[0]["OutTime"] != DBNull.Value && Convert.ToString(dtProcessIn.Rows[0]["OutTime"]) != string.Empty)
                            {
                                strOutTime = Convert.ToString(dtProcessIn.Rows[0]["OutTime"]);
                                if (strOutTime != DateTime.Parse(strLastOut, CI).ToShortTimeString())
                                {
                                    if (Convert.ToString(dtProcessIn.Rows[0]["OutNotation"]) != string.Empty)
                                    {
                                        strClk_Status = Convert.ToString(dtProcessIn.Rows[0]["OutNotation"]);
                                    }
                                }
                            }
                            if (strOutTime != DateTime.Parse(strLastOut, CI).ToShortTimeString())
                            {
                                // Update the Processed Data Table with OutTime, Calculated EarlyOut and Attendence for a particular EmployeeId and Date
                                InsertAndUpdateProcessedData(Convert.ToString(dtProcessIn.Rows[0]["Employee_Code_Id"]), Convert.ToString(dtProcessIn.Rows[0]["Date"]), gintShiftId, DateTime.Parse(strLastOut, CI).ToShortTimeString(), "Present", strClk_Status, "UO", "00:00", 0, clockAddress);
                            }
                            else if (strOutTime == DateTime.Parse(strLastOut, CI).ToShortTimeString())
                            {
                                // Update the Processed Data Table with OutTime, Calculated EarlyOut and Attendence for a particular EmployeeId and Date
                                InsertAndUpdateProcessedData(Convert.ToString(dtProcessIn.Rows[0]["Employee_Code_Id"]), Convert.ToString(dtProcessIn.Rows[0]["Date"]), 0, "", "", "", "U", "", 0, clockAddress);
                            }
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "WeeklyOffProcess(SwipeCardNo: " + inClk_EmpId + ";Date: " + inClk_Date + ";Time: " + inClk_Time + ";Type: " + inClk_Type + "); Error : " + ex.ToString());
            }
        }
        #endregion
        #region Ignore Duplicate Punches Checking
        public bool CheckIgnoreDuplicate(bool inShiftType, string inClk_CardId, string inClk_Date, string inClk_Time, string strClockDate, string inClk_Type)
        {
            bool blnDuplicateExists = false;
            try
            {
                DataTable dtDuplicateData;
                string strCheckDuplicates = string.Empty;
                int intCompanyId = 0;
                DataTable dtShiftSettings = new DataTable();
                intCompanyId = GetCompanyId(inClk_CardId, inClk_Date);
                gdtShiftSettings.DefaultView.RowFilter = "CompanyId = " + intCompanyId + "";
                dtShiftSettings = gdtShiftSettings.DefaultView.ToTable();
                if (dtShiftSettings.Rows.Count == 0)
                {
                    gdtShiftSettings.DefaultView.RowFilter = "CompanyId = -1";
                    dtShiftSettings = gdtShiftSettings.DefaultView.ToTable();
                }
                if (dtShiftSettings.Rows.Count > 0)
                {
                    if (Convert.ToBoolean(dtShiftSettings.Rows[0]["IgnoreDuplicatePunch"]) == true)
                    {
                        gstrPunchInterval = Convert.ToString(dtShiftSettings.Rows[0]["PunchInterval"]);
                        SqlParameter pminShiftType = new SqlParameter("@inShiftType", inShiftType);
                        SqlParameter pminClk_CardId = new SqlParameter("@inClk_CardId", inClk_CardId);
                        SqlParameter pminClk_Date = new SqlParameter("@inClk_Date", inClk_Date);
                        SqlParameter pminClk_Time = new SqlParameter("@inClk_Time", inClk_Time);
                        SqlParameter pmstrClockDate = new SqlParameter("@strClockDate", gstrClockDate);
                        SqlParameter pminClk_Type = new SqlParameter("@inClk_Type", inClk_Type);
                        SqlParameter pmgstrPunchInterval = new SqlParameter("@gstrPunchInterval", gstrPunchInterval);
                        SqlParameter[] pmetersIgnore = { pminShiftType, pminClk_CardId, pminClk_Date, pminClk_Time, pmstrClockDate, pminClk_Type, pmgstrPunchInterval };
                        dtDuplicateData = objDatafunction.GettingDatasetUsingParameter(pmetersIgnore, "Proc_TA_CheckIgnoreDuplicatePunches");
                        if (dtDuplicateData.Rows.Count > 0)
                        {
                            if (Convert.ToInt32(dtDuplicateData.Rows[0]["DuplicateCount"]) > 0)
                            {
                                blnDuplicateExists = true;
                            }
                        }
                    }
                }
            }
            catch (Exception)
            {
                throw;
            }
            return blnDuplicateExists;
        }
        #endregion
        #region CheckExactDuplicateRecordExists
        public DataTable CheckExactDuplicateRecordExists(string Clk_CardId, string Clk_Date, string Clk_Time)
        {
            DataTable dtCheckInDateExactDuplicateExists = new DataTable();
            try
            {
                SqlParameter pmClk_CardId = new SqlParameter("@Clk_CardId", Clk_CardId);
                SqlParameter pmClk_Date = new SqlParameter("@Clk_Date", Clk_Date);
                SqlParameter pmClk_Time = new SqlParameter("@Clk_Time", Clk_Time);
                SqlParameter[] pmeters = { pmClk_CardId, pmClk_Date, pmClk_Time };
                dtCheckInDateExactDuplicateExists = objDatafunction.GettingDatasetUsingParameter(pmeters, "Proc_TA_CheckExactDuplicateRecordExists");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "CheckExactDuplicateRecordExists ; ClockId : " + Clk_CardId + ";Error : " + ex.ToString());
            }
            return dtCheckInDateExactDuplicateExists;
        }
        #endregion
        #region "Functions related to Free Scan IN-OUT Mapping"
        /// <summary>
        /// The FreeScan() Method is used to Match the IN and OUT Details in the Clock Details Table
        /// </summary>
        /// <param name="inClk_EmpId">Employee Id</param>
        /// <param name="inClk_DeviceId">Device Id (or) Reader Id</param>
        /// <param name="inClk_Date">Date of Punch</param>
        /// <param name="inClk_Time">Time of Punch</param>
        /// <param name="inClk_Remarks">Reason. Applicable for Manual Time Entry</param>
        /// <param name="inClk_User">User Id who have added the Manual Time Entry</param>
        /// <param name="inClk_Status">Status of the Record. M - Record from Manual Time Entry and A - Automatic</param>
        /// 
        public void FreeScan(string inClk_EmpId, string inClk_DeviceId, string inClk_Date, string inClk_Time, string inClk_Remarks, string inClk_User, string inClk_Status)
        {
            // Call MoveInOutDetails() Function to Check whether the record lies inbetween InTime and OutTime
            int intCheck = MoveInOutDetails(inClk_EmpId, inClk_DeviceId, inClk_Date, inClk_Time, inClk_Remarks, inClk_User, inClk_Status);
            if (intCheck == 1)
            {
                return;
            }
            UpdateInOutDetails(inClk_EmpId, inClk_DeviceId, inClk_Date, inClk_Time, inClk_Remarks, inClk_User, inClk_Status, string.Empty);
        }
        public int MoveInOutDetails(string inClk_EmpId, string inClk_DeviceId, string inClk_Date, string inClk_Time, string inClk_Remarks, string inClk_User, string inClk_Status)
        {
            DataTable dtCheckInOut = new DataTable();
            DataTable dtCheckOutIn = new DataTable();
            DataTable dtCheckIn = new DataTable();
            DataTable dtCheckInn = new DataTable();
            string strSQLInOut = string.Empty, strSQLOutIn = string.Empty, strSQLCheckIn = string.Empty;
            string strDateTime = inClk_Date + " " + inClk_Time;
            try
            {
                // Check whether the Date and Time lies inbetween any InTime and OutTime in the Clock Details Table for particular Employee
                try
                {
                    SqlParameter pminClk_EmpId = new SqlParameter("@inClk_EmpId", inClk_EmpId);
                    SqlParameter pmgstrClockDate = new SqlParameter("@gstrClockDate", gstrClockDate);
                    SqlParameter pmstrDateTime = new SqlParameter("@strDateTime", strDateTime);
                    SqlParameter[] pmeters = { pminClk_EmpId, pmgstrClockDate, pmstrDateTime };
                    dtCheckInOut = objDatafunction.GettingDatasetUsingParameter(pmeters, "Proc_TA_CheckingInAndOutTimeLiesBwAnyExistingData");
                    dtCheckOutIn = objDatafunction.GettingDatasetUsingParameter(pmeters, "Proc_TA_CheckingInAndOutTimeLiesBwAnyExistingData1");
                    dtCheckIn = objDatafunction.GettingDatasetUsingParameter(pmeters, "Proc_TA_CheckingInAndOutTimeLiesBwAnyExistingData2");
                }
                catch (Exception ex)
                {
                    //eventLog1.WriteEntry("strSQLOutIn : " + strSQLOutIn);
                }
                if (dtCheckInOut.Rows.Count > 0)
                {
                    ReplaceInOutDetails(Convert.ToInt32(dtCheckInOut.Rows[0]["Clk_Id"]), "O", inClk_EmpId, inClk_DeviceId, inClk_Date, inClk_Time, inClk_Remarks, inClk_User, inClk_Status, "N");
                    return (1);
                }
                else if (dtCheckOutIn.Rows.Count == 2)
                {
                    Int32 intClockId = 0;
                    string strInDateTime = string.Empty;
                    string strOutDateTime = string.Empty;
                    if (Convert.ToString(dtCheckOutIn.Rows[0]["Type"]) == "Out")
                    {
                        intClockId = Convert.ToInt32(dtCheckOutIn.Rows[1]["Clk_Id"]);
                        strOutDateTime = Convert.ToString(dtCheckOutIn.Rows[0]["PunchDateTime"]);
                        strInDateTime = Convert.ToString(dtCheckOutIn.Rows[1]["PunchDateTime"]);
                    }
                    else if (Convert.ToString(dtCheckOutIn.Rows[0]["Type"]) == "In")
                    {
                        intClockId = Convert.ToInt32(dtCheckOutIn.Rows[0]["Clk_Id"]);
                        strOutDateTime = Convert.ToString(dtCheckOutIn.Rows[1]["PunchDateTime"]);
                        strInDateTime = Convert.ToString(dtCheckOutIn.Rows[0]["PunchDateTime"]);
                    }
                    string strSQLCheckInDate = string.Empty;
                    DataTable dtCheckInDate = new DataTable();
                    string strIsOutDateNull = "N";
                    SqlParameter pminClk_EmpId = new SqlParameter("@inClk_EmpId", inClk_EmpId);
                    SqlParameter pmstrOutDateTime = new SqlParameter("@strOutDateTime", strOutDateTime);
                    SqlParameter[] pmetersCountTot = { pminClk_EmpId, pmstrOutDateTime };
                    dtCheckInDate = objDatafunction.GettingDatasetUsingParameter(pmetersCountTot, "Proc_Ta_CountTotInAndOutPunches");
                    if (dtCheckInDate.Rows.Count > 0)
                    {
                        if (dtCheckInDate.Rows[0]["Count"] != DBNull.Value && Convert.ToString(dtCheckInDate.Rows[0]["Count"]) != string.Empty)
                        {
                            if (Convert.ToInt32(dtCheckInDate.Rows[0]["Count"]) > 0)
                            {
                                strIsOutDateNull = "Y";
                            }
                        }
                    }
                    if (strIsOutDateNull == "N")
                    {
                        ReplaceInOutDetails(intClockId, "I", inClk_EmpId, inClk_DeviceId, inClk_Date, inClk_Time, inClk_Remarks, inClk_User, inClk_Status, "N");
                        return (1);
                    }
                    else
                    {
                        int intStatus = 1;
                        intStatus = UpdateInOutDetails(inClk_EmpId, inClk_DeviceId, inClk_Date, inClk_Time, inClk_Remarks, inClk_User, inClk_Status, "MoveInOutDetails");
                        if (intStatus == 0)
                        {
                            ReplaceInOutDetails(intClockId, "I", inClk_EmpId, inClk_DeviceId, inClk_Date, inClk_Time, inClk_Remarks, inClk_User, inClk_Status, "N");
                        }
                        return (1);
                    }
                }
                else if (dtCheckIn.Rows.Count > 0)
                {
                    if (dtCheckIn.Rows[0]["InDateTime"] != DBNull.Value)
                    {
                        if (DateTime.Parse(strDateTime, CI) < DateTime.Parse(Convert.ToString(dtCheckIn.Rows[0]["InDateTime"]), CI))
                        {
                            SqlParameter pminClk_EmpId = new SqlParameter("@inClk_EmpId", inClk_EmpId);
                            SqlParameter pmstrDateTime = new SqlParameter("@strDateTime", strDateTime);
                            SqlParameter[] pmeters = { pminClk_EmpId, pmstrDateTime };
                            dtCheckInn = objDatafunction.GettingDatasetUsingParameter(pmeters, "Proc_TA_CheckingInAndOutTimeLiesBwAnyExistingData3");
                            if (dtCheckInn.Rows.Count == 2)
                            {
                                string strIsClockOutDateNull = "N";
                                if (Convert.ToString(dtCheckInn.Rows[0]["Type"]) == "F")
                                {
                                    if (dtCheckInn.Rows[0]["Clk_OutDate"] == DBNull.Value || Convert.ToString(dtCheckInn.Rows[0]["Clk_OutDate"]) == string.Empty)
                                    {
                                        strIsClockOutDateNull = "Y";
                                    }
                                }
                                else if (Convert.ToString(dtCheckInn.Rows[1]["Type"]) == "F")
                                {
                                    if (dtCheckInn.Rows[1]["Clk_OutDate"] == DBNull.Value || Convert.ToString(dtCheckInn.Rows[1]["Clk_OutDate"]) == string.Empty)
                                    {
                                        strIsClockOutDateNull = "Y";
                                    }
                                }
                                if (strIsClockOutDateNull == "N")
                                {
                                    ReplaceInOutDetails(Convert.ToInt32(dtCheckIn.Rows[0]["Clk_Id"]), "I", inClk_EmpId, inClk_DeviceId, inClk_Date, inClk_Time, inClk_Remarks, inClk_User, inClk_Status, "N");
                                    return (1);
                                }
                                else
                                {
                                    int intStatus = 1;
                                    intStatus = UpdateInOutDetails(inClk_EmpId, inClk_DeviceId, inClk_Date, inClk_Time, inClk_Remarks, inClk_User, inClk_Status, "MoveInOutDetails");
                                    if (intStatus == 0)
                                    {
                                        ReplaceInOutDetails(Convert.ToInt32(dtCheckIn.Rows[0]["Clk_Id"]), "I", inClk_EmpId, inClk_DeviceId, inClk_Date, inClk_Time, inClk_Remarks, inClk_User, inClk_Status, "N");
                                    }
                                    return (1);
                                }
                            }
                            else if (dtCheckInn.Rows.Count == 1)
                            {
                                ReplaceInOutDetails(Convert.ToInt32(dtCheckIn.Rows[0]["Clk_Id"]), "I", inClk_EmpId, inClk_DeviceId, inClk_Date, inClk_Time, inClk_Remarks, inClk_User, inClk_Status, "N");
                                return (1);
                            }
                            else
                            {
                                return (0);
                            }
                        }
                        else
                        {
                            return (0);
                        }
                    }
                    else
                    {
                        return (0);
                    }
                }
                else
                {
                    return (0);
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return (0);
        }
        public void ReplaceInOutDetails(int inClk_Id, string inPunchType, string inClk_EmpId, string inClk_DeviceId, string inClk_Date, string inClk_Time, string inClk_Remarks, string inClk_User, string inClk_Status, string strType)
        {
            DataTable dtReplaceIn = new DataTable();
            DataTable dtReplaceOut = new DataTable();
            string strSQLReplaceIn = string.Empty;
            string strSQLReplaceOut = string.Empty;
            string strSQLUpdate = string.Empty;
            string strInsertFlag = "N";
            try
            {
                string strDateTime = inClk_Date + " " + inClk_Time;
                SqlParameter pminClk_Id = new SqlParameter("@inClk_Id", inClk_Id);
                SqlParameter pmType = new SqlParameter("@Type", inPunchType);
                SqlParameter[] pmeters = { pminClk_Id, pmType };
                if (inPunchType == "O")
                {
                    dtReplaceOut = objDatafunction.GettingDatasetUsingParameter(pmeters, "Proc_TA_GetInAndOutPunchDetails");
                    if (dtReplaceOut.Rows.Count > 0)
                    {
                        string strEmpId = string.Empty, strClk_InDeviceId = string.Empty, strClk_InDate = string.Empty, strClk_Date = string.Empty;
                        string strClk_InTime = string.Empty;
                        // Stores the Old OUT Details from the Clock Details Table in Temporary Variables.
                        if (dtReplaceOut.Rows[0]["Clk_EmpId"] != DBNull.Value && Convert.ToString(dtReplaceOut.Rows[0]["Clk_EmpId"]) != string.Empty)
                        {
                            strEmpId = Convert.ToString(dtReplaceOut.Rows[0]["Clk_EmpId"]);
                        }
                        if (dtReplaceOut.Rows[0]["Clk_OutDeviceId"] != DBNull.Value && Convert.ToString(dtReplaceOut.Rows[0]["Clk_OutDeviceId"]) != string.Empty)
                        {
                            strClk_InDeviceId = Convert.ToString(dtReplaceOut.Rows[0]["Clk_OutDeviceId"]);
                        }
                        if (dtReplaceOut.Rows[0]["Clk_OutDate"] != DBNull.Value && Convert.ToString(dtReplaceOut.Rows[0]["Clk_OutDate"]) != string.Empty)
                        {
                            strClk_InDate = DateTime.Parse(Convert.ToString(dtReplaceOut.Rows[0]["Clk_OutDate"]), CI).ToShortDateString();
                        }
                        if (dtReplaceOut.Rows[0]["Clk_OutTime"] != DBNull.Value && Convert.ToString(dtReplaceOut.Rows[0]["Clk_OutTime"]) != string.Empty)
                        {
                            strClk_InTime = DateTime.Parse(Convert.ToString(dtReplaceOut.Rows[0]["Clk_OutTime"]), CI).ToLongTimeString();
                        }
                        if (dtReplaceOut.Rows[0]["Clk_Date"] != DBNull.Value && Convert.ToString(dtReplaceOut.Rows[0]["Clk_Date"]) != string.Empty)
                        {
                            strClk_Date = DateTime.Parse(Convert.ToString(dtReplaceOut.Rows[0]["Clk_Date"]), CI).ToShortDateString();
                        }
                        // Replaces the OUT Details in the Clock Details Table.
                        UpdateInAndOutDetailsIntoClockDetails(inClk_DeviceId, inClk_Date, inClk_Time, inPunchType, inClk_Remarks, inClk_User, "", inClk_Status, Convert.ToString(inClk_Id), "O", 0, "");
                        if (strEmpId != string.Empty && strClk_InDeviceId != string.Empty && strClk_InDate != string.Empty && strClk_InTime != string.Empty)
                        {
                            string strInDateTime = strClk_InDate + " " + strClk_InTime;
                            SqlParameter pminClk_EmpId = new SqlParameter("@inClk_EmpId", inClk_EmpId);
                            SqlParameter pmstrInDateTime = new SqlParameter("@strInDateTime", strInDateTime);
                            SqlParameter pmgstrClockDate = new SqlParameter("@gstrClockDate", gstrClockDate);
                            SqlParameter pmType1 = new SqlParameter("@Type", "R");
                            SqlParameter[] pmetersClockDetails = { pminClk_EmpId, pmstrInDateTime, pmgstrClockDate, pmType1 };
                            dtReplaceOut = objDatafunction.GettingDatasetUsingParameter(pmetersClockDetails, "Proc_Ta_GetClockID_FirstData");
                            if (dtReplaceOut.Rows.Count > 0)
                            {
                                if (dtReplaceOut.Rows[0]["Clk_Id"] != DBNull.Value)
                                {
                                    // Old OUT Details stored in the Temporary Variables is sent as Parameters to the ReplaceAndInsert Function
                                    ReplaceInOutDetails(Convert.ToInt32(dtReplaceOut.Rows[0]["Clk_Id"]), "I", strEmpId, strClk_InDeviceId, DateTime.Parse(strClk_InDate, CI).ToShortDateString(), strClk_InTime, inClk_Remarks, inClk_User, inClk_Status, "R");
                                }
                                else
                                {
                                    strInsertFlag = "Y";
                                }
                            }
                            else
                            {
                                strInsertFlag = "Y";
                            }
                            if (strInsertFlag == "Y")
                            {
                                FreeScanInsertInDetails(inClk_EmpId, strClk_InDeviceId, DateTime.Parse(strClk_InDate, CI).ToShortDateString(), DateTime.Parse(strClk_InTime, CI).ToLongTimeString(), inClk_Remarks, inClk_User, inClk_Status);
                                return;
                            }
                        }
                    }
                    else
                    {
                        FreeScanInsertInDetails(inClk_EmpId, inClk_DeviceId, inClk_Date, inClk_Time, inClk_Remarks, inClk_User, inClk_Status);
                    }
                }
                else if (inPunchType == "I")
                {
                    dtReplaceIn = objDatafunction.GettingDatasetUsingParameter(pmeters, "Proc_TA_GetInAndOutPunchDetails");
                    if (dtReplaceIn.Rows.Count > 0)
                    {
                        string strEmpId = string.Empty, strClk_OutDeviceId = string.Empty, strClk_OutDate = string.Empty, strClk_Date = string.Empty;
                        string strClk_OutTime = string.Empty;
                        // Stores the Old OUT Details from the Clock Details Table in Temporary Variables.
                        if (dtReplaceIn.Rows[0]["Clk_EmpId"] != DBNull.Value && Convert.ToString(dtReplaceIn.Rows[0]["Clk_EmpId"]) != string.Empty)
                        {
                            strEmpId = Convert.ToString(dtReplaceIn.Rows[0]["Clk_EmpId"]);
                        }
                        if (dtReplaceIn.Rows[0]["Clk_InDeviceId"] != DBNull.Value && Convert.ToString(dtReplaceIn.Rows[0]["Clk_InDeviceId"]) != string.Empty)
                        {
                            strClk_OutDeviceId = Convert.ToString(dtReplaceIn.Rows[0]["Clk_InDeviceId"]);
                        }
                        if (dtReplaceIn.Rows[0]["Clk_InDate"] != DBNull.Value && Convert.ToString(dtReplaceIn.Rows[0]["Clk_InDate"]) != string.Empty)
                        {
                            strClk_OutDate = DateTime.Parse(Convert.ToString(dtReplaceIn.Rows[0]["Clk_InDate"]), CI).ToShortDateString();
                        }
                        if (dtReplaceIn.Rows[0]["Clk_InTime"] != DBNull.Value && Convert.ToString(dtReplaceIn.Rows[0]["Clk_InTime"]) != string.Empty)
                        {
                            strClk_OutTime = DateTime.Parse(Convert.ToString(dtReplaceIn.Rows[0]["Clk_InTime"]), CI).ToLongTimeString();
                        }
                        if (dtReplaceIn.Rows[0]["Clk_Date"] != DBNull.Value && Convert.ToString(dtReplaceIn.Rows[0]["Clk_Date"]) != string.Empty)
                        {
                            strClk_Date = DateTime.Parse(Convert.ToString(dtReplaceIn.Rows[0]["Clk_Date"]), CI).ToShortDateString();
                        }
                        // Replaces the In Details in the Clock Details Table.
                        UpdateInAndOutDetailsIntoClockDetails(inClk_DeviceId, inClk_Date, inClk_Time, inPunchType, inClk_Remarks, inClk_User, gstrClockDate, inClk_Status, Convert.ToString(inClk_Id), "I", 0, "");
                        if (strEmpId != string.Empty && strClk_OutDeviceId != string.Empty && strClk_OutDate != string.Empty && strClk_OutTime != string.Empty)
                        {
                            ReplaceInOutDetails(inClk_Id, "O", strEmpId, strClk_OutDeviceId, DateTime.Parse(strClk_OutDate, CI).ToShortDateString(), strClk_OutTime, inClk_Remarks, inClk_User, inClk_Status, "R");
                        }
                    }
                    else
                    {
                        FreeScanInsertInDetails(inClk_EmpId, inClk_DeviceId, inClk_Date, inClk_Time, inClk_Remarks, inClk_User, inClk_Status);
                    }
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
        public void FreeScanInsertInDetails(string inClk_EmpId, string inClk_DeviceId, string inClk_Date, string inClk_Time, string inClk_Remarks, string inClk_User, string inClk_Status)
        {
            try
            {
                // Assign the Company Id from Global Variable
                gstrCompanyId = Convert.ToString(gintCompanyId);
                InsertInAndOutDetails(inClk_EmpId, inClk_DeviceId, inClk_Date, inClk_Time, "I", inClk_Remarks, inClk_User, inClk_Status, "I", "");
                gstrCompanyId = string.Empty;
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
        public int UpdateInOutDetails(string inClk_EmpId, string inClk_DeviceId, string inClk_Date, string inClk_Time, string inClk_Remarks, string inClk_User, string inClk_Status, string inCallerType)
        {
            DataTable dtClockIn = new DataTable();
            DataTable dtClockCheck = new DataTable();
            string strPunchType = string.Empty, strDateTime = string.Empty, strSQLClockCheck = string.Empty;
            string strSQLIn = string.Empty;
            string strInsertFlag = "N";
            try
            {
                strDateTime = inClk_Date + " " + inClk_Time;
                SqlParameter pminClk_EmpId1 = new SqlParameter("@inClk_EmpId", inClk_EmpId);
                SqlParameter[] pmetersClockDetails1 = { pminClk_EmpId1 };
                dtClockCheck = objDatafunction.GettingDatasetUsingParameter(pmetersClockDetails1, "Proc_TA_CheckingEmployeeAvailedInClockDetails");
                if (dtClockCheck.Rows.Count > 0)
                {
                    SqlParameter pminClk_EmpId = new SqlParameter("@inClk_EmpId", inClk_EmpId);
                    SqlParameter pmstrInDateTime = new SqlParameter("@strInDateTime", strDateTime);
                    SqlParameter pmgstrClockDate = new SqlParameter("@gstrClockDate", gstrClockDate);
                    SqlParameter pmType1 = new SqlParameter("@Type", "U");
                    SqlParameter[] pmetersClockDetails = { pminClk_EmpId, pmstrInDateTime, pmgstrClockDate, pmType1 };
                    dtClockIn = objDatafunction.GettingDatasetUsingParameter(pmetersClockDetails, "Proc_Ta_GetClockID_FirstData");
                    if (dtClockIn.Rows.Count > 0)
                    {
                        string strSQLClockDetailsUpdate = string.Empty;
                        strPunchType = "I";
                        // Update the Clock Details Table with IN Record.
                        UpdateInAndOutDetailsIntoClockDetails(inClk_DeviceId, inClk_Date, inClk_Time, strPunchType, inClk_Remarks, inClk_User, gstrClockDate, inClk_Status, Convert.ToString(dtClockIn.Rows[0]["Clk_Id"]), "I", 0, "");
                    }
                    else
                    {
                        DataTable dtClockOut = new DataTable();
                        SqlParameter pminClk_EmpId2 = new SqlParameter("@inClk_EmpId", inClk_EmpId);
                        SqlParameter pmstrInDateTime2 = new SqlParameter("@strInDateTime", strDateTime);
                        SqlParameter pmgstrClockDate2 = new SqlParameter("@gstrClockDate", gstrClockDate);
                        SqlParameter pmType2 = new SqlParameter("@Type", "T");
                        SqlParameter[] pmetersClockDetails2 = { pminClk_EmpId2, pmstrInDateTime2, pmgstrClockDate2, pmType2 };
                        dtClockOut = objDatafunction.GettingDatasetUsingParameter(pmetersClockDetails2, "Proc_Ta_GetClockID_FirstData");
                        if (dtClockOut.Rows.Count > 0)
                        {
                            string strSQLClockDetailsUpdate = string.Empty;
                            strPunchType = "O";
                            //Update the Clock Details Table with OUT Record.
                            UpdateInAndOutDetailsIntoClockDetails(inClk_DeviceId, inClk_Date, inClk_Time, strPunchType, inClk_Remarks, inClk_User, "", inClk_Status, Convert.ToString(dtClockOut.Rows[0]["Clk_Id"]), "O", 0, "");
                        }
                        else
                        {
                            // Insert IN Details
                            strPunchType = "I";
                            strInsertFlag = "Y";
                        }
                    }
                }
                else
                {
                    // Insert IN Details
                    strPunchType = "I";
                    strInsertFlag = "Y";
                }
                // If Insert Flag is "Y", then insert IN Details
                if (strInsertFlag == "Y")
                {
                    if (inCallerType == "MoveInOutDetails")
                    {
                        return (0);
                    }
                    FreeScanInsertInDetails(inClk_EmpId, inClk_DeviceId, inClk_Date, inClk_Time, inClk_Remarks, inClk_User, inClk_Status);
                }
            }
            catch (Exception ex)
            {
                //eventLog1.WriteEntry("strSQLIn : " + strSQLIn);
            }
            return (1);
        }
        #endregion
        #region InsertVoidPunches
        public void InsertVoidPunches(string inClk_EmpId, string inClk_DeviceId, string inClk_Date, string inClk_Time, string inClk_Remarks, string inClk_User, string inClk_Status, string inClk_Type)
        {
            try
            {
                gstrCompanyId = Convert.ToString(gintCompanyId);
                InsertInAndOutDetails(inClk_EmpId, inClk_DeviceId, inClk_Date, inClk_Time, inClk_Type == "I" ? "I" : "O", inClk_Remarks, inClk_User, inClk_Status, inClk_Type == "I" ? "IV" : "OV", "");
                gstrCompanyId = string.Empty;
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
        #endregion
        #region ManualTimeEntry
        /// <summary>
        /// Purpose :
        ///     The ManualTimeEntry Method is a used to take Raw Data from the TimeCheck Manual Time Entry Table and insert 
        ///     matching IN and OUT Records for a particular Employee and Date
        /// </summary>
        public void ManualTimeEntry()
        {
            DataTable dtRawData, dtClockIn, dtClockOut;
            string strSQLUpdate = string.Empty, strReaderId = string.Empty;
            string strRawData;
            try
            {
                //Get the Raw Data from the Manual Time Entry Table
                dtRawData = objDatafunction.GettingDatasetWithoutParameter("Proc_TA_GetRawDataFromManualEntry");
                bool blnValueExists = false;
                bool blnFutreDateTime = false;
                string Shiftdate = string.Empty;
                string shiftOutDate = string.Empty;
                foreach (DataRow drRawData in dtRawData.Rows)
                {
                    blnValueExists = false;
                    blnFutreDateTime = false;
                    string strSQLcheck = string.Empty;
                    bool blnDuplicateExists = false;
                    //The Status is set to M to indicate that it is a Manual Entry                 
                    strClk_Status = "M";
                    try
                    {
                        if ((drRawData["ManualTimeEntry_InDate"] != DBNull.Value) && (drRawData["ManualTimeEntry_InTime"] != DBNull.Value) && (drRawData["ManualTimeEntry_InPunchType"] != DBNull.Value)) //If Type is IN
                        {
                            if ((Convert.ToString(drRawData["ManualTimeEntry_InDate"]) != string.Empty) && (Convert.ToString(drRawData["ManualTimeEntry_InTime"]) != string.Empty) && (Convert.ToString(drRawData["ManualTimeEntry_InPunchType"]) != string.Empty))
                            {
                                string strManualEntryInDateTime = DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InDate"]), CI).ToShortDateString() + " " + Convert.ToString(drRawData["ManualTimeEntry_InTime"]);
                                if (Convert.ToDateTime(strManualEntryInDateTime) < Convert.ToDateTime(Convert.ToString(DateTime.Now)))
                                {
                                    Shiftdate = Convert.ToString(drRawData["ManualTimeEntry_InDate"]);
                                    gintShiftId = GetShiftId(Convert.ToString(drRawData["SwipeCardNo"]), Shiftdate, Convert.ToString(drRawData["ManualTimeEntry_InTime"]));
                                    while (gintShiftId == -1)
                                    {
                                        TimeSpan ts = new TimeSpan(-1, 0, 0, 0);
                                        Shiftdate = DateTime.Parse(Shiftdate, CI).Add(ts).ToShortDateString();
                                        gintShiftId = GetShiftId(Convert.ToString(drRawData["SwipeCardNo"]), Shiftdate, Convert.ToString(drRawData["ManualTimeEntry_InTime"]));
                                    }
                                    if (gintShiftId != 0)
                                    {
                                        GetLevelId(Convert.ToString(drRawData["SwipeCardNo"]), Convert.ToString(drRawData["ManualTimeEntry_InDate"]));
                                        // Check in the Clock Details for Duplicate
                                        dtClockIn = CheckingEmployeeRecordAvailedForParticularDate(Convert.ToString(drRawData["SwipeCardNo"]), Convert.ToString(drRawData["ManualTimeEntry_InReaderID"]), Convert.ToString(drRawData["ManualTimeEntry_InDate"]), Convert.ToString(drRawData["ManualTimeEntry_InTime"]), "I");
                                        if (dtClockIn.Rows.Count == 0)
                                        {
                                            if (drRawData["ManualTimeEntry_InReaderID"] != DBNull.Value)
                                            {
                                                // Get the InReaderId
                                                strReaderId = GetReaderId(int.Parse(Convert.ToString(drRawData["ManualTimeEntry_InReaderID"])));
                                                if (strReaderId != string.Empty)
                                                {
                                                    string strPunchValue = string.Empty;
                                                    strPunchValue = GetPunchValue(strReaderId, Convert.ToString(drRawData["ManualTimeEntry_InPunchType"]));
                                                    if (strPunchValue == "")
                                                    {
                                                        WriteErrorDetailsToDB(Convert.ToString(drRawData["ManualTimeEntry_Id"]), "InPunch Type is not created/not in active", "M");
                                                    }
                                                    else
                                                    {
                                                        //Get Clock Date
                                                        gstrClockDate = GetClockDate(Convert.ToString(drRawData["SwipeCardNo"]), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InTime"]), CI).ToShortTimeString());
                                                        // Insert the Record into the Clock Details Table 
                                                        // Get the shift type based on Shift Id 
                                                        bool shiftType = GetShiftType(gintShiftId);
                                                        // Insert the Record into the Clock Details Table 
                                                        if (!shiftType) // Function Key Mapping if Shift Type is false
                                                        {
                                                            blnValueExists = ReplaceAndInsert(Convert.ToString(drRawData["SwipeCardNo"]), strReaderId, DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InTime"]), CI).ToShortTimeString(), strPunchValue, Convert.ToString(drRawData["ManualTimeEntry_Reason"]).Replace("'", "''"), Convert.ToString(drRawData["Emp_Id"]), strClk_Status, 0);
                                                            //Added By Manikandan.R 
                                                            //On 25-08-2014 11:32 am
                                                            if (Convert.ToString(drRawData["ManualTimeEntry_InPunchType"]) == "Break In")
                                                            {
                                                                MappingPunches(Convert.ToString(drRawData["SwipeCardNo"]), strReaderId, DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InTime"]), CI).ToShortTimeString(), "Break In", gstrClockDate);
                                                            }
                                                            if (blnValueExists == false)
                                                            {
                                                                UpdateClockDate(Convert.ToString(drRawData["SwipeCardNo"]), strReaderId, DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InTime"]), CI).ToShortTimeString(), strPunchValue, shiftType, strClk_Status, Convert.ToString(drRawData["Clock_Address"]), Convert.ToString(drRawData["Latitude_value"]), Convert.ToString(drRawData["Longitude_value"]));
                                                            }
                                                        }
                                                        else // Free Scan Mapping if Shift Type is true
                                                        {
                                                            blnDuplicateExists = false;
                                                            // Check Ignore Duplicate 
                                                            blnDuplicateExists = CheckIgnoreDuplicate(shiftType, Convert.ToString(drRawData["SwipeCardNo"]), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InTime"]), CI).ToLongTimeString(), gstrClockDate, "IO");
                                                            bool blnExactDuplicateExists = false;
                                                            DataTable dtCheckInDateExactDuplicateExists = new DataTable();
                                                            dtCheckInDateExactDuplicateExists = CheckExactDuplicateRecordExists(Convert.ToString(drRawData["SwipeCardNo"]), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InTime"]), CI).ToShortTimeString());
                                                            if (dtCheckInDateExactDuplicateExists.Rows.Count > 0)
                                                            {
                                                                if (Convert.ToInt32(dtCheckInDateExactDuplicateExists.Rows[0]["Count"]) > 0)
                                                                {
                                                                    blnExactDuplicateExists = true;
                                                                }
                                                            }
                                                            if (blnDuplicateExists == false)
                                                            {
                                                                DataTable dtDeviceType = new DataTable();
                                                                dtDeviceType = CheckingDeviceMappingInEntrance(strReaderId, "C");
                                                                if (dtDeviceType.Rows.Count > 0)
                                                                {
                                                                    if (Convert.ToInt32(dtDeviceType.Rows[0]["count"]) > 1)
                                                                    {
                                                                        FreeScan(Convert.ToString(drRawData["SwipeCardNo"]), strReaderId, DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InTime"]), CI).ToShortTimeString(), Convert.ToString(drRawData["ManualTimeEntry_Reason"]).Replace("'", "''"), Convert.ToString(drRawData["Emp_Id"]), strClk_Status);
                                                                    }
                                                                    if (Convert.ToInt32(dtDeviceType.Rows[0]["count"]) == 1)
                                                                    {
                                                                        //if both devices in and out are same, that time we are not checking punch types exists or not.B
                                                                        //But at the same time if the devices are different in entrance master, we are checking
                                                                        //punchtypes are available or not. To avoid that implemented below datatable.
                                                                        //For freescan logic we dont need to 
                                                                        DataTable dt_DeviceType = new DataTable();
                                                                        dt_DeviceType = CheckingDeviceMappingInEntrance(strReaderId, "T");
                                                                        string clkType = string.Empty;
                                                                        if (dt_DeviceType.Rows.Count > 0)
                                                                        {
                                                                            clkType = Convert.ToString(dt_DeviceType.Rows[0]["Type"]);
                                                                            clkType = (clkType.ToUpper() == "IN") ? "I" : "O";
                                                                        }
                                                                        blnValueExists = ReplaceAndInsert(Convert.ToString(drRawData["SwipeCardNo"]), strReaderId, DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InTime"]), CI).ToShortTimeString(), clkType, Convert.ToString(drRawData["ManualTimeEntry_Reason"]).Replace("'", "''"), Convert.ToString(drRawData["Emp_Id"]), strClk_Status, 0);
                                                                        if (blnValueExists == false)
                                                                        {
                                                                            UpdateClockDate(Convert.ToString(drRawData["SwipeCardNo"]), strReaderId, DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InTime"]), CI).ToShortTimeString(), strPunchValue, shiftType, strClk_Status, Convert.ToString(drRawData["Clock_Address"]), Convert.ToString(drRawData["Latitude_value"]), Convert.ToString(drRawData["Longitude_value"]));
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                            else
                                                            {
                                                                if (blnExactDuplicateExists == false)
                                                                {
                                                                    //Added by Manikandan.R
                                                                    // On 27-09-2013
                                                                    DataTable dtDeviceType = new DataTable();
                                                                    dtDeviceType = CheckingDeviceMappingInEntrance(strReaderId, "T");
                                                                    if (dtDeviceType.Rows.Count > 0)
                                                                    {
                                                                        if (Convert.ToString(dtDeviceType.Rows[0]["Type"]) == "In")
                                                                        {
                                                                            InsertVoidPunches(Convert.ToString(drRawData["SwipeCardNo"]), strReaderId, DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InTime"]), CI).ToLongTimeString(), Convert.ToString(drRawData["ManualTimeEntry_Reason"]).Replace("'", "''"), Convert.ToString(drRawData["Emp_Id"]), strClk_Status, "I");
                                                                        }
                                                                        if (Convert.ToString(dtDeviceType.Rows[0]["Type"]) == "Out")
                                                                        {
                                                                            InsertVoidPunches(Convert.ToString(drRawData["SwipeCardNo"]), strReaderId, DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InTime"]), CI).ToLongTimeString(), Convert.ToString(drRawData["ManualTimeEntry_Reason"]).Replace("'", "''"), Convert.ToString(drRawData["Emp_Id"]), strClk_Status, "O");
                                                                        }
                                                                    }
                                                                }
                                                            }
                                                            UpdateClockDate(Convert.ToString(drRawData["SwipeCardNo"]), strReaderId, DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_InTime"]), CI).ToShortTimeString(), strPunchValue, shiftType, strClk_Status, Convert.ToString(drRawData["Clock_Address"]), Convert.ToString(drRawData["Latitude_value"]), Convert.ToString(drRawData["Longitude_value"]));
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                                else
                                {
                                    blnFutreDateTime = true;
                                }
                            }
                        }
                        if ((drRawData["ManualTimeEntry_OutDate"] != DBNull.Value) && (drRawData["ManualTimeEntry_OutTime"] != DBNull.Value) && (drRawData["ManualTimeEntry_OutPunchType"] != DBNull.Value)) //If Type is OUT
                        {
                            if ((Convert.ToString(drRawData["ManualTimeEntry_OutDate"]) != string.Empty) && (Convert.ToString(drRawData["ManualTimeEntry_OutTime"]) != string.Empty) && (Convert.ToString(drRawData["ManualTimeEntry_OutPunchType"]) != string.Empty))
                            {
                                string strManualEntryOutDateTime = DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutDate"]), CI).ToShortDateString() + " " + Convert.ToString(drRawData["ManualTimeEntry_OutTime"]);
                                if (Convert.ToDateTime(strManualEntryOutDateTime) < Convert.ToDateTime(Convert.ToString(DateTime.Now)))
                                {
                                    shiftOutDate = Convert.ToString(drRawData["ManualTimeEntry_OutDate"]);
                                    gintShiftId = GetShiftId(Convert.ToString(drRawData["SwipeCardNo"]), shiftOutDate, Convert.ToString(drRawData["ManualTimeEntry_InTime"]));
                                    while (gintShiftId == -1)
                                    {
                                        TimeSpan ts = new TimeSpan(-1, 0, 0, 0);
                                        shiftOutDate = DateTime.Parse(shiftOutDate, CI).Add(ts).ToShortDateString();
                                        gintShiftId = GetShiftId(Convert.ToString(drRawData["SwipeCardNo"]), shiftOutDate, Convert.ToString(drRawData["ManualTimeEntry_InTime"]));
                                    }
                                    // gintShiftId = GetShiftId(drRawData["SwipeCardNo"].ToString(), drRawData["ManualTimeEntry_OutDate"].ToString());
                                    if (gintShiftId != 0)
                                    {
                                        GetLevelId(Convert.ToString(drRawData["SwipeCardNo"]), Convert.ToString(drRawData["ManualTimeEntry_OutDate"]));
                                        // Check in the Clock Details for Duplicate
                                        dtClockOut = CheckingEmployeeRecordAvailedForParticularDate(Convert.ToString(drRawData["SwipeCardNo"]), Convert.ToString(drRawData["ManualTimeEntry_OutReaderID"]), Convert.ToString(drRawData["ManualTimeEntry_OutDate"]), Convert.ToString(drRawData["ManualTimeEntry_OutTime"]), "O");
                                        if (dtClockOut.Rows.Count == 0)
                                        {
                                            // Get the OutReaderId
                                            strReaderId = GetReaderId(int.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutReaderID"])));
                                            if (strReaderId != string.Empty)
                                            {
                                                string strPunchValue = string.Empty;
                                                strPunchValue = GetPunchValue(strReaderId, Convert.ToString(drRawData["ManualTimeEntry_OutPunchType"]));
                                                if (strPunchValue == "")
                                                {
                                                    WriteErrorDetailsToDB(Convert.ToString(drRawData["ManualTimeEntry_Id"]), "OutPunch Type is not created/not in active", "M");
                                                }
                                                else
                                                {
                                                    //Get Clock Date
                                                    gstrClockDate = GetClockDate(Convert.ToString(drRawData["SwipeCardNo"]), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutTime"]), CI).ToShortTimeString());
                                                    // Get the shift type based on Shift Id 
                                                    bool shiftType = GetShiftType(gintShiftId);
                                                    if (!shiftType) // Function Key Mapping if Shift Type is false
                                                    {
                                                        blnValueExists = ReplaceAndInsert(Convert.ToString(drRawData["SwipeCardNo"]), strReaderId, DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutTime"]), CI).ToShortTimeString(), strPunchValue, Convert.ToString(drRawData["ManualTimeEntry_Reason"]).Replace("'", "''"), Convert.ToString(drRawData["Emp_Id"]), strClk_Status, 0);
                                                        if (Convert.ToString(drRawData["ManualTimeEntry_OutPunchType"]) == "Break Out")
                                                        {
                                                            MappingPunches(Convert.ToString(drRawData["SwipeCardNo"]), strReaderId, DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutTime"]), CI).ToShortTimeString(), "Break Out", gstrClockDate);
                                                        }
                                                        if (blnValueExists == false)
                                                        {
                                                            UpdateClockDate(Convert.ToString(drRawData["SwipeCardNo"]), strReaderId, DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutTime"]), CI).ToShortTimeString(), strPunchValue, shiftType, strClk_Status, Convert.ToString(drRawData["Clock_Address"]), Convert.ToString(drRawData["Latitude_value"]), Convert.ToString(drRawData["Longitude_value"]));
                                                        }
                                                    }
                                                    else // Free Scan Mapping if Shift Type is true
                                                    {
                                                        blnDuplicateExists = false;
                                                        // Check Ignore Duplicate 
                                                        blnDuplicateExists = CheckIgnoreDuplicate(shiftType, Convert.ToString(drRawData["SwipeCardNo"]), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutTime"]), CI).ToLongTimeString(), gstrClockDate, "IO");
                                                        bool blnExactDuplicateExists = false;
                                                        DataTable dtCheckInDateExactDuplicateExists = new DataTable();
                                                        dtCheckInDateExactDuplicateExists = CheckExactDuplicateRecordExists(Convert.ToString(drRawData["SwipeCardNo"]), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutTime"]), CI).ToShortTimeString());
                                                        if (dtCheckInDateExactDuplicateExists.Rows.Count > 0)
                                                        {
                                                            if (Convert.ToInt32(dtCheckInDateExactDuplicateExists.Rows[0]["Count"]) > 0)
                                                            {
                                                                blnExactDuplicateExists = true;
                                                            }
                                                        }
                                                        if (blnDuplicateExists == false)
                                                        {
                                                            DataTable dtDeviceType = new DataTable();
                                                            dtDeviceType = CheckingDeviceMappingInEntrance(strReaderId, "C");
                                                            if (dtDeviceType.Rows.Count > 0)
                                                            {
                                                                if (Convert.ToInt32(dtDeviceType.Rows[0]["count"]) > 1)
                                                                {
                                                                    FreeScan(Convert.ToString(drRawData["SwipeCardNo"]), strReaderId, DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutTime"]), CI).ToShortTimeString(), Convert.ToString(drRawData["ManualTimeEntry_Reason"]).Replace("'", "''"), Convert.ToString(drRawData["Emp_Id"]), strClk_Status);
                                                                }
                                                                if (Convert.ToInt32(dtDeviceType.Rows[0]["count"]) == 1)
                                                                {
                                                                    //if both devices in and out are same, that time we are not checking punch types exists or not.B
                                                                    //But at the same time if the devices are different in entrance master, we are checking
                                                                    //punchtypes are available or not. To avoid that implemented below datatable.
                                                                    //For freescan logic we dont need to 
                                                                    DataTable dt_DeviceType = new DataTable();
                                                                    dt_DeviceType = CheckingDeviceMappingInEntrance(strReaderId, "T");
                                                                    string clkType = string.Empty;
                                                                    if (dt_DeviceType.Rows.Count > 0)
                                                                    {
                                                                        clkType = Convert.ToString(dt_DeviceType.Rows[0]["Type"]);
                                                                        clkType = (clkType.ToUpper() == "IN") ? "I" : "O";
                                                                    }
                                                                    blnValueExists = ReplaceAndInsert(Convert.ToString(drRawData["SwipeCardNo"]), strReaderId, DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutTime"]), CI).ToShortTimeString(), clkType, Convert.ToString(drRawData["ManualTimeEntry_Reason"]).Replace("'", "''"), Convert.ToString(drRawData["Emp_Id"]), strClk_Status, 0);
                                                                    if (blnValueExists == false)
                                                                    {
                                                                        UpdateClockDate(Convert.ToString(drRawData["SwipeCardNo"]), strReaderId, DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutTime"]), CI).ToShortTimeString(), strPunchValue, shiftType, strClk_Status, Convert.ToString(drRawData["Clock_Address"]), Convert.ToString(drRawData["Latitude_value"]), Convert.ToString(drRawData["Longitude_value"]));
                                                                    }
                                                                }
                                                            }
                                                        }
                                                        else
                                                        {
                                                            if (blnExactDuplicateExists == false)
                                                            {
                                                                DataTable dtDeviceType = new DataTable();
                                                                dtDeviceType = CheckingDeviceMappingInEntrance(strReaderId, "T");
                                                                if (dtDeviceType.Rows.Count > 0)
                                                                {
                                                                    if (Convert.ToString(dtDeviceType.Rows[0]["Type"]) == "In")
                                                                    {
                                                                        InsertVoidPunches(Convert.ToString(drRawData["SwipeCardNo"]), strReaderId, DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutTime"]), CI).ToLongTimeString(), Convert.ToString(drRawData["ManualTimeEntry_Reason"]).Replace("'", "''"), Convert.ToString(drRawData["Emp_Id"]), strClk_Status, "I");
                                                                    }
                                                                    if (Convert.ToString(dtDeviceType.Rows[0]["Type"]) == "Out")
                                                                    {
                                                                        InsertVoidPunches(Convert.ToString(drRawData["SwipeCardNo"]), strReaderId, DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutTime"]), CI).ToLongTimeString(), Convert.ToString(drRawData["ManualTimeEntry_Reason"]).Replace("'", "''"), Convert.ToString(drRawData["Emp_Id"]), strClk_Status, "O");
                                                                    }
                                                                }
                                                            }
                                                        }
                                                        UpdateClockDate(Convert.ToString(drRawData["SwipeCardNo"]), strReaderId, DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutDate"]), CI).ToShortDateString(), DateTime.Parse(Convert.ToString(drRawData["ManualTimeEntry_OutTime"]), CI).ToShortTimeString(), strPunchValue, shiftType, strClk_Status, Convert.ToString(drRawData["Clock_Address"]), Convert.ToString(drRawData["Latitude_value"]), Convert.ToString(drRawData["Longitude_value"]));
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }
                                else
                                {
                                    blnFutreDateTime = true;
                                }
                            }
                        }
                        if (blnFutreDateTime == false)
                        {
                            // After the Processing, Update Clk_Process to 'Y' in Manual Time Entry Table
                            UpdateRawDataFlag(Convert.ToInt32(drRawData["ManualTimeEntry_Id"]), 2, 0, 1, "M");
                        }
                    }
                    catch (Exception ex)
                    {
                        string strErrorMessage = ex.Message.ToString().Replace(",", "");
                        WriteErrorToEventLog("CollectRawData", "function : ManualTimeEntry ; SwipeCardNo : " + drRawData["SwipeCardNo"].ToString() + "; Date : " + gstrClockDate + "; Error : " + ex.ToString());
                        WriteErrorDetailsToDB(Convert.ToString(drRawData["ManualTimeEntry_Id"]), strErrorMessage, "MU");
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "ManualTimeEntry ; Error : " + ex.ToString());
            }
        }
        #endregion
        #region CheckingEmployeeRecordAvailedForParticularDate
        public DataTable CheckingEmployeeRecordAvailedForParticularDate(string inClk_EmpId, string InReaderID, string InDate, string InTime, string type)
        {
            DataTable dtClockIn = new DataTable();
            try
            {
                SqlParameter pminClk_EmpId = new SqlParameter("@inClk_EmpId", inClk_EmpId);
                SqlParameter pmInReaderID = new SqlParameter("@InReaderID", InReaderID);
                SqlParameter pmInDate = new SqlParameter("@InDate", InDate);
                SqlParameter pmInTime = new SqlParameter("@InTime", InTime);
                SqlParameter pmtype = new SqlParameter("@type", type);
                SqlParameter[] ParamvaluesClockDetails = { pminClk_EmpId, pmInReaderID, pmInDate, pmInTime, pmtype };
                dtClockIn = objDatafunction.GettingDatasetUsingParameter(ParamvaluesClockDetails, "Proc_TA_CheckingEmployeeRecordAvailedForParticularDate");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "CheckingEmployeeRecordAvailedForParticularDate ; DeviceId : " + InReaderID + "; Type : " + type + "; Error : " + ex.ToString());
            }
            return dtClockIn;
        }
        #endregion
        #region GetReaderId
        // **********************************************************************************************************************
        // Purpose :
        //     The GetReaderId Function is used to get the Equivalent ReaderId for unique Terminal_Id in the Terminal Table 
        //
        // Inputs  :
        //     inTerminalId - Unique Terminal_Id (Auto Number)
        //
        // Returns :
        //     If Equivalent ReaderId is Present, then
        //        Returns the ReaderId
        //     If Equivalent ReaderId is not Present, then
        //         Returns Null Value
        // **********************************************************************************************************************
        public string GetReaderId(int inTerminalId)
        {
            string strReaderId = string.Empty;
            try
            {
                SqlParameter pminTerminalId = new SqlParameter("@inTerminalId", inTerminalId);
                SqlParameter[] pmTerminal = { pminTerminalId };
                strReaderId = objDatafunction.GettingScalarValueUsingParameter(pmTerminal, "Proc_TA_GetReaderDetails");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "GetReaderId ; TerminalId : " + inTerminalId + "; Error : " + ex.ToString());
                throw ex;
            }
            return strReaderId;
        }
        #endregion
        #region GetPunchValue
        public string GetPunchValue(string inClk_DeviceId, string inPunchType)
        {
            string strPunchValue = string.Empty;
            try
            {
                SqlParameter pminClk_DeviceId = new SqlParameter("@inClk_DeviceId", inClk_DeviceId);
                SqlParameter pminPunchType = new SqlParameter("@inPunchType", inPunchType);
                SqlParameter[] Paramvalues = { pminClk_DeviceId, pminPunchType };
                strPunchValue = objDatafunction.GettingScalarValueUsingParameter(Paramvalues, "Proc_TA_GetPunchValue");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "GetPunchValue ; DeviceId : " + inClk_DeviceId + "; PunchType : " + inPunchType + "; Error : " + ex.ToString());
            }
            return (strPunchValue);
        }
        #endregion
        #region CheckingDeviceMappingInEntrance
        public DataTable CheckingDeviceMappingInEntrance(string Clk_DeviceId, string Type)
        {
            DataTable dt = new DataTable();
            try
            {
                SqlParameter pmClk_DeviceId = new SqlParameter("@Clk_DeviceId", Clk_DeviceId);
                SqlParameter pmType = new SqlParameter("@Type", Type);
                SqlParameter[] pmetersEntrance = { pmClk_DeviceId, pmType };
                dt = objDatafunction.GettingDatasetUsingParameter(pmetersEntrance, "Proc_TA_CheckingDeviceMappingInEntrance");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "CheckingDeviceMappingInEntrance ; DeviceId : " + Clk_DeviceId + "; Type : " + Type + "; Error : " + ex.ToString());
            }
            return dt;
        }
        #endregion
        #region WriteErrorDetailsToDB
        public void WriteErrorDetailsToDB(string ClockId, string ErrorMessage, string type)
        {
            try
            {
                SqlParameter pmClk_Id = new SqlParameter("@Clk_Id", ClockId);
                SqlParameter pmstrErrorMessage = new SqlParameter("@strErrorMessage", ErrorMessage);
                SqlParameter pmType = new SqlParameter("@Type", type);
                SqlParameter[] pmetersErrorlog = { pmClk_Id, pmstrErrorMessage, pmType };
                objDatafunction.ExecuteQueryUsingParameter(pmetersErrorlog, "Proc_TA_WriteErrorDetails");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "WriteErrorDetailsToDB ; ClockId : " + ClockId + ";Error : " + ex.ToString());
            }
        }
        #endregion
        #region UpdateRawDataFlag
        public void UpdateRawDataFlag(Int64 CLK_ID, int reasonId, int clk_flag, int clk_Process, string Type)
        {
            try
            {
                SqlParameter pmCLK_ID = new SqlParameter("@CLK_ID", CLK_ID);
                SqlParameter pmReasonId = new SqlParameter("@ReasonId", reasonId);
                SqlParameter pmClk_Flag = new SqlParameter("@Clk_Flag", clk_flag);
                SqlParameter pmClk_Process = new SqlParameter("@Clk_Process", clk_Process);
                SqlParameter pmType = new SqlParameter("@Type", Type);
                SqlParameter[] pmetersUpdateRawData = { pmCLK_ID, pmReasonId, pmClk_Flag, pmClk_Process, pmType };
                objDatafunction.ExecuteQueryUsingParameter(pmetersUpdateRawData, "Proc_TA_UpdateRawDataFlag");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "UpdateRawDataFlag()" + "\r\n" + ex.Message);
            }
        }
        #endregion
        #region DateConvertion
        public string DateConvertion(string Format, string strDateTime)
        {
            string strFinalDate = "";
            try
            {
                if (strDateTime == string.Empty)
                {
                    return string.Empty;
                }
                // Getting Month
                int indexMonth = -2;
                int intMonthNoOfChars = 0;
                string strMonth = string.Empty;
                int indexMMM = Format.IndexOf(@"MMM");
                if (indexMMM == -1)
                {
                    int indexMM = Format.IndexOf(@"MM");
                    if (indexMM >= 0)
                    {
                        indexMonth = indexMM;
                        intMonthNoOfChars = 2;
                    }
                }
                else
                {
                    indexMonth = indexMMM;
                    intMonthNoOfChars = 3;
                }
                if (indexMonth != -2)
                {
                    strMonth = strDateTime.Substring(indexMonth, intMonthNoOfChars);
                }
                // Getting Date
                int indexDate = -2;
                int intDateNoOfChars = 0;
                string strDate = string.Empty;
                int indexDD = Format.IndexOf(@"dd");
                if (indexDD >= 0)
                {
                    indexDate = indexDD;
                    intDateNoOfChars = 2;
                }
                if (indexDate != -2)
                {
                    strDate = strDateTime.Substring(indexDate, intDateNoOfChars);
                }
                // Getting Year
                int indexYear = -2;
                int intYearNoOfChars = 0;
                string strYear = string.Empty;
                int indexYYYY = Format.IndexOf(@"yyyy");
                if (indexYYYY == -1)
                {
                    int indexYY = Format.IndexOf(@"yy");
                    if (indexYY >= 0)
                    {
                        indexYear = indexYY;
                        intYearNoOfChars = 2;
                    }
                }
                else
                {
                    indexYear = indexYYYY;
                    intYearNoOfChars = 4;
                }
                if (indexYear != -2)
                {
                    strYear = strDateTime.Substring(indexYear, intYearNoOfChars);
                }
                if (indexMMM >= 0)
                {
                    strFinalDate = strDate + "/" + strMonth + "/" + strYear;
                }
                else
                {
                    strFinalDate = strYear + "/" + strMonth + "/" + strDate;
                }
                DateTime dtmFinalDate = new DateTime();
                dtmFinalDate = DateTime.Parse(strFinalDate, CI);
            }
            catch (Exception ex)
            {
                //eventLog1.WriteEntry("DateConvertion : " + ex.ToString());
                WriteErrorToEventLog("CollectRawData", "DateConvertion : " + ex.ToString());
                throw ex;
            }
            return (strFinalDate);
        }
        #endregion
        #region TimeConvertion
        public string TimeConvertion(string Format, string strDateTime)
        {
            string strTime = string.Empty;
            try
            {
                if (strDateTime == string.Empty)
                {
                    return string.Empty;
                }
                // Getting Hours
                int indexHours = -2;
                int inHourstNoOfChars = 0;
                string strHours = "00";
                int indexhh = Format.IndexOf(@"hh");
                if (indexhh >= 0)
                {
                    indexHours = indexhh;
                    inHourstNoOfChars = 2;
                }
                if (indexHours != -2)
                {
                    strHours = strDateTime.Substring(indexHours, inHourstNoOfChars);
                }
                // Getting Minutes
                int indexMins = -2;
                int intMinsNoOfChars = 0;
                string strMins = "00";
                int indexmm = Format.IndexOf(@"mm");
                if (indexmm >= 0)
                {
                    indexMins = indexmm;
                    intMinsNoOfChars = 2;
                }
                if (indexMins != -2)
                {
                    strMins = strDateTime.Substring(indexMins, intMinsNoOfChars);
                }
                // Getting Seconds
                int indexSecs = -2;
                int intSecsNoOfChars = 0;
                string strSeconds = "00";
                int indexss = Format.IndexOf(@"ss");
                if (indexss >= 0)
                {
                    indexSecs = indexss;
                    intSecsNoOfChars = 2;
                }
                if (indexSecs != -2)
                {
                    strSeconds = strDateTime.Substring(indexSecs, intSecsNoOfChars);
                }
                // Getting AM or PM - If 12 Hours Format
                int indexAMPM = -2;
                int intAMPMNoOfChars = 0;
                string strAMPM = string.Empty;
                int indextt = Format.IndexOf(@"tt");
                if (indextt >= 0)
                {
                    indexAMPM = indextt;
                    intAMPMNoOfChars = 2;
                }
                if (indexAMPM != -2)
                {
                    strAMPM = strDateTime.Substring(indexAMPM, intAMPMNoOfChars);
                }
                if (indextt >= 0)
                {
                    strTime = strHours + ":" + strMins + ":" + strSeconds + " " + strAMPM;
                }
                else
                {
                    strTime = strHours + ":" + strMins + ":" + strSeconds;
                }
                DateTime dtmFinalTime = new DateTime();
                try
                {
                    dtmFinalTime = DateTime.Parse(strTime, CI);
                }
                catch (Exception ex)
                {
                    //eventLog1.WriteEntry("TimeConvertion : " + ex.ToString());
                    throw ex;
                }
            }
            catch (Exception ex)
            {
                throw ex;
            }
            return (strTime);
        }
        #endregion
        #region GettingDeviceDataBaseDetails
        public DataTable GettingDeviceDataBaseDetails(int intTerminalID, string inFiletype)
        {
            DataTable dtDeviceDB = new DataTable();
            try
            {
                SqlParameter pmFileType = new SqlParameter("@FileType", inFiletype);
                SqlParameter pmTerminalID = new SqlParameter("@TerminalDataTypeId", intTerminalID);
                SqlParameter[] pmetersRDBMS = { pmFileType, pmTerminalID };
                dtDeviceDB = objDatafunction.GettingDatasetUsingParameter(pmetersRDBMS, "Proc_TA_GettingDeviceDataBaseDetails");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "GettingDeviceDataBaseDetails()" + "\r\n" + ex.Message);
            }
            return dtDeviceDB;
        }
        #endregion
        #region CollectTextFileRawData
        // **********************************************************************************************************************
        // Purpose :
        //     The CollectTextFileRawData Method is used to get the Source Path for a particular FileType from the TimeCheck 
        //     Terminal DataType Table where the Text Files to be processed are present and gets the Directories from that Source
        //     Path and calls the ProcessDirectories() method to process all the SubDirectories.
        //   
        // Inputs  :
        //     inFiletype : Type of the File to be processed (In this Case : Text Files - Delimiter or Fixed Length)
        // **********************************************************************************************************************
        public void CollectTextFileRawData(int intTerminalID, string inFiletype, string strBrandName)
        {
            DataTable dtFileSourcePath = new DataTable();
            string strFileSourcePath = string.Empty;
            string strBackupSourcePath = string.Empty;
            string strBackupType = string.Empty;
            string strSQLSourcePath = string.Empty;
            try
            {
                // Get the Source Path for a particular File Type(Text Files - Delimiter or Fixed Length) from the TimeCheck Terminal DataType Table
                dtFileSourcePath = GettingDeviceDataBaseDetails(intTerminalID, inFiletype);
                if (dtFileSourcePath.Rows.Count > 0)
                {
                    if (dtFileSourcePath.Rows[0]["File_SourcePath"] != DBNull.Value)
                    {
                        strFileSourcePath = Convert.ToString(dtFileSourcePath.Rows[0]["File_SourcePath"]);
                    }
                    if (dtFileSourcePath.Rows[0]["File_BackupPath"] != DBNull.Value)
                    {
                        strBackupSourcePath = Convert.ToString(dtFileSourcePath.Rows[0]["File_BackupPath"]);
                    }
                    if (dtFileSourcePath.Rows[0]["File_BackupType"] != DBNull.Value)
                    {
                        strBackupType = Convert.ToString(dtFileSourcePath.Rows[0]["File_BackupType"]);
                    }
                }
                if (strFileSourcePath != string.Empty)
                {
                    // Get the Directory from the Source Path
                    DirectoryInfo diDirectoryInfo = new DirectoryInfo(strFileSourcePath);
                    ProcessDirectories(diDirectoryInfo, 0, inFiletype, strBackupSourcePath, strBackupType);
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "CollectTextFileRawData(); TerminalID : " + intTerminalID + "; Filetype : " + inFiletype + "; BrandName : " + strBrandName + "; Error : " + ex.ToString());
            }
        }
        #endregion
        #region ProcessDirectories
        // **********************************************************************************************************************
        // Purpose :
        //     The ProcessDirectories Method is a Recursive Method and is used to get the SubDirectories from all Levels    
        //     Recursively and Process the TextFiles in those Directories and SubDirectories by calling ProcessFiles() Method
        //     
        // Inputs  :
        //     inDirectoryInfo  : Root Directory Information
        //     inDirectoryLevel : Directory Level Number
        //     inFiletype       : Type of the File to be processed (In this Case : Text Files - Delimiter or Fixed Length)
        // **********************************************************************************************************************
        public void ProcessDirectories(DirectoryInfo inDirectoryInfo, int inDirectoryLevel, string inFiletype, string inBackupSourcePath, string inBackupType)
        {
            ProcessFiles(inDirectoryInfo, inDirectoryLevel, inFiletype, inBackupSourcePath, inBackupType);
            // Get the SubDirectories from the Directory
            foreach (DirectoryInfo diChildDirectoryInfo in inDirectoryInfo.GetDirectories())
            {
                // Recursive Call to get the Files or SubDirectories from the SubDirectories
                ProcessDirectories(diChildDirectoryInfo, inDirectoryLevel + 1, inFiletype, inBackupSourcePath, inBackupType);
            }
            if (inDirectoryLevel > 0)
            {
                inDirectoryInfo.Delete();
            }
        }
        // **********************************************************************************************************************
        // Purpose :
        //     The ProcessFiles Method is used to get all the Text Files in a particular Directory and read all the Text Files
        //     Line by Line to get the Raw Data Details such as CardNo,ReaderNo,Date,Time,Type(I-In (or) O-Out) and inserts
        //     these Raw Data into the TimeCheck Raw Data Table and finally moves the Processed File to the BackUp Path which 
        //     is specified in the TimeCheck Terminal DataType Table.
        //     
        // Inputs  :
        //     inDirectoryInfo  : Directory or SubDirectory Information
        //     inFiletype       : Type of the File to be processed (In this Case : Text Files - Delimiter or Fixed Length)
        // **********************************************************************************************************************
        public void ProcessFiles(DirectoryInfo inDirectoryInfo, int inDirectoryLevel, string inFiletype, string inBackupSourcePath, string inBackupType)
        {
            DataTable dtFixedLengthFiles = new DataTable();
            DataTable dtDelimiterFiles = new DataTable();
            DataTable dtEmployeeCheck = new DataTable();
            DataRow drFixedLengthFile;
            DataRow drDelimiterFile;
            string strTxtData = string.Empty;
            string strDeviceID = string.Empty;
            string strEmpID = string.Empty;
            string strDateTime = string.Empty;
            string strDate = string.Empty;
            string strTime = string.Empty;
            string strClkType = string.Empty;
            string strTransIdentifier = string.Empty;
            string strClkDate = string.Empty;
            string strClkTime = string.Empty;
            string strSQLInsert = string.Empty;
            string strSQLFileDetails = string.Empty;
            string strSQLCheckEmployee = string.Empty;
            // Get all the Files from the Directory and store in the FileInfo Array
            FileInfo[] fiFileList = inDirectoryInfo.GetFiles("*.*");
            // If there are no files in the Directory, then return
            if (fiFileList.Length == 0)
            {
                return;
            }
            string strPath = string.Empty;
            if (inBackupType == "MF" || inBackupType == "SF")
            {
                if (inDirectoryLevel > 0)
                {
                    strPath = inBackupSourcePath + "\\" + inDirectoryInfo.Name;
                    if (!Directory.Exists(strPath))
                    {
                        DirectoryInfo di = Directory.CreateDirectory(strPath);
                    }
                }
                else
                {
                    strPath = inBackupSourcePath;
                }
            }
            foreach (FileInfo fiFile in fiFileList)
            {
                // Get the File Path
                gstrDataOutFile = (fiFile.DirectoryName).ToString() + "\\" + fiFile.ToString();
                try
                {
                    // Get the Text File from the Specified Path and Store it in TextReader Object
                    TextReader trTextFiles = new StreamReader(gstrDataOutFile);
                    // Read the Text File Line by Line
                    while ((strTxtData = trTextFiles.ReadLine()) != null)
                    {
                        int intInsertBit = 0;
                        // If File Type is Fixed Length
                        if (inFiletype == "Fixed Length")
                        {
                            strSQLFileDetails = "select File_SourcePath,File_BackupPath,File_BackupType,FixedLength_ReaderNoFrom,FixedLength_ReaderNoTo,FixedLength_CardNoFrom,FixedLength_CardNoTo,FixedLength_DateTimeBit,FixedLength_DateTimeFrom,FixedLength_DateTimeTo,DateTimeFormat,FixedLength_DateFrom,FixedLength_DateTo,DateFormat,FixedLength_TimeFrom,FixedLength_TimeTo,TimeFormat,FixedLength_TypeFrom,FixedLength_TypeTo,FixedLength_TransactionIdentifierFrom,FixedLength_TransactionIdentifierTo,TransactionIdentifierBit,TransactionIdentifierValue from TA_Tbl_TerminalDataType where FileType = '" + inFiletype + "'";
                            if (strSQLFileDetails != string.Empty)
                            {
                                dtFixedLengthFiles = objDatafunction.ExecuteQuery(strSQLFileDetails, "TA_Tbl_TerminalDataType");
                            }
                            if (dtFixedLengthFiles.Rows.Count > 0)
                            {
                                drFixedLengthFile = dtFixedLengthFiles.Rows[0];
                                if (drFixedLengthFile["TransactionIdentifierBit"] != DBNull.Value)
                                {
                                    if (Convert.ToString(drFixedLengthFile["TransactionIdentifierBit"]) == "True")
                                    {
                                        if (drFixedLengthFile["TransactionIdentifierValue"] != DBNull.Value)
                                        {
                                            if (Convert.ToString(drFixedLengthFile["TransactionIdentifierValue"]) != string.Empty)
                                            {
                                                strTransIdentifier = strTxtData.Substring(int.Parse(Convert.ToString(drFixedLengthFile["FixedLength_TransactionIdentifierFrom"])) - 1, (int.Parse(Convert.ToString(drFixedLengthFile["FixedLength_TransactionIdentifierTo"])) - int.Parse(Convert.ToString(drFixedLengthFile["FixedLength_TransactionIdentifierFrom"]))) + 1);
                                                if (strTransIdentifier == Convert.ToString(drFixedLengthFile["TransactionIdentifierValue"]))
                                                {
                                                    intInsertBit = 1;
                                                }
                                            }
                                        }
                                    }
                                    else if (Convert.ToString(drFixedLengthFile["TransactionIdentifierBit"]) == "False")
                                    {
                                        intInsertBit = 1;
                                    }
                                }
                                if (intInsertBit == 1)
                                {
                                    if ((drFixedLengthFile["FixedLength_ReaderNoFrom"] != DBNull.Value) && (drFixedLengthFile["FixedLength_ReaderNoTo"] != DBNull.Value))
                                    {
                                        strDeviceID = strTxtData.Substring(int.Parse(Convert.ToString(drFixedLengthFile["FixedLength_ReaderNoFrom"])) - 1, (int.Parse(Convert.ToString(drFixedLengthFile["FixedLength_ReaderNoTo"])) - int.Parse(Convert.ToString(drFixedLengthFile["FixedLength_ReaderNoFrom"]))) + 1);
                                    }
                                    if ((drFixedLengthFile["FixedLength_CardNoFrom"] != DBNull.Value) && (drFixedLengthFile["FixedLength_CardNoTo"] != DBNull.Value))
                                    {
                                        strEmpID = strTxtData.Substring(int.Parse(Convert.ToString(drFixedLengthFile["FixedLength_CardNoFrom"])) - 1, (int.Parse(Convert.ToString(drFixedLengthFile["FixedLength_CardNoTo"])) - int.Parse(Convert.ToString(drFixedLengthFile["FixedLength_CardNoFrom"]))) + 1);
                                    }
                                    if (drFixedLengthFile["FixedLength_DateTimeBit"] != DBNull.Value)
                                    {
                                        if (Convert.ToString(drFixedLengthFile["FixedLength_DateTimeBit"]) == "True")
                                        {
                                            if ((drFixedLengthFile["FixedLength_DateTimeFrom"] != DBNull.Value) && (drFixedLengthFile["FixedLength_DateTimeTo"] != DBNull.Value) && (drFixedLengthFile["DateTimeFormat"] != DBNull.Value))
                                            {
                                                strDateTime = strTxtData.Substring(int.Parse(Convert.ToString(drFixedLengthFile["FixedLength_DateTimeFrom"])) - 1, (int.Parse(Convert.ToString(drFixedLengthFile["FixedLength_DateTimeTo"])) - int.Parse(Convert.ToString(drFixedLengthFile["FixedLength_DateTimeFrom"]))) + 1);
                                                strClkDate = DateConvertion(Convert.ToString(drFixedLengthFile["DateTimeFormat"]), strDateTime);
                                                strClkTime = TimeConvertion(Convert.ToString(drFixedLengthFile["DateTimeFormat"]), strDateTime);
                                            }
                                        }
                                        else if (Convert.ToString(drFixedLengthFile["FixedLength_DateTimeBit"]) == "False")
                                        {
                                            if ((drFixedLengthFile["FixedLength_DateFrom"] != DBNull.Value) && (drFixedLengthFile["FixedLength_DateTo"] != DBNull.Value) && (drFixedLengthFile["DateFormat"] != DBNull.Value))
                                            {
                                                strDate = strTxtData.Substring(int.Parse(Convert.ToString(drFixedLengthFile["FixedLength_DateFrom"])) - 1, (int.Parse(Convert.ToString(drFixedLengthFile["FixedLength_DateTo"])) - int.Parse(Convert.ToString(drFixedLengthFile["FixedLength_DateFrom"]))) + 1);
                                                strClkDate = DateConvertion(Convert.ToString(drFixedLengthFile["DateFormat"]), strDate);
                                            }
                                            if ((drFixedLengthFile["FixedLength_TimeFrom"] != DBNull.Value) && (drFixedLengthFile["FixedLength_TimeTo"] != DBNull.Value) && (drFixedLengthFile["TimeFormat"] != DBNull.Value))
                                            {
                                                strTime = strTxtData.Substring(int.Parse(Convert.ToString(drFixedLengthFile["FixedLength_TimeFrom"])) - 1, (int.Parse(Convert.ToString(drFixedLengthFile["FixedLength_TimeTo"])) - int.Parse(Convert.ToString(drFixedLengthFile["FixedLength_TimeFrom"]))) + 1);
                                                strClkTime = TimeConvertion(Convert.ToString(drFixedLengthFile["TimeFormat"]), strTime);
                                            }
                                        }
                                    }
                                    if ((drFixedLengthFile["FixedLength_TypeFrom"] != DBNull.Value) && (drFixedLengthFile["FixedLength_TypeTo"] != DBNull.Value))
                                    {
                                        strClkType = strTxtData.Substring(int.Parse(Convert.ToString(drFixedLengthFile["FixedLength_TypeFrom"])) - 1, (int.Parse(Convert.ToString(drFixedLengthFile["FixedLength_TypeTo"])) - int.Parse(Convert.ToString(drFixedLengthFile["FixedLength_TypeFrom"]))) + 1);
                                    }
                                }
                            }
                        }
                        // If File Type is Delimiter
                        else if (inFiletype == "Delimiter")
                        {
                            strSQLFileDetails = "select File_SourcePath,File_BackupPath,File_BackupType,Delimiter_NoOfFields,Delimiter_Delimiter,Delimiter_StringEnclosedBy,Delimiter_ReaderNo,Delimiter_CardNo,Delimiter_DateTimeBit,Delimiter_DateTime,DateTimeFormat,Delimiter_Date,DateFormat,Delimiter_Time,TimeFormat,Delimiter_Type,Delimiter_TransactionIdentifier,TransactionIdentifierBit,TransactionIdentifierValue from TA_Tbl_TerminalDataType where FileType = '" + inFiletype + "'";
                            if (strSQLFileDetails != string.Empty)
                            {
                                dtDelimiterFiles = objDatafunction.ExecuteQuery(strSQLFileDetails, "TA_Tbl_TerminalDataType");
                            }
                            if (dtDelimiterFiles.Rows.Count > 0)
                            {
                                drDelimiterFile = dtDelimiterFiles.Rows[0];
                                // Split the Line using the Delimiter which is defined in the Terminal DataType Master.
                                if (drDelimiterFile["Delimiter_Delimiter"] != DBNull.Value)
                                {
                                    char cDelimiter = char.Parse(Convert.ToString(drDelimiterFile["Delimiter_Delimiter"]).Trim());
                                    string[] strField = strTxtData.Split(cDelimiter);
                                    int intReaderNo = 0, intCardNo = 0, intDateTime = 0, intDate = 0, intTime = 0, intType = 0, intTransIdentifier = 0;
                                    if (drDelimiterFile["Delimiter_ReaderNo"] != DBNull.Value)
                                    {
                                        string strReaderNo = Convert.ToString(drDelimiterFile["Delimiter_ReaderNo"]);
                                        intReaderNo = int.Parse(strReaderNo.Substring(5, 1));
                                    }
                                    if (drDelimiterFile["Delimiter_CardNo"] != DBNull.Value)
                                    {
                                        string strCardNo = Convert.ToString(drDelimiterFile["Delimiter_CardNo"]);
                                        intCardNo = int.Parse(strCardNo.Substring(5, 1));
                                    }
                                    if (drDelimiterFile["Delimiter_DateTimeBit"] != DBNull.Value)
                                    {
                                        if (Convert.ToString(drDelimiterFile["Delimiter_DateTimeBit"]) == "True")
                                        {
                                            if (drDelimiterFile["Delimiter_DateTime"] != DBNull.Value)
                                            {
                                                string sDateTime = Convert.ToString(drDelimiterFile["Delimiter_DateTime"]);
                                                intDateTime = int.Parse(sDateTime.Substring(5, 1));
                                            }
                                        }
                                        else if (Convert.ToString(drDelimiterFile["Delimiter_DateTimeBit"]) == "False")
                                        {
                                            if (drDelimiterFile["Delimiter_Date"] != DBNull.Value)
                                            {
                                                string sDate = Convert.ToString(drDelimiterFile["Delimiter_Date"]);
                                                intDate = int.Parse(sDate.Substring(5, 1));
                                            }
                                            if (drDelimiterFile["Delimiter_Time"] != DBNull.Value)
                                            {
                                                string sTime = Convert.ToString(drDelimiterFile["Delimiter_Time"]);
                                                intTime = int.Parse(sTime.Substring(5, 1));
                                            }
                                        }
                                    }
                                    if (drDelimiterFile["Delimiter_Type"] != DBNull.Value)
                                    {
                                        string strType = Convert.ToString(drDelimiterFile["Delimiter_Type"]);
                                        intType = int.Parse(strType.Substring(5, 1));
                                    }
                                    if (drDelimiterFile["Delimiter_TransactionIdentifier"] != DBNull.Value)
                                    {
                                        string sTransIdentifier = Convert.ToString(drDelimiterFile["Delimiter_TransactionIdentifier"]);
                                        intTransIdentifier = int.Parse(sTransIdentifier.Substring(5, 1));
                                    }
                                    string strStringEnclosed = "Y";
                                    // If StringEnclosedBy is Present 
                                    if (drDelimiterFile["Delimiter_StringEnclosedBy"] != DBNull.Value)
                                    {
                                        if (Convert.ToString(drDelimiterFile["Delimiter_StringEnclosedBy"]).Trim() != string.Empty)
                                        {
                                            char cStringEnclosedBy = char.Parse(Convert.ToString(drDelimiterFile["Delimiter_StringEnclosedBy"]).Trim());
                                            string[] Fields = new string[strField.Length];
                                            for (int i = 0; i <= (strField.Length - 1); i++)
                                            {
                                                string[] Temp = strField[i].Split(cStringEnclosedBy);
                                                Fields[i] = Temp[1];
                                            }
                                            strDeviceID = Fields[intReaderNo - 1];
                                            strEmpID = Fields[intCardNo - 1];
                                            if (drDelimiterFile["Delimiter_DateTimeBit"] == DBNull.Value)
                                            {
                                                if (Convert.ToString(drDelimiterFile["Delimiter_DateTimeBit"]) == "True")
                                                {
                                                    if (intDateTime != 0 && drDelimiterFile["DateTimeFormat"] != DBNull.Value)
                                                    {
                                                        strDateTime = Fields[intDateTime - 1];
                                                        strClkDate = DateConvertion(Convert.ToString(drDelimiterFile["DateTimeFormat"]), strDateTime);
                                                        strClkTime = TimeConvertion(Convert.ToString(drDelimiterFile["DateTimeFormat"]), strDateTime);
                                                    }
                                                }
                                                else if (Convert.ToString(drDelimiterFile["Delimiter_DateTimeBit"]) == "False")
                                                {
                                                    if ((intDate != 0) && (intTime != 0) && (drDelimiterFile["DateFormat"] != DBNull.Value) && (drDelimiterFile["TimeFormat"] != DBNull.Value))
                                                    {
                                                        strDate = Fields[intDate - 1];
                                                        strClkDate = DateConvertion(Convert.ToString(drDelimiterFile["DateFormat"]), strDate);
                                                        strTime = Fields[intTime - 1];
                                                        strClkTime = TimeConvertion(Convert.ToString(drDelimiterFile["TimeFormat"]), strTime);
                                                    }
                                                }
                                            }
                                            strClkType = Fields[intType - 1];
                                            strTransIdentifier = Fields[intTransIdentifier - 1];
                                        }
                                        else
                                        {
                                            strStringEnclosed = "N";
                                        }
                                    }
                                    // If StringEnclosedBy is not Present 
                                    else
                                    {
                                        strStringEnclosed = "N";
                                    }
                                    if (strStringEnclosed == "N")
                                    {
                                        strDeviceID = strField[intReaderNo - 1];
                                        strEmpID = strField[intCardNo - 1];
                                        if (drDelimiterFile["Delimiter_DateTimeBit"] != DBNull.Value)
                                        {
                                            if (Convert.ToString(drDelimiterFile["Delimiter_DateTimeBit"]) == "True")
                                            {
                                                if (intDateTime != 0 && drDelimiterFile["DateTimeFormat"] != DBNull.Value)
                                                {
                                                    strDateTime = strField[intDateTime - 1];
                                                    strClkDate = DateConvertion(Convert.ToString(drDelimiterFile["DateTimeFormat"]), strDateTime);
                                                    strClkTime = TimeConvertion(Convert.ToString(drDelimiterFile["DateTimeFormat"]), strDateTime);
                                                }
                                            }
                                            else if (Convert.ToString(drDelimiterFile["Delimiter_DateTimeBit"]) == "False")
                                            {
                                                if ((intDate != 0) && (intTime != 0) && (drDelimiterFile["DateFormat"] != DBNull.Value) && (drDelimiterFile["TimeFormat"] != DBNull.Value))
                                                {
                                                    strDate = strField[intDate - 1];
                                                    strClkDate = DateConvertion(Convert.ToString(drDelimiterFile["DateFormat"]), strDate);
                                                    strTime = strField[intTime - 1];
                                                    strClkTime = TimeConvertion(Convert.ToString(drDelimiterFile["TimeFormat"]), strTime);
                                                }
                                            }
                                        }
                                        strClkType = strField[intType - 1];
                                        strTransIdentifier = strField[intTransIdentifier - 1];
                                    }
                                    if (drDelimiterFile["TransactionIdentifierBit"] != DBNull.Value)
                                    {
                                        if (Convert.ToString(drDelimiterFile["TransactionIdentifierBit"]) == "True")
                                        {
                                            if (drDelimiterFile["TransactionIdentifierValue"] != DBNull.Value)
                                            {
                                                if (Convert.ToString(drDelimiterFile["TransactionIdentifierValue"]) != string.Empty)
                                                {
                                                    if (strTransIdentifier == Convert.ToString(drDelimiterFile["TransactionIdentifierValue"]))
                                                    {
                                                        intInsertBit = 1;
                                                    }
                                                }
                                            }
                                        }
                                        else if (Convert.ToString(drDelimiterFile["TransactionIdentifierBit"]) == "False")
                                        {
                                            intInsertBit = 1;
                                        }
                                    }
                                }
                            }
                        }
                        if (intInsertBit == 1)
                        {
                            // Check in the TimeCheck Employee Table whether EmployeeId which is got from the Text File is Valid and Active Employee
                            InsertRawDataDetails(strEmpID, strDeviceID, strClkDate, strClkTime, strClkType);
                        }
                    }
                    trTextFiles.Close();
                    //if (inBackupType == "SF")
                    //{
                    //    System.IO.File.Move(gstrDataOutFile, inDirectoryInfo + "\\" + Path.GetFileName(fiFile.FullName) + DateTime.Now.ToString("ddMMyyyyhhmmss") + ".txt");
                    //}
                    //else
                    //{
                    if (inBackupType == "MF" || inBackupType == "SF")
                    {
                        // Move the ProcessedFile to the File Backup Path defined in the Terminal Datatype Master
                        if (strPath != string.Empty)
                        {
                            System.IO.File.Move(gstrDataOutFile, strPath + "\\" + Path.GetFileName(fiFile.FullName) + DateTime.Now.ToString("ddMMyyyyhhmmss") + ".txt");
                        }
                    }
                    //}
                }
                catch (Exception Ex)
                {
                    //string message = Ex.Message;
                    //eventLog1.WriteEntry("Collect Data - TextFile : " + Ex.ToString());
                    WriteErrorToEventLog("CollectRawData", "Collect Data - TextFile : " + Ex.ToString());
                    throw Ex;
                }
            }
        }
        #endregion
        #region BeCalled
        public static int BeCalled(uint nTotal, uint nDone)
        {
            return 0;
        }
        #endregion
        #region GetDeviceInfo
        private string GetDeviceInfo(string strIPAddress, string strDevID, string strDevPwd, string strPort)
        {
            string devInfo;
            //string ip_addr = this.Txt_IP.Text;
            //string password = this.Txt_PW.Text;
            // string ip_addr = "192.168.0.165";
            string ip_addr = strIPAddress;
            string password = strDevPwd;
            string DevID = strDevID;
            //devInfo = "DeviceInfo( dev_id = \"0\" dev_type = \"HW_HDCP\" comm_type = \"ip\" ip_address = ";
            //devInfo += "\"192.168.0.165\" password = \"1\")";
            devInfo = "DeviceInfo( dev_id = \"" + strDevID + "\" dev_type = \"HW_HDCP\" comm_type = \"ip\" ip_address =\"" + strIPAddress + "\" password = \"" + strDevPwd + "\")";
            int devPort = -1;
            //int.TryParse("9922", out devPort);
            int.TryParse(ConfigurationSettings.AppSettings["Hanvon_Dev_Port"].ToString(), out devPort);
            if (devPort != -1)
            {
                devInfo = devInfo.Insert(devInfo.Length - 1, " port_number = \"" + devPort + '"');
            }
            return devInfo;
        }
        #endregion
        #region HwDev_Execute
        public static int HwDev_Execute(string pDevInfoBuf, int nDevInfoLen, string pSendBuf, int nSendLen, ref string pRecvBuf, ref uint pRecvLen, CallBack pFuncTotalDone)
        {
            int ret = 0;
            IntPtr dataPtr = IntPtr.Zero;
            byte[] data;
            IntPtr pRecvBuf2 = IntPtr.Zero;
            try
            {
                data = ASCIIEncoding.Default.GetBytes(pSendBuf);
                int dataLen = (int)data.Length;
                dataPtr = Program.GlobalAlloc(0x0000, dataLen);
                if (dataPtr == IntPtr.Zero)
                    return -1;// (int)RetValue.ERR_RECG_NOT_ENOUGH_MEM;
                dataPtr = Program.GlobalLock(dataPtr);
                if (dataPtr == IntPtr.Zero)
                    return -1;// (int)RetValue.ERR_RECG_NOT_ENOUGH_MEM;
                Marshal.Copy(data, 0, dataPtr, dataLen);
                ret = Program.HwDev_Execute(pDevInfoBuf, pDevInfoBuf.Length, dataPtr, dataLen, ref pRecvBuf2, ref pRecvLen, pFuncTotalDone);
                pRecvBuf = Marshal.PtrToStringAnsi(pRecvBuf2);
                Program.HwDev_Finish(ref pRecvBuf2);
            }
            catch (System.Exception e)
            {
                ret = -1;
                throw new OperationCanceledException(e.Message);
            }
            finally
            {
                Program.GlobalUnlock(dataPtr);
                Program.GlobalFree(dataPtr);
                data = null;
            }
            return ret;
        }
        #endregion
        #region DecryptDateTime
        public string DecryptDateTime(int inDateTime, string inType)
        {
            if (inDateTime == 0)
            {
                return string.Empty;
            }
            string strMonth = string.Empty, strDay = string.Empty, strYear = string.Empty, strHours = string.Empty, strMins = string.Empty, strSeconds = string.Empty;
            string strDateTime = inDateTime.ToString("X");
            if (strDateTime.Length == 3 || strDateTime.Length == 4)
            {
                strDateTime = "00" + strDateTime;
            }
            else if (strDateTime.Length == 2 || strDateTime.Length == 1)
            {
                strDateTime = "0000" + strDateTime;
            }
            if (inType == "D")
            {
                if (strDateTime.Length == 5)
                {
                    strMonth = Convert.ToInt16((strDateTime.Substring(1, 2)), 16).ToString("00");
                    strDay = Convert.ToInt16((strDateTime.Substring(3, 2)), 16).ToString("00");
                    strYear = Convert.ToInt16((strDateTime.Substring(0, 1)), 16).ToString("00");
                }
                else if (strDateTime.Length == 6)
                {
                    strMonth = Convert.ToInt16((strDateTime.Substring(2, 2)), 16).ToString("00");
                    strDay = Convert.ToInt16((strDateTime.Substring(4, 2)), 16).ToString("00");
                    strYear = Convert.ToInt16((strDateTime.Substring(0, 2)), 16).ToString("00");
                }
                strDateTime = strMonth + "/" + strDay + "/" + strYear;
            }
            else if (inType == "T")
            {
                if (strDateTime.Length == 5)
                {
                    strHours = Convert.ToInt16((strDateTime.Substring(0, 1)), 16).ToString("00");
                    strMins = Convert.ToInt16((strDateTime.Substring(1, 2)), 16).ToString("00");
                    strSeconds = Convert.ToInt16((strDateTime.Substring(3, 2)), 16).ToString("00");
                }
                else if (strDateTime.Length == 6)
                {
                    strHours = Convert.ToInt16((strDateTime.Substring(0, 2)), 16).ToString("00");
                    strMins = Convert.ToInt16((strDateTime.Substring(2, 2)), 16).ToString("00");
                    strSeconds = Convert.ToInt16((strDateTime.Substring(4, 2)), 16).ToString("00");
                }
                strDateTime = strHours + ":" + strMins + ":" + strSeconds;
            }
            try
            {
                DateTime dtmDateTime = DateTime.Parse(strDateTime, CI);
            }
            catch (Exception ex)
            {
                strDateTime = string.Empty;
                WriteErrorToEventLog("CollectRawData", "DecryptDateTime ; DateTime : " + inDateTime + "; inType : " + inType + "; Error : " + ex.ToString());
                throw ex;
            }
            return (strDateTime);
        }
        #endregion
        #region CollectMDBRawData
        // **********************************************************************************************************************
        // Purpose :
        //     The CollectMDBRawData Method is used to get the Raw Data from MDB File and inserts the Raw Data into the
        //     TimeCheck Raw Data Table
        // **********************************************************************************************************************
        public void CollectMDBRawData(int intTerminalID, string inFileType, string strBrandName)
        {
            DataTable dtRDBMSDetails = new DataTable();
            DataTable dtRdbmsRawData = new DataTable();
            DataTable dtRawData = new DataTable();
            DataTable dtEmployee = new DataTable();
            DateTime dtmDateTime = new DateTime();
            string strSQL = string.Empty;
            string strSQLFileDetails = string.Empty, strConnectionString = string.Empty, strTableName = string.Empty;
            string strColReaderNo = string.Empty, strColCardNo = string.Empty, strColDateTime = string.Empty;
            string strColDate = string.Empty, strColTime = string.Empty, strColType = string.Empty;
            string strColFlag = string.Empty, strColTransIdentifier = string.Empty, strTransIdentifierValue = string.Empty;
            string strDateTime = string.Empty, strDate = string.Empty, strTime = string.Empty;
            try
            {
                dtRDBMSDetails = GettingDeviceDataBaseDetails(intTerminalID, inFileType);
                if (dtRDBMSDetails.Rows.Count > 0)
                {
                    if (dtRDBMSDetails.Rows[0]["ConnectionString"] != DBNull.Value)
                    {
                        char[] split = { ';' };
                        string strSpt = "";
                        string sptChr = Convert.ToString(dtRDBMSDetails.Rows[0]["ConnectionString"]);
                        if (sptChr != "")
                        {
                            string[] strFilters = sptChr.Split(split);
                            if (strFilters.Length > 1)
                                strConnectionString = Convert.ToString(dtRDBMSDetails.Rows[0]["ConnectionString"]);
                            else
                                strConnectionString = Cryptographys.Cryptography.Decrypt_BioStar(Convert.ToString(dtRDBMSDetails.Rows[0]["ConnectionString"]), "");
                        }
                    }
                    if (dtRDBMSDetails.Rows[0]["TableName"] != DBNull.Value)
                    {
                        strTableName = Convert.ToString(dtRDBMSDetails.Rows[0]["TableName"]);
                    }
                    if (dtRDBMSDetails.Rows[0]["MDB_ReaderNo"] != DBNull.Value)
                    {
                        strColReaderNo = Convert.ToString(dtRDBMSDetails.Rows[0]["MDB_ReaderNo"]);
                    }
                    if (dtRDBMSDetails.Rows[0]["MDB_CardNo"] != DBNull.Value)
                    {
                        strColCardNo = Convert.ToString(dtRDBMSDetails.Rows[0]["MDB_CardNo"]);
                    }
                    if (dtRDBMSDetails.Rows[0]["MDB_DateTimeBit"] != DBNull.Value)
                    {
                        if (Convert.ToString(dtRDBMSDetails.Rows[0]["MDB_DateTimeBit"]) == "True")
                        {
                            if (dtRDBMSDetails.Rows[0]["MDB_DateTime"] != DBNull.Value)
                            {
                                strColDateTime = Convert.ToString(dtRDBMSDetails.Rows[0]["MDB_DateTime"]);
                            }
                        }
                        else if (Convert.ToString(dtRDBMSDetails.Rows[0]["MDB_DateTimeBit"]) == "False")
                        {
                            if ((dtRDBMSDetails.Rows[0]["MDB_Date"] != DBNull.Value) && (dtRDBMSDetails.Rows[0]["MDB_Time"] != DBNull.Value))
                            {
                                strColDate = Convert.ToString(dtRDBMSDetails.Rows[0]["MDB_Date"]);
                                strColTime = Convert.ToString(dtRDBMSDetails.Rows[0]["MDB_Time"]);
                            }
                        }
                    }
                    if (dtRDBMSDetails.Rows[0]["MDB_Type"] != DBNull.Value)
                    {
                        strColType = Convert.ToString(dtRDBMSDetails.Rows[0]["MDB_Type"]);
                    }
                    if (dtRDBMSDetails.Rows[0]["RDBMS_MDB_Flag"] != DBNull.Value)
                    {
                        strColFlag = Convert.ToString(dtRDBMSDetails.Rows[0]["RDBMS_MDB_Flag"]);
                    }
                    if (dtRDBMSDetails.Rows[0]["MDB_TransactionIdentifier"] != DBNull.Value)
                    {
                        strColTransIdentifier = Convert.ToString(dtRDBMSDetails.Rows[0]["MDB_TransactionIdentifier"]);
                    }
                    if (dtRDBMSDetails.Rows[0]["TransactionIdentifierValue"] != DBNull.Value)
                    {
                        strTransIdentifierValue = Convert.ToString(dtRDBMSDetails.Rows[0]["TransactionIdentifierValue"]);
                    }
                    if ((strColDateTime != string.Empty) || (strColDate != string.Empty && strColTime != string.Empty))
                    {
                        if (dtRDBMSDetails.Rows[0]["strSQL"] != DBNull.Value)
                        {
                            strSQL = Convert.ToString(dtRDBMSDetails.Rows[0]["strSQL"]);
                        }
                    }

                    DataTable dtTblExists = new DataTable();
                    DataTable dtlogTableDetails = new DataTable();
                    CI.DateTimeFormat.ShortTimePattern = "hh:mm:ss tt";
                    CI.DateTimeFormat.LongTimePattern = "hh:mm:ss tt";
                    string finalMonth = "";
                    string strFinaltableName = "";
                    string strTableExistsQuery = "";
                    int CurrentYear = Convert.ToInt32(DateTime.Now.Year);
                    int CurrentMonth = Convert.ToInt32(DateTime.Now.Month);
                    double lastLogID = 0;
                    strTableExistsQuery = "select name from MSysObjects where type In (1, 4, 6) and name = ";
                    string dataCollectionQuery = "";
                    int maxlogID = 0;
                    switch (strBrandName)
                    {
                        //Table will be created dynamically due to this we brought up this option newly service.
                        // on 03-Aug-2020 12:42 PM
                        //implemented into ultimate alloys company
                        case "ESSL":
                            try
                            {
                                #region ESSL
                                for (int i = 2; i >= 0; i--)
                                {

                                    if (CurrentMonth == 0)
                                    {
                                        CurrentYear = Convert.ToInt16(CurrentYear) - 1;
                                        CurrentMonth = 12;
                                    }
                                    finalMonth = "";
                                    strFinaltableName = "";
                                    lastLogID = 0;
                                    maxlogID = 0;
                                    strFinaltableName = strTableName + Convert.ToString(CurrentMonth) + "_" + Convert.ToString(CurrentYear);
                                    dtlogTableDetails = GetDeviceLogTableDetails(strFinaltableName);
                                    if (dtlogTableDetails.Rows.Count > 0)
                                    {
                                        lastLogID = Convert.ToDouble(dtlogTableDetails.Rows[0]["LastLogID"]);
                                    }                                    
                                    if (strTableExistsQuery != string.Empty)
                                    {
                                        objDatafunction.InitializeRDBMSConnection(strConnectionString);
                                        dtTblExists = objDatafunction.rdbmsExecuteQuery(strTableExistsQuery + "'" + Convert.ToString(strFinaltableName) + "'", Convert.ToString(strFinaltableName));
                                        if (dtTblExists.Rows.Count > 0)
                                        {
                                            dataCollectionQuery = strSQL.Replace("#Table_Name", strFinaltableName);
                                            dataCollectionQuery = dataCollectionQuery.Replace("#log_Number", lastLogID.ToString());
                                            dtRdbmsRawData = objDatafunction.rdbmsExecuteQuery(dataCollectionQuery, strTableName);
                                            CI.DateTimeFormat.ShortTimePattern = "hh:mm tt";
                                            CI.DateTimeFormat.LongTimePattern = "hh:mm tt";
                                            if (dtRdbmsRawData.Rows.Count > 0)
                                            {
                                                InsertLogToRawDataTable_WithOutPunchTypes(dtRDBMSDetails, dtRdbmsRawData, strColReaderNo, strColCardNo, strColDateTime, "", "");
                                                //ToDo: need to enabled below line instead of above line.
                                                //InsertLogToRawDataTable(dtRDBMSDetails, dtRdbmsRawData, strConnectionString, strColReaderNo, strColCardNo, strColDateTime, strColDate, strColTime, strColType, strColFlag);
                                                //Todo: This field need to be confirmed with ESSL database.
                                                if (strColFlag != "" && strColFlag != "NoFlag")
                                                    maxlogID = (int)dtRdbmsRawData.Compute("MAX(" + strColFlag + ")", "");
                                            }
                                            if (strColFlag != "" && strColFlag != "NoFlag")
                                                InsertDeviceLogDetails(strFinaltableName, maxlogID);
                                        }
                                    }
                                    CurrentMonth -= 1;
                                }
                                #endregion
                            }
                            catch (Exception ex)
                            {
                                WriteErrorToEventLog("CollectRawData", "CollectMDBRawData(); Error : " + ex.ToString());
                                throw ex;
                            }
                            break;
                        default:
                            if (strSQL != string.Empty)
                            {
                                //Two columns are need to be created into mdb database file -susername and nindex column.
                                objDatafunction.InitializeRDBMSConnection(strConnectionString);
                                dtRdbmsRawData = objDatafunction.rdbmsExecuteQuery(strSQL, strTableName);
                            }
                            foreach (DataRow drRdbmsRawData in dtRdbmsRawData.Rows)
                            {
                                string strSQLInsert = string.Empty, strSQLUpdate = string.Empty, strSQLCheckEmployee = string.Empty;
                                if ((Convert.ToString(drRdbmsRawData[strColReaderNo]) != string.Empty) && (Convert.ToString(drRdbmsRawData[strColCardNo]) != string.Empty) && (Convert.ToString(drRdbmsRawData[strColType]) != string.Empty))
                                {
                                    if (dtRDBMSDetails.Rows[0]["MDB_DateTimeBit"] != DBNull.Value)
                                    {
                                        if (Convert.ToString(dtRDBMSDetails.Rows[0]["MDB_DateTimeBit"]) == "True")
                                        {
                                            if (drRdbmsRawData[strColDateTime] != DBNull.Value && Convert.ToString(drRdbmsRawData[strColDateTime]) != string.Empty && Convert.ToString(drRdbmsRawData[strColDateTime]) != "0")
                                            {
                                                dtmDateTime = DateTime.Parse(Convert.ToString(drRdbmsRawData[strColDateTime]), CI);
                                            }
                                            strDate = dtmDateTime.ToShortDateString();
                                            strTime = dtmDateTime.ToLongTimeString();
                                        }
                                        else if (Convert.ToString(dtRDBMSDetails.Rows[0]["MDB_DateTimeBit"]) == "False")
                                        {
                                            if ((drRdbmsRawData[strColDate] != DBNull.Value) && (drRdbmsRawData[strColTime] != DBNull.Value) && (Convert.ToString(drRdbmsRawData[strColDate]) != string.Empty) && (Convert.ToString(drRdbmsRawData[strColTime]) != string.Empty) && (Convert.ToString(drRdbmsRawData[strColDate]) != "0") && (Convert.ToString(drRdbmsRawData[strColTime]) != "0"))
                                            {
                                                if (dtRDBMSDetails.Rows[0]["IsEncrypted"] != DBNull.Value)
                                                {
                                                    if (Convert.ToString(dtRDBMSDetails.Rows[0]["IsEncrypted"]) == "True")
                                                    {
                                                        strDate = DecryptDateTime(int.Parse(Convert.ToString(drRdbmsRawData[strColDate])), "D");
                                                        strTime = DecryptDateTime(int.Parse(Convert.ToString(drRdbmsRawData[strColTime])), "T");
                                                    }
                                                    else
                                                    {
                                                        strDate = DateTime.Parse(Convert.ToString(drRdbmsRawData[strColDate]), CI).ToShortDateString();
                                                        strTime = DateTime.Parse(Convert.ToString(drRdbmsRawData[strColTime]), CI).ToLongTimeString();
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    try
                                    {
                                        if (drRdbmsRawData[strColCardNo] != DBNull.Value && drRdbmsRawData[strColReaderNo] != DBNull.Value && drRdbmsRawData[strColType] != DBNull.Value && strDate != string.Empty && strDate != "0" && strTime != string.Empty && strTime != "0")
                                        {
                                            string strType = string.Empty, strPunchType = string.Empty;
                                            strType = drRdbmsRawData[strColType].ToString();
                                            // BioStation
                                            if (strType == "0" || strType == "1" || strType == "2" || strType == "3" || strType == "4" || strType == "5" || strType == "6" || strType == "7" || strType == "8" || strType == "9" || strType == "10" || strType == "11" || strType == "12" || strType == "13" || strType == "14" || strType == "15")
                                            {
                                                strPunchType = strType;
                                            }
                                            else
                                            {
                                                // Other BioEntry Device
                                                strPunchType = drRdbmsRawData[strColReaderNo].ToString();
                                            }
                                            InsertRawDataDetails(Convert.ToString(drRdbmsRawData[strColCardNo]), Convert.ToString(drRdbmsRawData[strColReaderNo]), DateTime.Parse(strDate, CI).ToLongDateString(), DateTime.Parse(strTime, CI).ToLongTimeString(), strPunchType);
                                        }
                                        if (Convert.ToString(drRdbmsRawData["nIndex"]) != "")
                                        {
                                            if (dtRDBMSDetails.Rows[0]["MDB_DateTimeBit"] != DBNull.Value)
                                            {
                                                if (dtRDBMSDetails.Rows[0]["strSQLUpdate"] != DBNull.Value)
                                                {
                                                    strSQLUpdate = Convert.ToString(dtRDBMSDetails.Rows[0]["strSQLUpdate"]);
                                                    strSQLUpdate += drRdbmsRawData["nIndex"].ToString();
                                                    if (strSQLUpdate != "")
                                                    {
                                                        objDatafunction.InitializeRDBMSConnection(strConnectionString);
                                                        objDatafunction.rdbmsExecuteNonQuery(strSQLUpdate);
                                                    }
                                                }
                                            }
                                        }
                                        else
                                        {
                                            WriteErrorToEventLog("CollectRawData", "function : CollectMDBRawData(); nIndex field is missing in reportstable.Please create it.");
                                        }
                                    }
                                    catch (Exception ex)
                                    {
                                        WriteErrorToEventLog("CollectRawData", "CollectMDBRawData(); SwipeCardNo : " + drRdbmsRawData[strColCardNo].ToString() + "; ReaderNo : " + drRdbmsRawData[strColReaderNo].ToString() + "; Date : " + strDate + "; Time : " + strTime + "; Error : " + ex.ToString());
                                        throw ex;
                                    }
                                }
                            }
                            break;
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "CollectMDBRawData(); TerminalID : " + intTerminalID + "; FileType : " + inFileType + "; BrandName : " + strBrandName + "; Error : " + ex.ToString());
                throw ex;
            }
        }
        #endregion
        #region GetEquivalentDeviceId
        // **********************************************************************************************************************
        // Purpose :
        //     The GetEquivalentDeviceId Function is used to get the Equivalent InDeviceId for the OutDeviceId (or) to get the
        //     Equivalent OutDeviceId for the InDeviceId
        // Inputs  :
        //     inClk_DeviceId - DeviceID (or) ReaderID 
        //     inClk_Type     - Clock Type (I-In or O-Out)
        // Returns :
        //     If Equivalent DeviceId is Present, then
        //        Returns the DeviceId
        //     If Equivalent DeviceId is not Present, then
        //         Returns Null Value
        // **********************************************************************************************************************
        public string GetEquivalentDeviceId(string inClk_DeviceId, string inClk_Type)
        {
            DataTable dtDeviceId = new DataTable();
            string strDeviceId = string.Empty;
            int intDeviceCount = 0, intCount = 1;
            try
            {
                SqlParameter pmType = new SqlParameter("@Type", inClk_Type);
                SqlParameter[] pmetersEquivalent = { pmType };
                dtDeviceId = objDatafunction.GettingDatasetUsingParameter(pmetersEquivalent, "Proc_TA_GetEquivalentDeviceDetails");
                intDeviceCount = dtDeviceId.Rows.Count;
                foreach (DataRow drDeviceIds in dtDeviceId.Rows)
                {
                    if (drDeviceIds["Terminal_ReaderID"] != DBNull.Value)
                    {
                        if (strDeviceId == string.Empty)
                        {
                            if (dtDeviceId.Rows.Count > 1)
                            {
                                strDeviceId = Convert.ToString(drDeviceIds["Terminal_ReaderID"]) + "'";
                            }
                            else
                            {
                                strDeviceId = Convert.ToString(drDeviceIds["Terminal_ReaderID"]);
                            }
                        }
                        else
                        {
                            if (intCount == intDeviceCount)
                            {
                                strDeviceId = strDeviceId + ",'" + Convert.ToString(drDeviceIds["Terminal_ReaderID"]);
                            }
                            else
                            {
                                strDeviceId = strDeviceId + ",'" + Convert.ToString(drDeviceIds["Terminal_ReaderID"]) + "'";
                            }
                        }
                    }
                    intCount = intCount + 1;
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "GetEquivalentDeviceId ; DeviceID : " + inClk_DeviceId + "; Type : " + inClk_Type + "; Error : " + ex.ToString());
            }
            return (strDeviceId);
        }
        #endregion
        #region GetTotalHours
        public string GetTotalHours(TimeSpan tsDayHoursMins)
        {
            char splitChar = '.';
            string[] strSplitHours;
            string strHoursMinutes = string.Empty;
            try
            {
                strSplitHours = Convert.ToString(tsDayHoursMins).Split(splitChar);
                int intTotalHours = 0;
                if (strSplitHours.Length > 1)
                {
                    intTotalHours = Convert.ToInt32(strSplitHours[0]);
                    intTotalHours = intTotalHours * 24;
                }
                intTotalHours = intTotalHours + tsDayHoursMins.Hours;
                strHoursMinutes = intTotalHours.ToString("00") + ":" + tsDayHoursMins.Minutes.ToString("00");
            }
            catch (Exception ex)
            {
                throw ex;
                //WriteErrorToEventLog("CollectRawData", "GetTotalHours()" + "\r\n" + ex.Message);
            }
            return strHoursMinutes;
        }
        #endregion
        #region CheckForHoliday
        // Check whether the date is Holiday
        public int CheckForHoliday(DateTime dtmDate)
        {
            int intCount = 0;
            try
            {
                SqlParameter pmdtmDate = new SqlParameter("@dtmDate", dtmDate);
                SqlParameter[] pParams = { pmdtmDate };
                intCount = objDatafunction.GettingIntScalarValueUsingParameter(pParams, "Proc_TA_CheckForHolidayForCollect");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "CheckForHoliday ; Date : " + dtmDate + "; Error : " + ex.ToString());
                throw ex;
            }
            return (intCount);
        }
        #endregion
        #region UpdateProcessFlag
        public void UpdateProcessFlagFromPrevToNextDay(string inClk_EmpId, string inClockDate)
        {
            try
            {
                SqlParameter pminClk_EmpId = new SqlParameter("@inClk_EmpId", inClk_EmpId);
                SqlParameter pminClockDate = new SqlParameter("@inClockDate", inClockDate);
                SqlParameter[] pmetersUpdateFlag = { pminClk_EmpId, pminClockDate };
                objDatafunction.ExecuteQueryUsingParameter(pmetersUpdateFlag, "Proc_TA_UpdateProcessflag");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "UpdateProcessFlagFromPrevToNextDay(Clk_EmpId:" + inClk_EmpId + ";Date: " + inClockDate + ");Error : " + ex.ToString());
            }
        }
        #endregion
        #region UpdateManualNotation
        public void UpdateManualNotation(string inSwipeCardNo, string Clockdate, string StrType, string strClk_Status)
        {
            try
            {
                SqlParameter UpdateManualNotation_inSwipeCardNo = new SqlParameter("@inSwipeCardNo", inSwipeCardNo);
                SqlParameter UpdateManualNotation_Clockdate = new SqlParameter("@Clk_Date", Clockdate);
                SqlParameter UpdateManualNotation_strType = new SqlParameter("@StrType", StrType);
                SqlParameter UpdateManualNotation_strClk_Status = new SqlParameter("@strClk_Status", strClk_Status);
                SqlParameter[] pParams = { UpdateManualNotation_inSwipeCardNo, UpdateManualNotation_Clockdate, UpdateManualNotation_strType, UpdateManualNotation_strClk_Status };
                objDatafunction.ExecuteQueryUsingParameter(pParams, "Proc_Ta_UpdateManualNotation");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "UpdateManualNotation ; Date : " + Clockdate + "; Error : " + ex.ToString());
                throw ex;
            }
        }
        #endregion
        #region WriteErrorToEventLog
        public void WriteErrorToEventLog(string applicationName, string msg)
        {
            StackFrame CallStack = new StackFrame(1, true);
            int lineNumber = CallStack.GetFileLineNumber();
            string msg2 = CallStack.GetFileName() + "\r\n";           // This get calling module's file name and adds to event log.
            msg2 += "Line: " + lineNumber.ToString() + "\r\n";        // This get calling module's line number of call to this function.
            msg2 += msg;
            if (!EventLog.SourceExists("TC3.2.0CollectRawDataLogSource"))
            {
                EventLog.CreateEventSource("TC3.2.0CollectRawDataLogSource", "TC3.2.0CollectRawDataLog");
            }
            EventLog.WriteEntry("TC3.2.0CollectRawDataLogSource", msg2, EventLogEntryType.Error, lineNumber);
        }
        #endregion
        #region UpdateFlagInDeviceDatabase
        public void UpdateFlagInDeviceDatabase(string strTableName, string strColFlag, string nIndex)
        {
            try
            {
                OleDbParameter pmTableName = new OleDbParameter("@TableName", Convert.ToString(strTableName));
                OleDbParameter pmFlagName = new OleDbParameter("@FlagName", Convert.ToString(strColFlag));
                OleDbParameter pmnIndex = new OleDbParameter("@nIndex", Convert.ToString(nIndex));
                OleDbParameter[] pmetersUpdateFlag = { pmTableName, pmFlagName, pmnIndex };
                objDatafunction.ExecuteQueryUsingParameterRDBMS(pmetersUpdateFlag, "Proc_TA_UpdateFlagInDeviceDatabase");
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
        #endregion
        #region InsertRawDataDetails
        public void InsertRawDataDetails(string CLK_CARDID, string CLK_DEVICEID, string CLK_DATE, string CLK_TIME, string CLK_TYPE)
        {
            try
            {
                SqlParameter pmCLK_CARDID = new SqlParameter("@CLK_CARDID", CLK_CARDID);
                SqlParameter pmCLK_DEVICEID = new SqlParameter("@CLK_DEVICEID", CLK_DEVICEID);
                SqlParameter pmCLK_DATE = new SqlParameter("@CLK_DATE", CLK_DATE);
                SqlParameter pmCLK_TIME = new SqlParameter("@CLK_TIME", CLK_TIME);
                SqlParameter pmCLK_TYPE = new SqlParameter("@CLK_TYPE", CLK_TYPE);
                SqlParameter[] pmetersRawData = { pmCLK_CARDID, pmCLK_DEVICEID, pmCLK_DATE, pmCLK_TIME, pmCLK_TYPE };
                objDatafunction.ExecuteQueryUsingParameter(pmetersRawData, "Proc_TA_InsertRawDataDetails");
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
        #endregion
        #region InsertMariaLogsInToReportsList
        public void InsertMariaLogsInToReportsList(string DEVDT, string USRID, string TNAKEY, string DEVUID, string EVT)
        {
            try
            {
                SqlParameter pmCLK_CARDID = new SqlParameter("@cDate", DEVDT);
                SqlParameter pmCLK_DEVICEID = new SqlParameter("@CLK_ID", USRID);
                SqlParameter pmCLK_DATE = new SqlParameter("@IO", TNAKEY);
                SqlParameter pmCLK_TIME = new SqlParameter("@nReaderIdn", DEVUID);
                SqlParameter pmCLK_TYPE = new SqlParameter("@nEventIdn", EVT);
                SqlParameter[] pmetersRawData = { pmCLK_CARDID, pmCLK_DEVICEID, pmCLK_DATE, pmCLK_TIME, pmCLK_TYPE };
                objDatafunction.ExecuteQueryUsingParameter(pmetersRawData, "InsertMariaLogsInToReportsList");
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
        #endregion
        #region UpdateShiftInPermenent
        public void UpdateShiftInPermenent(string Employee_Code_Id, string Date, int Shift_Id)
        {
            try
            {
                SqlParameter pmEmployee_Code_Id = new SqlParameter("@EmployeeCodeId", Employee_Code_Id);
                SqlParameter pmDate = new SqlParameter("@ShiftDate", Date);
                SqlParameter pmShift_Id = new SqlParameter("@Shift_Id", Shift_Id);
                SqlParameter[] pmetersProcessedData = { pmEmployee_Code_Id, pmDate, pmShift_Id };
                objDatafunction.ExecuteQueryUsingParameter(pmetersProcessedData, "Proc_TA_UpdateShiftinPermenentShiftAllocation");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "UpdateShiftInPermenent(SwipeCardNo: " + Employee_Code_Id + ";Date: " + Date + ";Shift_Id: " + Shift_Id + ");Error: " + ex.ToString());
            }
        }
        #endregion
        #region GetClockDateForAutoShiftEmployee
        public string GetClockDateForAutoShiftEmployee(string SwipeCardNo, string inClk_Date, string inClk_Time, int companyId)
        {
            string strclockdate = string.Empty;
            try
            {
                SqlParameter pmSwipeCardNo = new SqlParameter("@SwipeCardNo", SwipeCardNo);
                SqlParameter pmDate = new SqlParameter("@inClk_Date", inClk_Date);
                SqlParameter pmtime = new SqlParameter("@inClk_Time", inClk_Time);
                SqlParameter pmCompanyId = new SqlParameter("@CompanyId", companyId);
                SqlParameter[] pmetersProcessedData = { pmSwipeCardNo, pmDate, pmtime, pmCompanyId };
                strclockdate = Convert.ToString(objDatafunction.GettingScalarValueUsingParameter(pmetersProcessedData, "Proc_TA_GetClockDateForAutoShiftEmployee"));
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "Proc_TA_GetClockDateForAutoShiftEmployee(SwipeCardNo: " + SwipeCardNo + ";Date: " + inClk_Date + ";inClk_Time: " + inClk_Time + ");Error: " + ex.ToString());
            }
            return strclockdate;
        }
        #endregion
        #region CMITech
        public void getIrisDeviceLogs(int logID)
        {
            DataTable dtTerminal = new DataTable();
            try
            {
                m_clients = new Dictionary<string, Client>();
                m_selectedDevice = "";
                string TerminalID = "";
                SqlParameter pmType = new SqlParameter("@Type", "A");
                SqlParameter pmTerminalID = new SqlParameter("@TerminalID", 0);
                SqlParameter pmUserGroupName = new SqlParameter("@UserGroupName", "SuperAdmin");
                SqlParameter[] pmetersEquivalent = { pmType, pmTerminalID, pmUserGroupName };
                dtTerminal = objDatafunction.GettingDatasetUsingParameter(pmetersEquivalent, "Proc_TA_SelectTerminalDetails");
                foreach (DataRow dr in dtTerminal.Rows)
                {
                    m_selectedDevice = Convert.ToString(dr["Terminal_Description"]);
                    TerminalID = Convert.ToString(dr["Terminal_ReaderID"]);
                    string[] isValidIPAddress = m_selectedDevice.Split('.');
                    if (isValidIPAddress.Length < 3)
                    {
                        continue;
                    }
                    connectUmx();
                    if (!string.IsNullOrEmpty(m_selectedDevice))
                    {
                        if (m_clients[m_selectedDevice] != null && m_clients[m_selectedDevice].IsConnected())
                        {
                            try
                            {
                                List<Log> logs = m_clients[m_selectedDevice].GetLogs(logID);
                                if (logs != null)
                                {
                                    DataTable dtlogs = new DataTable();
                                    dtlogs.TableName = "IrisLog_Table";
                                    dtlogs.Columns.Add("AdditionalData", typeof(string));
                                    dtlogs.Columns.Add("EventType", typeof(string));
                                    dtlogs.Columns.Add("Info", typeof(string));
                                    dtlogs.Columns.Add("LogUID", typeof(int));
                                    dtlogs.Columns.Add("SubjectUID", typeof(string));
                                    dtlogs.Columns.Add("Timestamp", typeof(DateTime));
                                    foreach (Log log in logs)
                                    {
                                        if (log.AdditionalData != null && log.AdditionalData != "" &&
                                            log.EventType != null && log.EventType != "" &&
                                            log.Info != null && log.Info != "" &&
                                            log.LogUID != 0 &&
                                            log.SubjectUID != null && log.SubjectUID != "" &&
                                            log.Timestamp != null
                                            )
                                        {
                                            if (log.AdditionalData == "Allowed" && log.EventType == "Recognition")
                                                dtlogs.Rows.Add(log.AdditionalData, log.EventType, log.Info, log.LogUID, log.SubjectUID, log.Timestamp);
                                        }
                                    }
                                    if (dtlogs.Rows.Count > 0)
                                    {
                                        StringWriter swLeaveData = new StringWriter();
                                        dtlogs.WriteXml(swLeaveData);
                                        string strDevicelogs = Convert.ToString(swLeaveData);
                                        InsertIrisLogsToTimecheck(strDevicelogs, m_selectedDevice, TerminalID);
                                    }
                                    else
                                    {
                                        WriteErrorToEventLog("CollectRawData", "[Error] " + DateTime.Now + " Fail to get logs");
                                    }
                                }
                                else
                                    WriteErrorToEventLog("CollectRawData", "[Error] " + DateTime.Now + " Fail to get logs");
                            }
                            catch (DeviceNotFoundException ex)
                            {
                                WriteErrorToEventLog("CollectRawData", "[Error] " + DateTime.Now + " " + ex.Message);
                            }
                            catch (Exception ex)
                            {
                                WriteErrorToEventLog("CollectRawData", "[Error] :" + ex.Message);
                            }
                        }
                        else
                        {
                            WriteErrorToEventLog("CollectRawData", "[Warning] " + DateTime.Now + " Not connected to a device.");
                        }
                    }
                }
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "ToCheckTerminalAndPunchTypesExists()" + "\r\n" + ex.Message);
            }
        }
        public void InsertIrisLogsToTimecheck(string deviceLogs, string ipAddress, string TerminalID)
        {
            try
            {
                SqlParameter pmdvLogs = new SqlParameter("@LogData", deviceLogs);
                SqlParameter pmipAddress = new SqlParameter("@ipAddress", ipAddress);
                SqlParameter pmTerminalID = new SqlParameter("@TerminalID", TerminalID);
                SqlParameter[] pmetersUpdateRawData = { pmdvLogs, pmipAddress, pmTerminalID };
                objDatafunction.ExecuteQueryUsingParameter(pmetersUpdateRawData, "InsertIrisLogsFromDevice");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "UpdateRawDataFlag()" + "\r\n" + ex.Message);
            }
        }
        private string initClient(ref Client client)
        {
            string ipAddress = m_selectedDevice;
            string serialNumber = "";
            bool checkSerialEnabled = false;
            client = new Client(ipAddress, serialNumber, checkSerialEnabled);
            return serialNumber;
        }
        private void connectUmx(bool forceConnect = false)
        {
            // Init client for connect
            Client client = null;
            string serialNumber = initClient(ref client);
#if true // Try to connect
            bool connectOk = false;
            try
            {
                if (forceConnect) connectOk = client.StealConnect(/*false, false, true, 5000*/);
                else connectOk = client.Connect(/*false, false, true, 5000*/);
            }
            catch (DeviceNotFoundException ex)
            {
                WriteErrorToEventLog("CollectRawData", "connectUmx()" + "\r\n" + ex.Message);
            }
            catch (InvalidSerialNumberException ex)
            {
                WriteErrorToEventLog("CollectRawData", "connectUmx()" + "\r\n" + ex.Message);
            }
#endif
            // After trying to connect
            if (connectOk)
            {
                m_clients.Add(m_selectedDevice, client);
            }
            else if (forceConnect)
            {
                WriteErrorToEventLog("CollectRawData", "[Error] " + DateTime.Now + " Error forcing connection to device.");
            }
            else
            {
                connectUmx(true);
            }
        }
        public static DataTable ToDataTable<T>(List<T> items)
        {
            DataTable dataTable = new DataTable(typeof(T).Name);
            //Get all the properties
            PropertyInfo[] Props = typeof(T).GetProperties(BindingFlags.Public | BindingFlags.Instance);
            foreach (PropertyInfo prop in Props)
            {
                //Defining type of data column gives proper data table 
                var type = (prop.PropertyType.IsGenericType && prop.PropertyType.GetGenericTypeDefinition() == typeof(Nullable<>) ? Nullable.GetUnderlyingType(prop.PropertyType) : prop.PropertyType);
                //Setting column names as Property names
                dataTable.Columns.Add(prop.Name, type);
            }
            foreach (T item in items)
            {
                var values = new object[Props.Length];
                for (int i = 0; i < Props.Length; i++)
                {
                    //inserting property values to datatable rows
                    values[i] = Props[i].GetValue(item, null);
                }
                dataTable.Rows.Add(values);
            }
            //put a breakpoint here and check datatable
            return dataTable;
        }
        #endregion
        #region InsertDeviceLogDetails
        public void InsertDeviceLogDetails(string tblName, double lastLogID)
        {
            try
            {
                SqlParameter pmtblName = new SqlParameter("@TblName", tblName);
                SqlParameter pmlastLogID = new SqlParameter("@LastLogID", lastLogID);
                SqlParameter[] pmetersRawData = { pmtblName, pmlastLogID };
                objDatafunction.ExecuteQueryUsingParameter(pmetersRawData, "Proc_Ta_InsertAndUpdateDeviceLogTableDetails");
            }
            catch (Exception ex)
            {
                throw ex;
            }
        }
        #endregion
        #region GetDeviceLogTableDetails
        public DataTable GetDeviceLogTableDetails(string logTableName)
        {
            DataTable dtDeviceLog = new DataTable();
            try
            {
                SqlParameter pmFileType = new SqlParameter("@DeviceLog_TableName", logTableName);
                SqlParameter[] pmetersRDBMS = { pmFileType };
                dtDeviceLog = objDatafunction.GettingDatasetUsingParameter(pmetersRDBMS, "Proc_TA_GetDeviceLogTableDetails");
            }
            catch (Exception ex)
            {
                WriteErrorToEventLog("CollectRawData", "Proc_TA_GetDeviceLogTableDetails()" + "\r\n" + ex.Message);
            }
            return dtDeviceLog;
        }
        #endregion
        #region InsertLogToRawDataTable
        private void InsertLogToRawDataTable(DataTable dtRDBMSDetails, DataTable dtRdbmsRawData, string strColReaderNo, string strColCardNo, string strColDateTime, string strColDate, string strColTime, string strColType)
        {
            #region Processing1000Records
            DateTime dtmDateTime = new DateTime();
            string strDate = string.Empty, strTime = string.Empty;
            foreach (DataRow drRdbmsRawData in dtRdbmsRawData.Rows)
            {
                string strSQLInsert = string.Empty, strSQLUpdate = string.Empty, strSQLCheckEmployee = string.Empty;
                if ((drRdbmsRawData[strColReaderNo] != DBNull.Value) && (drRdbmsRawData[strColCardNo] != DBNull.Value) && (drRdbmsRawData[strColType] != DBNull.Value) && (Convert.ToString(drRdbmsRawData[strColReaderNo]) != string.Empty) && (Convert.ToString(drRdbmsRawData[strColCardNo]) != string.Empty) && (Convert.ToString(drRdbmsRawData[strColType]) != string.Empty))
                {
                    if (dtRDBMSDetails.Rows[0]["RDBMS_DateTimeBit"] != DBNull.Value)
                    {
                        if (Convert.ToString(dtRDBMSDetails.Rows[0]["RDBMS_DateTimeBit"]) == "True")
                        {
                            if (drRdbmsRawData[strColDateTime] != DBNull.Value && Convert.ToString(drRdbmsRawData[strColDateTime]) != string.Empty && Convert.ToString(drRdbmsRawData[strColDateTime]) != "0")
                            {
                                dtmDateTime = DateTime.Parse(Convert.ToString(drRdbmsRawData[strColDateTime]), CI);
                                strDate = dtmDateTime.ToShortDateString();
                                strTime = dtmDateTime.ToShortTimeString();
                            }
                        }
                        else if (Convert.ToString(dtRDBMSDetails.Rows[0]["RDBMS_DateTimeBit"]) == "False")
                        {
                            if ((drRdbmsRawData[strColDate] != DBNull.Value) && (drRdbmsRawData[strColTime] != DBNull.Value) && (Convert.ToString(drRdbmsRawData[strColDate]) != string.Empty) && (Convert.ToString(drRdbmsRawData[strColTime]) != string.Empty) && (Convert.ToString(drRdbmsRawData[strColDate]) != "0") && (Convert.ToString(drRdbmsRawData[strColTime]) != "0"))
                            {
                                if (dtRDBMSDetails.Rows[0]["IsEncrypted"] != DBNull.Value)
                                {
                                    if (Convert.ToString(dtRDBMSDetails.Rows[0]["IsEncrypted"]) == "True")
                                    {
                                        strDate = DecryptDateTime(int.Parse(Convert.ToString(drRdbmsRawData[strColDate])), "D");
                                        strTime = DecryptDateTime(int.Parse(Convert.ToString(drRdbmsRawData[strColTime])), "T");
                                    }
                                    else
                                    {
                                        strDate = DateTime.Parse(Convert.ToString(drRdbmsRawData[strColDate]), CI).ToShortDateString();
                                        strTime = DateTime.Parse(Convert.ToString(drRdbmsRawData[strColTime]), CI).ToLongTimeString();
                                    }
                                }
                            }
                        }
                    }
                    string strType = string.Empty, strPunchType = string.Empty;
                    try
                    {
                        #region InsertRawData
                        if (drRdbmsRawData[strColCardNo] != DBNull.Value && drRdbmsRawData[strColReaderNo] != DBNull.Value && drRdbmsRawData[strColType] != DBNull.Value && strDate != string.Empty && strDate != "0" && strTime != string.Empty && strTime != "0")
                        {
                            strType = Convert.ToString(drRdbmsRawData[strColType]);
                            // BioStation
                            switch (strType)
                            {
                                case "0":
                                case "1":
                                case "2":
                                case "3":
                                case "4":
                                case "5":
                                case "6":
                                case "7":
                                case "8":
                                case "9":
                                case "10":
                                case "11":
                                case "12":
                                case "13":
                                case "14":
                                case "15":
                                    strPunchType = strType;
                                    break;
                                default:
                                    strPunchType = Convert.ToString(drRdbmsRawData[strColReaderNo]);
                                    break;
                            }
                            InsertRawDataDetails(Convert.ToString(drRdbmsRawData[strColCardNo]),
                                Convert.ToString(drRdbmsRawData[strColReaderNo]),
                                Convert.ToString(DateTime.Parse(strDate, CI)),
                                Convert.ToString(strTime),
                                Convert.ToString(strPunchType));
                        }
                        #endregion
                    }
                    catch (Exception ex)
                    {
                        WriteErrorToEventLog("CollectRawData", "CollectRBMSRawData(); SwipeCardNo : " + drRdbmsRawData[strColCardNo].ToString() + "; ReaderNo : " + drRdbmsRawData[strColReaderNo].ToString() + "; Date : " + strDate + "; Time : " + strTime + "; Punch Type : " + strPunchType + "; Error : " + ex.ToString());
                        throw ex;
                    }
                }
            }
            #endregion
        }
        #endregion
        #region InsertLogToRawDataTable_WithOutPunchTypes
        private void InsertLogToRawDataTable_WithOutPunchTypes(DataTable dtRDBMSDetails, DataTable dtRdbmsRawData, string strColReaderNo, string strColCardNo, string strColDateTime, string strColDate, string strColTime)
        {
            #region Processing1000Records
            DateTime dtmDateTime = new DateTime();
            string strDate = string.Empty, strTime = string.Empty;
            foreach (DataRow drRdbmsRawData in dtRdbmsRawData.Rows)
            {
                string strSQLInsert = string.Empty, strSQLUpdate = string.Empty, strSQLCheckEmployee = string.Empty;
                if ((drRdbmsRawData[strColReaderNo] != DBNull.Value) && (drRdbmsRawData[strColCardNo] != DBNull.Value) && (Convert.ToString(drRdbmsRawData[strColReaderNo]) != string.Empty) && (Convert.ToString(drRdbmsRawData[strColCardNo]) != string.Empty))
                {
                    if (dtRDBMSDetails.Rows[0]["RDBMS_DateTimeBit"] != DBNull.Value)
                    {
                        if (Convert.ToString(dtRDBMSDetails.Rows[0]["RDBMS_DateTimeBit"]) == "True")
                        {
                            if (drRdbmsRawData[strColDateTime] != DBNull.Value && Convert.ToString(drRdbmsRawData[strColDateTime]) != string.Empty && Convert.ToString(drRdbmsRawData[strColDateTime]) != "0")
                            {
                                dtmDateTime = DateTime.Parse(Convert.ToString(drRdbmsRawData[strColDateTime]), CI);
                                strDate = dtmDateTime.ToShortDateString();
                                strTime = dtmDateTime.ToShortTimeString();
                            }
                        }
                        else if (Convert.ToString(dtRDBMSDetails.Rows[0]["RDBMS_DateTimeBit"]) == "False")
                        {
                            if ((drRdbmsRawData[strColDate] != DBNull.Value) && (drRdbmsRawData[strColTime] != DBNull.Value) && (Convert.ToString(drRdbmsRawData[strColDate]) != string.Empty) && (Convert.ToString(drRdbmsRawData[strColTime]) != string.Empty) && (Convert.ToString(drRdbmsRawData[strColDate]) != "0") && (Convert.ToString(drRdbmsRawData[strColTime]) != "0"))
                            {
                                if (dtRDBMSDetails.Rows[0]["IsEncrypted"] != DBNull.Value)
                                {
                                    if (Convert.ToString(dtRDBMSDetails.Rows[0]["IsEncrypted"]) == "True")
                                    {
                                        strDate = DecryptDateTime(int.Parse(Convert.ToString(drRdbmsRawData[strColDate])), "D");
                                        strTime = DecryptDateTime(int.Parse(Convert.ToString(drRdbmsRawData[strColTime])), "T");
                                    }
                                    else
                                    {
                                        strDate = DateTime.Parse(Convert.ToString(drRdbmsRawData[strColDate]), CI).ToShortDateString();
                                        strTime = DateTime.Parse(Convert.ToString(drRdbmsRawData[strColTime]), CI).ToLongTimeString();
                                    }
                                }
                            }
                        }
                    }
                    string strType = string.Empty, strPunchType = string.Empty;
                    try
                    {
                        #region InsertRawData
                        if (drRdbmsRawData[strColCardNo] != DBNull.Value && drRdbmsRawData[strColReaderNo] != DBNull.Value && strDate != string.Empty && strDate != "0" && strTime != string.Empty && strTime != "0")
                        {
                            strPunchType = Convert.ToString(drRdbmsRawData[strColReaderNo]);
                            InsertRawDataDetails(Convert.ToString(drRdbmsRawData[strColCardNo]),
                                Convert.ToString(drRdbmsRawData[strColReaderNo]),
                                Convert.ToString(DateTime.Parse(strDate, CI)),
                                Convert.ToString(strTime),
                                Convert.ToString(strPunchType));
                        }
                        #endregion
                    }
                    catch (Exception ex)
                    {
                        WriteErrorToEventLog("CollectRawData", "CollectRBMSRawData(); SwipeCardNo : " + drRdbmsRawData[strColCardNo].ToString() + "; ReaderNo : " + drRdbmsRawData[strColReaderNo].ToString() + "; Date : " + strDate + "; Time : " + strTime + "; Punch Type : " + strPunchType + "; Error : " + ex.ToString());
                        throw ex;
                    }
                }
            }
            #endregion
        }
        #endregion
    }
}
